2000-10-11  Dave Love  <fx@gnu.org>

	* toolbar/cancel.xpm, toolbar/jump_to.xpm, toolbar/right_arrow.xpm:
	* toolbar/close.xpm, toolbar/left_arrow.xpm, toolbar/save.xpm:
	* toolbar/copy.xpm, toolbar/mail.xpm, toolbar/saveas.xpm:
	* toolbar/cut.xpm, toolbar/mail_compose.xpm:
	* toolbar/search-replace.xpm, toolbar/exit.xpm:
	* toolbar/mail_send.xpm, toolbar/search.xpm, toolbar/fld_open.xpm:
	* toolbar/new.xpm, toolbar/spell.xpm, toolbar/help.xpm:
	* toolbar/open.xpm, toolbar/undo.xpm, toolbar/home.xpm:
	* toolbar/paste.xpm, toolbar/up_arrow.xpm, toolbar/index.xpm:
	* toolbar/preferences.xpm, toolbar/info.xpm, toolbar/print.xpm:
	Reduce colour requirements to 25 overall.  (Probably wants
	revisiting from the originals to reduce further.)

2000-10-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* hexl.el (hexlify-buffer): Bind coding-system-for-write to
	buffer-file-coding-system, instead of raw-text.
	(dehexlify-buffer): Bind coding-system-for-read to
	buffer-file-coding-system, instead of raw-text.

2000-10-11  Sam Steingold  <sds@gnu.org>

	* progmodes/cperl-mode.el (cperl-invalid-face): double-quote
	`underline' - fixes the bug introduced on 2000-09-21.

2000-10-11  Dave Love  <fx@gnu.org>

	* progmodes/scheme.el (scheme-mode-variables, dsssl-mode): Avoid
	compiler warnings.
	(scheme-mode): Doc fix.
	(scheme-font-lock-keywords-1): Match `define-syntax'.

2000-10-11  Miles Bader  <miles@lsi.nec.co.jp>

	* faces.el (frame-set-background-mode): Pay attention to saved
	face specs as well as default ones.  Only do anything if the
	bg-mode or display-type has actually changed.  Use `dolist'.
	(region): Make dark-background `region' face less in-your-face.

2000-10-10  Sam Steingold  <sds@gnu.org>

	* chistory.el, ielm.el, ledit.el:
	* progmodes/inf-lisp.el, progmodes/scheme.el:
	Use `lisp-mode-shared-map' instead of `shared-lisp-mode-map'.

2000-10-10  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/texinfo.el: Update copyright and fix typo.

	* desktop.el (desktop-modes-not-to-save): New var.
	(desktop-save-buffer-p): Use it.
	Also, obey desktop-buffers-not-to-save even for non-file buffers.
	(desktop-buffer-file): Use pop-to-buffer if switch-to-buffer fails.

2000-10-10  Dave Love  <fx@gnu.org>

	* toolbar/tool-bar.el (tool-bar-add-item)
	(tool-bar-add-item-from-menu): Don't favour XPM icons on mono
	display.

	* startup.el (command-line): Don't require XPM support for toolbar.

	* toolbar/attach.pbm, toolbar/cancel.pbm, toolbar/close.pbm:
	* toolbar/copy.pbm, toolbar/cut.pbm, toolbar/exit.pbm:
	* toolbar/fld_open.pbm, toolbar/help.pbm, toolbar/home.pbm:
	* toolbar/index.pbm, toolbar/info.pbm, toolbar/jump_to.pbm:
	* toolbar/left_arrow.pbm, toolbar/mail.pbm, toolbar/mail_compose.pbm:
	* toolbar/mail_send.pbm, toolbar/new.pbm, toolbar/open.pbm:
	* toolbar/paste.pbm, toolbar/preferences.pbm, toolbar/print.pbm:
	* toolbar/right_arrow.pbm, toolbar/save.pbm, toolbar/saveas.pbm:
	* toolbar/search-replace.pbm, toolbar/search.pbm, toolbar/spell.pbm:
	* toolbar/undo.pbm, toolbar/up_arrow.pbm: New files straight from
	the .xpms; probably need retouching.

2000-10-10  Miles Bader  <miles@lsi.nec.co.jp>

	* subr.el (add-to-list): Add optional argument APPEND.
	* battery.el (display-battery): Use `add-to-list'.

2000-10-09  Thien-Thi Nguyen  <ttn@gnu.org>

	* play/zone.el (zone-timer, zone-wc-tbl): Rework
	these vars as symbol properties.
	(zone, zone-when-idle, zone-leave-me-alone)
	(zone-pgm-whack-chars): Use new symbol properties.

	* battery.el (display-battery): Doc spelling fix.

	* vc.el (with-vc-file, edit-vc-file): Specify `indent-function'
	property.

2000-10-09  Dave Love  <fx@gnu.org>

	* toolbar/tool-bar.el (tool-bar-mode): Check whether tool-bar-map
	has been initialized before calling tool-bar-setup.
	(tool-bar-add-item-from-menu): Add autoload cookie.

2000-10-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el (send-mail-item-name): New function.
	(menu-bar-tools-menu) <compose-mail>: Use it to display the value
	of mail-user-agent in the menu.  Don't display the "Send Mail"
	item if mail-user-agent is nil or its value is ignore.
	(menu-bar-tools-menu) <rmail>: Don't display the "Read Mail" item
	if read-mail-command is nil or its value is ignore.

	* mouse.el ([header-line mouse-1]): Bind to mouse-select-window.

2000-10-09  Miles Bader  <miles@gnu.org>

	* toolbar/up_arrow.xpm: Flip to put highlight in correct place.
	Correct image size.
	* toolbar/left_arrow.xpm: Correct image size.

	* jka-compr.el: Don't call `jka-compr-install' when loading (it
	will be done by the definition of `auto-compression-mode' if
	necessary.  Move code to uninstall existing file-name handler
	before definition of `auto-compression-mode'.

	* image-file.el (auto-image-file-mode): Move to the end of the
	file, because `define-minor-mode' actually calls the mode-function
	if the associated variable is non-nil, which requires that all
	needed functions be already defined.

	* mouse.el (popup-menu): Balance parens.

2000-10-08  Stefan Monnier  <monnier@cs.yale.edu>

	* mouse.el (popup-menu): Move the command call outside the loop
	so that popup-menu returns whatever the command returns.

	* progmodes/etags.el: Docstring fixes.  Maintainer line updated.
	(initialize-new-tags-table): Use run-hook-with-args-until-success.
	(find-tag): Use pop-to-buffer if switch-to-buffer failed.
	(tags-table-format-functions): Renamed from tags-table-format-hooks.

	* vc.el (vc-version-diff): diff-switches can be a list.
	Use relative filenames for prettier output.

	* pcvs.el (cvs-append-to-ignore, cvs-vc-command-advice)
	(vc-post-command-functions): Remove old-VC compatibility code.

	* newcomment.el (comment-indent-default): Autoload.

	* font-lock.el (font-lock-defaults): Make buffer-local.
	(font-lock-turn-on-thing-lock): Use jit-lock-refontify.
	(font-lock-choose-keywords):
	Ignore LEVEL unless KEYWORDS is a list of syms.
	(c-keywords, c++-keywords, objc-keywords, java-keywords):
	Don't wrap regexp-opt things in \(...\) unnecessarily.

	* jit-lock.el: Don't require font-lock any more.
	(jit-lock-functions): Make buffer-local.
	(jit-lock-saved-fontify-buffer-function): Remove.
	(jit-lock-mode): Remove autoload cookie.
	Remove font-lock specific code.
	(jit-lock-unregister): Don't bother handling complex hooks any more.
	(jit-lock-refontify): New function.
	(jit-lock-fontify-buffer): Use it.
	(jit-lock-function-1): Replaced by jit-lock-fontify-now.
	(jit-lock-fontify-now): Renamed from jit-lock-function-1.
	Add optional args START and END.
	Never call font-lock-fontify-region directly.
	(jit-lock-function, jit-lock-stealth-fontify): Use it.

	* emacs-lisp/regexp-opt.el (regexp-opt): Add \<...\> if PAREN=`words'.

2000-10-08  Dave Love  <fx@gnu.org>

	* progmodes/ada-mode.el (ada-mode-menu): Add name to menu map.

	* progmodes/icon.el (icon-mode-map): Add name to menu-bar keymap.

	* play/studly.el (studlify-region, studlify-word): Add autoload
	cookie.

	* play/morse.el (morse-region, unmorse-region): Add autoload
	cookie.

	* play/spook.el (spook-phrases-file): Use expand-file-name, not
	concat.

	* emacs-lisp/lisp-mode.el (lisp-imenu-generic-expression): Don't
	insist on symbols starting with word syntax.
	(lisp-mode-shared-map): Renamed from shared-lisp-mode-map.
	(eval-defun-1): Doc fix.
	(indent-sexp): Use nconc to build up indent-stack.

	* mail/sendmail.el: Byte-compile-dynamic since it gets loaded by
	Gnus with little use.
	(mail-setup-hook): Add mail-abbrevs-setup to options.

	* recentf.el: Doc fixes.

	* vcursor.el (vcursor-cs-binding): Remove compatibility code.
	Clean up remainder.

	* timezone.el (timezone-parse-date): Doc fix.  Fix regexps for (5)
	without timezone and (8) with timezone to enforce some whitespace.
	Simplify code somewhat.

	* options.el (list-options): Doc that you should use customize.

	* iswitchb.el (iswitchb-mode): Add :require.

	* info.el (Info-goto-node, Info-menu): Doc fix.
	(Info-mode-menu): Bind beginning-of-buffer, Info-edit
	(info-tool-bar-map): New variable.
	(Info-mode): Use it.
	(Info-edit-map): Define all in defvar.
	(speedbar-attached-frame): Avoid compiler warning.

	* toolbar/tool-bar.el (tool-bar-map): Define it empty.
	(global-map): Bind [tool-bar] to a filtered map.
	(tool-bar-add-item): Remove MAP arg.  Allow PBM icons.
	(tool-bar-add-item-from-menu): Use tool-bar-map, not tb-map.
	Allow PBM icons.
	(tool-bar-setup): Adjust calls of tool-bar-add-item.

	* toolbar/index.xpm, toolbar/jump_to.xpm, toolbar/attach.xpm:
	* toolbar/up_arrow.xpm, toolbar/left_arrow.xpm, toolbar/home.xpm:
	* toolbar/right_arrow.xpm: New files.  Renamed from tigert's
	icons, except up_arrow, which is left-arrow rotated.

	* imenu.el (imenu-add-to-menubar): Fix last change.

2000-10-08  Peter Breton  <pbreton@ne.mediaone.net>

	* generic-x.el (rul-generic-mode): Remove eval-when-compile
	statements. Suggested by Stefan Monnier  <monnier@cs.yale.edu>.

2000-10-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/titdic-cnv.el (quail-cxterm-package-ext-info): Fix
	typos in doc strings.

	* font-lock.el (font-lock-mode, global-font-lock-mode): Mention in
	the doc strings how to customize Font Lock faces.

	* mouse.el (mouse-drag-mode-line-1): Fix an off-by-one error in
	computing growth when dragging the header line.

2000-10-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* simple.el (kill-line): Doc fix.

2000-10-08  Miles Bader  <miles@gnu.org>

	* faces.el (secondary-selection): Make foreground visible on tty.

	* jka-compr.el (auto-compression-mode): Move to the end of the
	file, because `define-minor-mode' actually calls the mode-function
	if the associated variable is non-nil, which requires that all
	needed functions be already defined.
	(with-auto-compression-mode): Add autoload cookie.

2000-10-07  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (find-backup-file-name) [ms-dos]: If support for long
	file names is not available, behave as if version-control were set
	to never.

2000-10-07  Dave Love  <fx@gnu.org>

	* net/browse-url.el (browse-url-gnome-moz-arguments): New option.
	(browse-url-gnome-moz): New function.
	(browse-url-browser-function): Use it.
	Suggested by Colin Walters <walters@cis.ohio-state.edu>.

2000-10-07  Stefan Monnier  <monnier@cs.yale.edu>

	* indent.el (tab-always-indent): New var.
	(indent-for-tab-command): Use it.

	* files.el (set-auto-mode): Ignore unknown -*- mode -*- rather than
	raise an error.  This way it can still default to a sane value.

	* startup.el (fancy-splash-screens): Use local rather than global map.
	Don't use `update-menu-bindings' any more.
	Get rid of assumptions about keymap representation.

2000-10-06  Dave Love  <fx@gnu.org>

	* textmodes/fill.el (sentence-end-double-space)
	(sentence-end-without-period):  Doc fix.
	(adaptive-fill-regexp): Purecopy.
	(unjustify-current-line): Use line-end-position.
	(fill-individual-paragraphs-prefix): Use line-beginning-position.

	* net/eudc-vars.el (eudc): Add :version, :link.

	* international/mule-conf.el (file-coding-system-alist): Use \', not $.

	* emacs-lisp/find-func.el (find-function-regexp): Remove spurion.
	Fix for define-minor-mode.
	(function-at-point): Alias to function-called-at-point.

	* custom.el (custom-declare-variable, custom-set-variables): Use mapc.

	* simple.el (backward-word): Doc fix.

	* image-file.el (image-file-name-regexp): image-file-regexps ->
	image-file-name-regexps.
	(image-file-name-extensions): Add pbm.

2000-10-06  Stefan Monnier  <monnier@cs.yale.edu>

	* smerge-mode.el (smerge-diff): Setup the buffer's default-directory
	and add filename to the names so that diff-mode can jump to source.

	* font-lock.el (font-lock-defaults-alist): Remove the TeX entries.
	(tex-font-lock-keywords, tex-font-lock-keywords-2)
	(tex-font-lock-keywords-1): Remove.
	(font-lock-turn-on-thing-lock): Use jit-lock-register.
	(font-lock-turn-off-thing-lock): Use jit-lock-unregister.
	(font-lock-default-fontify-region):
	Expand beg..end correctly when just following a multiline region.
	(font-lock-fontify-anchored-keywords):
	Include the anchor text as part of the multiline.

2000-10-06  Gerd Moellmann  <gerd@gnu.org>

	* loadup.el (toplevel): Load `loaddefs' before `help' because the
	latter needs the autoloaded define-minor-mode macro during the
	bootstrap.

	* startup.el (command-line): For now, activate tool-bar-mode only
	if XPM images are supported.

	* mouse.el (mouse-drag-header-line): Don't allow resizing a
	window by dragging a header-line at the top of the frame; that's
	confusing because the header-line doesn't move.
	(mouse-drag-mode-line-1): Use event-* and posn-* functions instead
	of treating the event as a list.  Some cleanup.

2000-10-06  Miles Bader  <miles@gnu.org>

	* simple.el (display-message-or-buffer): New function.
	(shell-command-on-region): Use `display-message-or-buffer'.

	* emacs-lisp/easy-mmode.el (define-derived-mode): Tweak generated
	docstring parts.

	* net/net-utils.el (nslookup-prompt-regexp, ftp-prompt-regexp)
	(smbclient-prompt-regexp): Add usage note to doc string.
	(ftp-font-lock-keywords, smbclient-font-lock-keywords): Removed.
	(ftp-mode, smbclient-mode): Don't set `font-lock-defaults'.
	Use add-hook for adding the comint filter function, and only do so
	if it's not already in the global hook list.
	(ftp-mode, smbclient-mode, nslookup-mode): Remove redundant calls
	to `make-local-variable'.
	(nslookup-font-lock-keywords): Remove prompt entry.
	(nslookup): Don't set the process-filter.
	(finger): Exit the loop correctly when the regexps list runs out.
	(ftp, smbclient, smbclient-list-shares):
	Set the real major mode immediately, not after execing.
	Use `pop-to-buffer' instead of `switch-to-buffer-other-window'.

	* comint.el (comint-watch-for-password-prompt): Use STRING as a prompt.

2000-10-05  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/compile.el (compile-collect-regexps): Use dolist and push.

	* which-func.el (which-func-format): Remove spurious space.
	(which-func-mode): Don't make it permanent-local.
	(which-func-ff-hook): Allow which-func-maxout to be nil.
	(which-func-update): Simplify a bit.  Only run if which-func-mode is t.
	(which-func-mode): Simplify.
	Use post-command-idle-hook rather than post-command-hook.
	Go through all buffers and update their state.
	(which-function): Also try add-log-current-defun-function.

	* vc.el (with-vc-properties): Use conses rather than length-2 lists.
	(vc-checkout, vc-finish-steal, vc-checkin, vc-revert-file):
	Update call to with-vc-properties accordingly.
	(vc-comment-search-reverse, vc-comment-search-forward): Docstring fix.
	(vc-revert-buffer): More careful about window selection and deletion.
	(vc-switch-backend): Slight reorg to avoid calling `registered' twice.

	* pcvs.el (cvs-ediff-exit-hook): Expect delete-window to fail.
	(cvs-retrieve-revision): Reuse a pre-existing buffer.
	(cvs-dired-action): Change the default to quickdir.

	* newcomment.el (comment-indent): Delegate to indent-according-to-mode
	if comment-indent-function returns nil.
	(comment-indent-default): New function.
	(comment-indent-function): Use it and document the new semantics.

	* image-file.el: Docstring fixes.

	* help.el (help-xref-on-pp): Use match-string.
	(describe-variable): New arg BUFFER.
	Store the current buffer in the help-xref-stack.
	(temp-buffer-resize-mode): Use define-minor-mode.

	* jit-lock.el (jit-lock-mode): Use jit-lock-defer-contextually
	consistently with its docstring.
	Set jit-lock-first-unfontify-pos in an idempotent way.
	(jit-lock-register): Autoload and add arg CONTEXTUAL.

2000-10-05  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-mysql-options): New variable.
	(sql-mysql): Use it.

2000-10-05  Miles Bader  <miles@lsi.nec.co.jp>

	* image.el (image): New group.

	* smerge-mode.el (smerge-mine-face, smerge-other-face)
	(smerge-base-face, smerge-markers-face): Add dark-background variants.

2000-10-04  Peter Breton  <pbreton@ne.mediaone.net>

	* net/net-utils.el (nslookup-font-lock-keywords)
	(ftp-font-lock-keywords, smbclient-font-lock-keywords):
	Ignore the value of wqindow-system; always define keywords

2000-10-05  Kenichi Handa  <handa@etl.go.jp>

	* startup.el (fancy-splash-screens): Remove the code for
	debugging; `(trace-to-stderr "EXITTT\n")'.

2000-10-05  Miles Bader  <miles@gnu.org>

	* diff-mode.el (diff-goto-source): Update call to
	`diff-hunk-status-msg' to reflect new REV variable.

2000-10-04  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/icon.el (icon-mode):
	Don't gratuitously override the default for comment-column.

	* vc-hooks.el (vc-mode-line): Fix interactive spec.

	* jit-lock.el (with-buffer-unmodified): Use unwind-protect.
	(jit-lock-mode): Make sure font-lock-keywords-only is bound before use.
	(jit-lock-functions): New var.
	(jit-lock-function-1): Use it if non-nil.
	Don't switch the syntax-table.  Don't set parse-sexp-lookup-properties.
	Set the `fontified' property before doing the fontification to avoid
	repeatedly going through the same error.
	Don't turn errors into messages.
	(jit-lock-register, jit-lock-unregister): New functions.

	* dired.el (dired-mark-pop-up): Turn comment into docstring.
	Use with-current-buffer.

	* dired-aux.el (dired-do-create-files, dired-kill-tree):
	Turn comment into docstring.

	* apropos.el (apropos-mode): Use define-derived-mode.

2000-10-04  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (fancy-splash-pending-command): New variable.
	(fancy-splash-pre-command): New function.
	(fancy-splash-screens): Rewritten.
	(command-line-1): If fancy-splash-pending-command is set, call it
	interactively.

2000-10-04  Dave Love  <fx@gnu.org>

	* toolbar/tool-bar.el (tool-bar-setup): New function.
	(tool-bar-mode): Use it.

	* subr.el (substitute-key-definition): Doc fix.
	(play-sound-file): New command.

2000-10-04  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-before-save, vc-default-make-version-backups,
	vc-version-backup-file-name): New functions.

	* files.el (basic-save-buffer): Call vc-before-save before saving.

	* vc-cvs.el (vc-cvs-make-version-backups): Return t if
	vc-cvs-stay-local-p.

	* vc.el (vc-revert-buffer): Handle empty diff properly.
	(vc-version-backup-file): New function.
	(vc-checkout): Create a version backup if necessary.
	(vc-checkin): If a version backup file exists, delete it.
	(vc-version-diff): Diff locally using version backups, if available.
	(vc-revert-file): If there's a version backup, revert locally.
	(vc-transfer-file): Use version backup for base version, if
	available.  If not, ask for confirmation whether to get it from the
	server.  Update mode line before check-in.

2000-10-04  Dave Love  <fx@gnu.org>

	* toolbar/tool-bar.el (tool-bar-setup): New function.
	(tool-bar-mode): Use it.

2000-10-04  Peter Breton  <pbreton@ne.mediaone.net>

	* net/net-utils.el (nslookup-font-lock-keywords)
	(ftp-font-lock-keywords, smbclient-font-lock-keywords):
	Only set if window-system is non-nil
	(net-utils-run-program): Returns buffer.
	(network-connection-reconnect): Added this function.

	* generic.el:
	Incorporates extensive cleanup and docfixes by
	Stefan Monnier (monnier+gnu/emacs@flint.cs.yale.edu).
	Uses cl compile-time macros.
	(generic-mode-name, generic-comment-list)
	(generic-keywords-list, generic-font-lock-expressions)
	(generic-mode-function-list, generic-mode-syntax-table):
	Removed variables.
	(generic-mode-alist): Renamed to generic-mode-list.
	(generic-find-file-regexp): Default changed to "^#".
	(generic-read-type): Uses completing read on generic-mode-list.
	(generic-mode-sanity-check): removed this function.
	(generic-add-to-auto-mode): Removed this function
	(generic-mode-internal): Bind mode-specific definitions
	into function instead of putting them in alist.
	(generic-mode-set-comments): Reworked extensively.
	(generic-mode-find-file-hook): Simplified regexp searching
	(generic-make-keywords-list): Omit extra pair of parens

	* find-lisp.el (find-lisp-find-files-internal):
	Make sure directory name ends with "/".

	* generic-x.el (apache-conf-generic-mode):
	Regexp now allows leading whitespace.
	(rc-generic-mode): Added eval-when-compile
	around generic-make-keywords-list.
	Deleted duplicate regexp
	(rul-generic-mode): Added eval-when-compile
	around generic-make-keywords-list.
	(etc-fstab-generic-mode): New generic mode.
	(rul-generic-mode): Removed one eval-when-compile
	which caused a max-specpdl-size exceeded error.

2000-10-04  Miles Bader  <miles@gnu.org>

	* simple.el (minibuffer-temporary-goal-position): New variable.
	(next-history-element): Try to keep the position of point in the
	input string constant.

	* dired-aux.el (dired-mark-read-file-name): Add optional arg DEFAULT.
	(dired-do-create-files): If there's only one file, pass it in as
	the DEFAULT arg to dired-mark-read-file-name.

2000-10-03  Stefan Monnier  <monnier@cs.yale.edu>

	* diff-mode.el (diff-font-lock-keywords): Minor regex fix.
	(diff-goto-source): Be smarter when choosing REVERSE or not.

	* textmodes/texinfo.el (texinfo-heading-face): Forgot the var def.
	(texinfo-mode-menu): Add an explicit shortcut for update all.

2000-10-03  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-transfer-file, vc-default-receive-file): Rewritten to
	factorize backend-specific code cleanly (this was essentially
	conceived by Stefan Monnier).
	(vc-unregister): Function removed.
	(vc-revert-file): New function.
	(vc-revert-buffer): Delegate some of the work to it.

	* vc-rcs.el (vc-rcs-fetch-master-state): Parse and remember
	default branch unconditionally.
	(vc-rcs-set-default-branch): New function.
	(vc-rcs-cancel-version, vc-rcs-checkin, vc-rcs-checkout): Use it.
	(vc-rcs-checkin): If an appropriate default branch has been set,
	force creation of that branch.
	(vc-rcs-receive-file): Rewritten to contain only backend-specific
	code (as suggested by Stefan Monnier).

2000-10-02  Gerd Moellmann  <gerd@gnu.org>

	* isearch.el (isearch-lazy-highlight-update): Don't put a lazy
	highlighting overlay with a different face over the overlay
	isearch uses to highlight the current match because that can lead
	to bad face combinations.

	* loadup.el (toplevel): Load faces before isearch.

	* isearch.el (isearch-faces): New custom group.
	(isearch): New defface; was already tested for in the code.
	(isearch-lazy-highlight-face): Changed to defface from defcustom.
	(isearch-highlight): Always use face `isearch'.

2000-10-02  Dave Love  <fx@gnu.org>

	* emacs-lisp/byte-opt.el (byte-optimize-lapcode): Don't bind
	unused vars.  Treat byte-constant2 like byte-constant.  Fix bogus
	comparison of opcode with operand.

2000-10-03  Miles Bader  <miles@gnu.org>

	* play/yow.el (yow): Don't display multi-line quotations in a *Help*
	buffer, since the echo area will now grow to accommodate them.

2000-10-02  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-registered): If FILE used to be registered under
	a certain backend, try that one first.

	* vc.el (vc-responsible-backend): Undo the previous change in the
	argument list.  Handle multiple backends correctly.
	(vc-find-new-backend): Function removed.
	(vc-register): Use vc-responsible-backend, as before.
	(vc-next-action-on-file): Do use vc-registered, not vc-backend.

2000-10-02  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (fancy-splash-head): Change message below the
	logo.

2000-10-02  Miles Bader  <miles@lsi.nec.co.jp>

	* diff-mode.el (diff-goto-source): Emit a status message.
	(diff-test-hunk, diff-apply-hunk): Remove unneeded `let'.
	(diff-test-hunk): Fix doc string.
	(diff-apply-hunk): Only advance if `diff-advance-after-apply-hunk'.
	(diff-advance-after-apply-hunk): New variable.
	(diff-apply-hunk): Don't return a value.

2000-10-01  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-editable-p): Minor optimization.
	(edit-vc-file, vc-next-action-on-file): Don't use find-file.
	(vc-find-new-backend): New function split from vc-responsible-backend.
	(vc-register): Use it.
	(vc-responsible-backend): Remove REGISTER arg and add BACKENDS arg.
	(vc-unregister): Drop BACKEND arg (it doesn't work anyway).
	(vc-default-unregister, vc-revert-buffer): Docstring fix.
	(vc-clear-headers): Don't use find-file.
	(vc-revert-buffer): Use `and' again (must have been a braino).
	(vc-switch-backend): Only prompt if requested.
	Short circuit if nothing is to be done.
	Don't use vc-resynch-buffer which could lose unsaved editing.
	(vc-default-receive-file): Update call to vc-unregister.
	(with-vc-file, vc-next-action-on-file):
	Use vc-backend rather than vc-registered.
	(vc-next-action-on-file): Use intern-soft.
	Deal with read-only *vc-diff* buffer.
	(vc-transfer-file): Docstring fix.

	* vc-rcs.el (vc-rcs-unregister): Keep a backup of the master file.
	(vc-rcs-receive-file): Avoid with-vc-properties.
	Update call to vc-unregister.
	Use constant `RCS' rather than (dynamically bound) var `backend'.

2000-10-01  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-next-action-on-file): Update mode line only if file
	is visited.
	(vc-start-entry): New argument initial-contents.  Don't visit the file
	if it isn't already visited.  Brought documentation up-to-date.
	(vc-next-action, vc-register): Updated calls to vc-start-entry.
	(vc-checkin): New optional arg initial-contents, which is passed to
	vc-start-entry.
	(vc-finish-logentry): Make sure to bury log buffer only if there
	really is one.  Call `vc-resynch-buffer' on log-file, not
	buffer-file-name.
	(vc-default-comment-history, vc-default-wash-log): New functions.
	(vc-index-of): Removed.
	(vc-transfer-file): Make do without the above.
	(vc-default-receive-file): Call comment-history unconditionally.  Pass
	the resulting string to vc-checkin, instead of inserting it into the
	comment ring.

	* vc-rcs.el (vc-rcs-receive-file): Call comment-history
	unconditionally.  Use the comments as initial contents of the log
	entry buffer.  Document the trick to force branch creation with no
	changes.

2000-10-01  Miles Bader  <miles@gnu.org>

	* emacs-lisp/easy-mmode.el (easy-mmode-define-navigation): Call
	`recenter' with an arg to prevent redrawing the display.

2000-09-30  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/easy-mmode.el (easy-mmode-pretty-mode-name): Prettier.

	* emacs-lisp/lisp.el (lisp-complete-symbol): Only jump 2 not 3 levels.

	* progmodes/c-mode.el (c-mode):
	Don't gratuitously override the default for comment-column.

	* textmodes/tex-mode.el (latex-metasection-list): New var.
	(latex-imenu-create-index): Use it.
	Move the regexp construction outside loops (and use push).
	(tex-font-lock-keywords-1, tex-font-lock-keywords-2)
	(tex-font-lock-keywords): Moved from font-lock.el.
	(tex-comment-indent): Remove.
	(tex-common-initialization): Don't set comment-indent-function.
	(latex-block-default): New var.
	(tex-latex-block): Use it to provide a default choice.
	Add any unknown choice to latex-block-names.
	Insert [...] after {...}.
	(tex-last-unended-begin): Simplify regexp.
	(tex-goto-last-unclosed-latex-block, latex-backward-sexp-1)
	(latex-forward-sexp-1, latex-forward-sexp): New functions.
	(latex-mode): Set forward-sexp-function.

	* textmodes/texinfo.el (texinfo-font-lock-syntactic-keywords):
	Add regexp for @ignore ... @end ignore.
	(texinfo-heading-face): New face.
	(texinfo-font-lock-keywords): Use it.
	(texinfo-mode-menu): New menu.
	(texinfo-inside-macro-p, texinfo-inside-env-p, texinfo-insert-quote):
	New functions.
	(texinfo-mode-map): Bind " to insert-quote and M-RET to insert-@item.
	(texinfo-section-types-regexp, texinfo-section-level-regexp)
	(texinfo-subsection-level-regexp, texinfo-subsubsection-level-regexp):
	Remove declaration.
	(texinfo-show-structure): Use outline-regexp and texinfo-section-list.

	* delsel.el (delete-selection-mode): Use define-minor-mode.

	* emacs-lisp/regexp-opt.el (regexp-opt-group): Put more parenthesis.

2000-09-29  Stefan Monnier  <monnier@cs.yale.edu>

	* dired.el (dired-map-over-marks): Use modern backquotes and docstring.

2000-09-30  Gerd Moellmann  <gerd@gnu.org>

	* replace.el (keep-lines-read-args): New function.
	(keep-lines, flush-lines, how-many): Use keep-lines-read-args to
	read arguments interactively.  Add parameters RSTART and REND.
	Operate on the active region in Transient Mark mode.

	* files.el (auto-mode-alist): Add pattern for `#*mail*...'.

	* emacs-lisp/authors.el (authors-obsolete-file-p): New function.
	(authors-obsolete-files-regexps): New variable.
	(authors-add): Don't record changes in obsolete files.

2000-09-29  Stefan Monnier  <monnier@cs.yale.edu>

	* autoinsert.el (auto-insert-mode): Use define-minor-mode.

	* newcomment.el (comment-indent-function): Use 0 for ;;; and %%%.
	(comment-indent): Make sure there's a space between code and comment.
	Shift comments left to avoid going past fill-column.

2000-09-29  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (startup-echo-area-message): New function.
	(display-startup-echo-area-message): Use it.
	(fancy-splash-screens): Rewritten to use keymaps and a timer.
	(fancy-splash-default-action): New function.
	(fancy-splash-screens-1): New function.
	(fancy-splash-head): Put a help-echo and a keymap under the image.

2000-09-29  Stefan Monnier  <monnier@cs.yale.edu>

	* diff-mode.el (diff-add-log-file-name): Remove.
	(diff-mode): Use add-log-buffer-file-name-function.

	* add-log.el (find-change-log): New arg BUFFER-FILE.
	(add-log-file-name): Obey add-log-file-name-function.
	(add-log-buffer-file-name-function): New var.
	(add-change-log-entry): Use it.

2000-09-29  Miles Bader  <miles@gnu.org>

	* image-file.el (image-file-name-extensions): New variable.
	(image-file-name-regexps): Renamed from `image-file-regexps'.
	New default value is nil.  Call `auto-image-file-mode'.
	(image-file-name-regexp): New function.
	(auto-image-file-mode): New minor mode.
	(insert-image-file): Don't make conditional on the image-file
	handler being enabled.
	(image-file-handler): Make the call here conditional instead.
	(set-image-file-handler-enabled, enable-image-file-handler)
	(disable-image-file-handler): Functions removed.

	* emacs-lisp/authors.el (authors-print): Rephrase many-files
	string.

2000-09-29  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/tex-mode.el (latex-outline-regexp): Don't use `list*';
	it's a function from CL.
	(latex-imenu-create-index): Replace eval-when-compile with progn
	because latex-section-alist is not bound while compiling.

2000-09-28  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/outline.el (outline-minor-mode): Use define-minor-mode.
	(outline-mode): Use define-derived-mode.

	* progmodes/perl-mode.el (perl-mode):
	* progmodes/awk-mode.el (awk-mode):
	* progmodes/asm-mode.el (asm-mode):
	Don't gratuitously override the default for comment-column.

	* emacs-lisp/lisp.el (lisp-complete-symbol):
	Distinguish the let-binding case from the funcall case.
	(forward-sexp-function): New variable.
	(forward-sexp): Use it.

	* emacs-lisp/easy-mmode.el (easy-mmode-define-keymap): Autoload.
	(easy-mmode-defmap): Remove the now useless autoload.

	* time.el (display-time-mode): Use define-minor-mode.

	* subr.el (add-minor-mode): Don't eval NAME.
	Don't depend on the presence of TOGGLE-FUN for any special behavior.
	Use if rather than cond.

	* simple.el (read-expression-map): Define more properly.
	(comment-indent-hook): Remove.
	(string-to-syntax): Bug fix.

	* pcvs.el (cvs-ediff-exit-hook): Kill buffer before window.
	(cvs-ediff-diff): Fix typo.
	(cvs-revert-if-needed): Don't bother preserving read-only.

	* paren.el (show-paren-mode): Use define-minor-mode.

	* jka-compr.el (auto-compression-mode): Use define-minor-mode.
	(toggle-auto-compression): Remove.
	(jka-compr-build-file-regexp): Remove useless grouping.

	* diff-mode.el (diff-mode-map, diff-minor-mode-prefix):
	Avoid user-reserved bindings.
	(diff-mode, diff-minor-mode): Drop make-local-hook (done by add-hook).
	(diff-header-face): Revert to grey85.

	* cvs-status.el (cvs-status-entry-leader-re): Minor fix.

	* complete.el (partial-completion-mode) <defcustom>: Remove.
	(partial-completion-mode): Use define-minor-mode.
	(PC-do-completion): Understand `completion-auto-help = delay'
	to mean to popup the completion buffer only the second time.
	(PC-include-file-all-completions, PC-include-file-all-completions)
	(PC-include-file-all-completions): Don't quote lambda.

	* comint.el (comint-mode-hook): Docstring fix.
	(comint-mode): Use define-derived-mode.
	(comint-mode-map): Remove obsolete comment.
	(make-comint): Minor stylistic change.
	(comint-insert-clicked-input): Be more careful to find the overlay.
	Use this-command-keys rather than hardcoding mouse-2.

	* font-lock.el: Replace confusing (,@ with ,
	(tex-font-lock-keywords-1, tex-font-lock-keywords-2):
	Don't use regexp-opt-depth.  Spice up the regexp for args.
	Don't distinguish between cmds that can take an opt arg or not.
	Use `append' and `prepend' rather than `keep'.

	* textmodes/tex-mode.el (latex-imenu-indent-string): Add a space.
	(latex-outline-regexp): New var.
	(latex-outline-level): New fun.
	(latex-section-alist): New var.
	(latex-imenu-create-index): Use it.  Use `push' as well.
	(tex-shell-map): Initialize it properly.
	(tex-mode): Minor stylistic change.
	(plain-tex-mode): Use define-derived-mode.
	(latex-mode): Use define-derived-mode.
	Construct the paragraph regexps in a more readable way.
	Set the buffer-local outline-{level,regexp} vars.
	(slitex-mode): Derive from latex-mode.
	(tex-common-initialization): Don't kill-all-vars anymore.
	Add setting for comment-add and font-lock-defaults.
	(tex-start-shell): Use with-current-buffer and don't re-init keymap.
	(tex-main-file): New fun.  Obey TeX-master as well and remove `.tex'.
	(tex-start-tex): New arg DIR (and send a chdir command for it).
	Also display the shell buffer and save it in tex-last-buffer-texed.
	(tex-region): Use expand-file-name rather than concat.
	Remove code made useless by changes in tex-start-tex.
	(tex-file): Use tex-main-file and adapt to new tex-start-tex.

	* map-ynp.el (map-y-or-n-p): Fix missing backquotes.

2000-09-28  Dave Love  <fx@gnu.org>

	* eshell/eshell.el (eshell) <defgroup>: Add :version.

2000-09-28  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/authors.el (authors-add): Use `nconc' instead of
	`append'.

2000-09-28  Stefan Monnier  <monnier@cs.yale.edu>

	* info.el (Info-extract-pointer): Undo last change.
	Instead, fix the position of the `bound' arg to re-search-backward.

2000-09-27  Stefan Monnier  <monnier@cs.yale.edu>

	* info.el (Info-extract-pointer):
	Widen more carefully, to avoid finding pointers in other nodes.
	(Info-index): Use push.

2000-09-27  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (set-frame-font): Remove call to obsolete function
	frame-update-faces.
	(set-foreground-color, set-background-color): Likewise for
	frame-update-face-colors.

2000-09-27  Miles Bader  <miles@gnu.org>

	* image-file.el: New file.

2000-09-27  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (frame-notice-user-settings): Don't call
	frame-update-faces, which is a no-op now.

	* ediff-wind.el (ediff-control-frame-parameters): Add zero
	tool-bar-lines.

2000-09-27  Dave Love  <fx@gnu.org>

	* mouse.el: Fix last change.

2000-09-27  Miles Bader  <miles@lsi.nec.co.jp>

	* toolbar/tool-bar.el (tool-bar-help): Use `mouse-pixel-position'.

2000-09-22  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-help): The output message is
	improved.

2000-09-26  Dave Love  <fx@gnu.org>

	* mouse.el (popup-menu): If POSITION is nil, set it using
	mouse-position.

2000-09-25  Sam Steingold  <sds@gnu.org>

	* net/browse-url.el (browse-url-file-url): Check for null maps.

2000-09-26  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (frame-notice-user-settings): Don't add a
	tool-bar-lines frame parameter to default-frame-alist in batch mode.

	* frame.el (frame-notice-user-settings):
	Make tool-bar-mode and default-frame-alist consistent.

	* toolbar/tool-bar.el (tool-bar-help): New function.

2000-09-25  Gerd Moellmann  <gerd@gnu.org>

	* bytecomp.el (byte-compile-defvar-or-defconst): Only cons onto
	current-load-list in top-level forms.  Else this leaks a cons cell
	every time a defun is called.

	* mail/mail-utils.el (rmail-dont-reply-to): Fix last change.

2000-09-25  Dave Love  <fx@gnu.org>

	* startup.el (fancy-splash-head): Check XPM is available.

	* autoinsert.el (auto-insert): Doc fix.
	(auto-insert-alist): Following GNU notices, don't say `copyright
	_by_'.  Use line-beginning-position.
	(auto-insert): Check buffer-file-name is non-nil before use.

2000-09-25  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/texinfo.el (texinfo-mode): Prevent filling lines
	starting with `@def' or `@multitable', in addition to ones
	specified by the user in auto-fill-inhibit-regexp.

2000-09-25  Markus Rost  <rost@math.ohio-state.edu>

	* mail/mail-utils.el (rmail-dont-reply-to): Avoid infinite loop if
	rmail-dont-reply-to-names matches the empty string.

2000-09-25  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (command-line-1, fancy-splash-text): Change the
	text to sound more friendly.

2000-09-23  Thien-Thi Nguyen  <ttn@gnu.org>

	* progmodes/hideshow.el: Update author email address.
	Generally, sync w/ maintainer version 5.22.
	(hs-hide-all-non-comment-function): New var.
	(hs-hide-hook, hs-show-hook, hs-minor-mode): Update docstrings.
	(hs-hide-all): Use `hs-hide-all-non-comment-function'.
	(hs-show-region): Delete this command.
	(hs-minor-mode-map): Change bindings to leave "C-c LETTER" alone.

2000-09-22  Dave Love  <fx@gnu.org>

	* hl-line.el (hl-line-overlay): Don't make it buffer-local.
	(hl-line-highlight): Specify buffer when moving overlay.

	* progmodes/fortran.el (fortran-mode): Locally set
	normal-auto-fill-function.
	(fortran-auto-fill-mode): Just alias to auto-fill-mode.
	(fortran-mode-map): Adjust auto-fill menu entry.

2000-09-22  Gerd Moellmann  <gerd@gnu.org>

	* vc-rcs.el (toplevel): Require `vc' when compiling.

	* startup.el (fancy-splash-head): Use splash.pbm instead of splash.xbm.

2000-09-22  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-switch-backend): Signal an error if the file is not
	registered under the new backend.

	* vc-rcs.el (vc-rcs-checkin): Fix bug that prevented check-in
	without explicit revision number.

2000-09-21  Stefan Monnier  <monnier@cs.yale.edu>

	* diff-mode.el (diff-file-header-face): Reset to its previous value.
	(diff-hunk-text): Correctly use offsets rather than buffer-positions.
	(diff-xor): New function.
	(diff-find-source-location): Use it.  Fix a stupid name clash.
	(diff-hunk-status-msg): New function.
	(diff-apply-hunk): Drop args OTHER-FILE, DRY-RUN, POPUP and NOERROR.
	(diff-test-hunk): Use diff-find-source-location.
	(diff-goto-source): Favor the `reverse'.
	(diff-hunk-text): Properly handle one-sided context diffs.
	(diff-apply-hunk): When done, advance to the next hunk.

2000-09-21  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (command-line): If frame was created with a non-zero
	tool-bar-lines parameter, switch tool-bar-mode on.

	* add-log.el (change-log-date-face, change-log-name-face)
	(change-log-email-face, change-log-file-face)
	(change-log-list-face, change-log-conditionals-face)
	(change-log-function-face, change-log-acknowledgement-face):
	New faces, inheriting from font-lock faces.
	(change-log-font-lock-keywords): Use them.

2000-09-21  Dave Love  <fx@gnu.org>

	* progmodes/cperl-mode.el (top-level): Clean up
	`eval-when-compile's and assorted defvars.
	(cperl-invalid-face): Don't double-quote value.  Change custom
	type.
	(cperl-mode): Set normal-auto-fill-function and don't zap
	auto-fill-function.
	(cperl-imenu--function-name-regexp-perl): Renamed from
	imenu-example--function-name-regexp-perl.
	(cperl-imenu--create-perl-index): Renamed from
	imenu-example--create-perl-index.
	(cperl-xsub-scan): Don't require cl.

	* msb.el (msb-mode-map): Use substitute-key-definition.
	(msb-mode): Use msb-mode-map.

2000-09-21  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-index-of, vc-transfer-file, vc-default-receive-file):
	New functions.
	(vc-next-action-on-file): Call vc-transfer-file at appropriate places.
	(vc-switch-backend): New function.
	(vc-prefix-map): Bind `vc-switch-backend' to `b'.
	(vc-register): Fix prompt.
	(vc-unregister, vc-default-unregister): New functions.
	(vc-version-diff): Handle empty buffer in sentinel.

	* vc-rcs.el (vc-rcs-workfile-is-newer): New function.
	(vc-rcs-state-heuristic): Use it to guess the state of files with
	non-strict locking.
	(vc-rcs-find-most-recent-rev): Handle the case when a branch has
	been set with -b, but not created yet.
	(vc-rcs-fetch-master-state): With non-strict locking, compare file
	contents in order to find the state.
	(vc-rcs-checkin): Allow creation of branches with no changes.
	(vc-rcs-unregister, vc-rcs-receive-file)
	(vc-rcs-set-non-strict-locking): New functions.

	* vc-hooks.el (vc-name): Force correct computation of the value
	in case it is missing.

2000-09-21  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (fancy-splash-tail): Use a different foreground
	color on a dark frame background.

2000-09-21  Miles Bader  <miles@lsi.nec.co.jp>

	* info.el: Use the correct capitalization when making Info-mode
	and Info-edit-mode `special' modes.

2000-09-20  Stefan Monnier  <monnier@cs.yale.edu>

	* diff-mode.el (diff-add-log-file-name, diff-current-defun): New funs.
	(diff-mode): Add support for add-log.el.
	(diff-hunk-text): Use char offsets rather than line offsets.
	(diff-find-source-location): Replace LINE with line-offset (nil
	if not found) and always set POS to a meaningful position.
	Adapt to the new char-offsets.
	(diff-apply-hunk): Drop support for the unused `select' POPUP.
	Adapt to the new diff-find-source-location.
	(diff-goto-source): Adapt to the new diff-find-source-location.

	* add-log.el (add-log-file-name): New function (split out of
	add-change-log-entry).
	(add-change-log-entry): Use it.
	Call add-log-file-name-function with the changelog file name if
	the current buffer is not associated with any file.
	Avoid find-file if the selected window is dedicated.

	* diff-mode.el (diff-find-source-location):
	Move code from diff-apply-hunk.  Return buffer rather than file.
	(diff-apply-hunk): Use the new result from  diff-find-source-location.
	(diff-goto-source): Use the new diff-find-source-location.

2000-09-20  Dave Love  <fx@gnu.org>

	* iswitchb.el: Some doc fixes.
	(iswitchb-mode-map): Define completely initially.  Inherit
	minibuffer-local-map.
	(iswitchb-completion-help) <!iswitchb-xemacs>: Use
	fundamental-mode.
	(iswitchb-global-map): New variable.
	(iswitchb-summaries-to-end): Amalgamate regexps.
	(iswitchb-mode): New.
	(iswitchb-mode-hook): New variable.
	(iswitchb) <defgroup>: Add URL link.  Use group `completion', not
	`extensions'.

2000-09-20  Gerd Moellmann  <gerd@gnu.org>

	* ehelp.el (electric-help): New defgroup.
	(electric-help-shrink-window): New user-option.
	(with-electric-help): Use it.

	* window.el (shrink-window-if-larger-than-buffer): If face
	`mode-line' has a :box, and we're on a graphical frame, add 1
	to the needed window height.

	* frame.el (frame-notice-user-settings): Add a last parameter nil
	to a call to `append', because the last list passed to `append' is
	not copied, and so subsequent calls to assq-delete-all will modify
	default-frame-alist.

	* startup.el (fancy-splash-image): Change :type.
	(fancy-splash-head): Use an XBM image if appropriate.
	(command-line-1): Show splash screens in more cases.

	* startup.el (fancy-splash-text): Don't quote faces.

	* dired.el (dired-font-lock-keywords): Undo last change.
	(dired-readin): Bind indent-tabs-mode to nil.

	* startup.el (fancy-splash-head): If frame's background mode
	is `dark', change the black background of the image to gray.
	(fancy-splash-screens): Display startup echo area message.
	(display-startup-echo-area-message): New function.

2000-09-20  Miles Bader  <miles@lsi.nec.co.jp>

	* faces.el (mode-line, tool-bar): Merge entries for `x' and `w32'.

	* info.el (info-header-node): Tweak for color ttys.

	* faces.el (face-valid-attribute-values): Make sure directories we
	search for stipples both exist and are readable before trying to
	search them.

	* diff-mode.el (diff-apply-hunk): Jump to the correct line offset
	in the dry-run case.

	* jka-compr.el (with-auto-compression-mode): New macro.

	* cus-edit.el (custom-face-tag-face, custom-group-tag-face-1)
	(custom-group-tag-face, custom-variable-tag-face): Use relative
	:height and inherit from `variable-pitch' face instead of
	hardwiring :family.
	* hi-lock.el (hi-black-hb): Likewise.

	Reapply Gerd's change from 2000-09-18, which seems to have gotten lost:
	* toolbar/tool-bar.el (tool-bar-add-item-from-menu): Like in
	toolbar-add-item, if image doesn't have a mask add a `:mask
	heuristic'.

2000-09-19  Stefan Monnier  <monnier@cs.yale.edu>

	* diff-mode.el: Docstring fixes.
	(diff-header-face, diff-comment-face): New faces.
	(diff-font-lock-keywords): Highlight a bit differently.
	(diff-find-source-location): Don't return SPAN any more.
	(diff-hunk-text): Don't bother erasing the temp buffer.
	(diff-find-text): Drop argument LINE.
	(diff-apply-hunk): Update calls to diff-find-text.
	(diff-goto-source): Use pop-to-buffer again and don't raise an error.

	* calendar/calendar.el: Docstring fixes.
	(calendar-make-alist): Don't quote lambda.
	(calendar-star-date): Use make-local-variable.

2000-09-19  Dave Love  <fx@gnu.org>

	* toolbar/tool-bar.el: Renamed from toolbar.el.
	Change `toolbar' to `tool-bar' generally in symbols.
	Make some items invisible in `special' major modes.
	(tool-bar-add-item-from-menu): Renamed from toolbar-like-menu-item.
	Add arg PROPS.

	* startup.el (fancy-splash-screen) <defgroup>: Fix syntax.
	Add :version here.
	(fancy-splash-delay, fancy-splash-image): Remove :version here.

2000-09-19  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/sh-script.el (sh-search-word): Remove call to
	`debug'.

	* files.el (find-file-suppress-same-file-warnings): New
	user-option.
	(find-file-noselect): Use it.

	* startup.el (fancy-splash-delay, fancy-splash-image): Add
	:version.
	(fancy-splash-screen): Defgroup.

	* add-log.el (change-log-font-lock-keywords): Match names
	more exactly for the case that font-lock-constant-face is
	underlined.

2000-09-19  Richard M. Stallman  <rms@gnu.org>

	* progmodes/sh-script.el (sh-search-word): Rewritten for
	speed.

2000-09-19  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-revert-buffer): Set vc-checkout-time correctly.

2000-09-19  Gerd Moellmann  <gerd@gnu.org>

	* gnus/: Update to emacs-21-branch of the Gnus CVS repository.
	* gnus/binhex.el, gnus/flow-fill.el, gnus/format-spec.el
	* gnus/gnus-ml.el, gnus/gnus-mlspl.el, gnus/ietf-drums.el,
	* gnus/imap.el, gnus/mail-parse.el, gnus/mail-prsvr.el,
	* gnus/mail-source.el, gnus/mailcap.el, gnus/mm-bodies.el,
	* gnus/mm-decode.el, gnus/mm-encode.el, gnus/mm-partial.el,
	* gnus/mm-util.el, gnus/mm-uu.el, gnus/mm-view.el,
	* gnus/mml.el, gnus/nnimap.el, gnus/nnslashdot.el,
	* gnus/nnultimate.el, gnus/nnwarchive.el, gnus/qp.el,
	* gnus/rfc1843.el, gnus/rfc2045.el, gnus/rfc2047.el,
	* gnus/rfc2104.el, gnus/rfc2231.el, gnus/time-date.el,
	* gnus/utf7.el, gnus/uudecode.el, gnus/webmail.el: New files.

	* startup.el (fancy-splash-text): New variable.
	(fancy-splash-delay, fancy-splash-image): New user-options.
	(fancy-splash-insert, fancy-splash-head, fancy-splash-tail)
	(fancy-splash-screens): New functions.
	(command-line-1): If display has a `display' frame parameter, has
	colors, and we have XPM support, show more fancy splash screens.

2000-09-19  Dave Love  <fx@gnu.org>

	* map-ynp.el (map-y-or-n-p): Check use-dialog-box.  Don't lose
	with null `help'.  Use modern backquote syntax.

2000-09-19  Gerd Moellmann  <gerd@gnu.org>

	* font-lock.el (font-lock-mode): Change message telling the user
	that ``the buffer is too big''.

	* dired.el (dired-font-lock-keywords): Allow tabs and spaces,
	for instance for the case that tab-width is 2.

2000-09-18  Gerd Moellmann  <gerd@gnu.org>

	* toolbar/toolbar.el (toolbar-like-menu-item): Like in
	toolbar-add-item, if image doesn't have a mask add a `:mask
	heuristic'.

2000-09-18  Miles Bader  <miles@lsi.nec.co.jp>

	* diff-mode.el (diff-hunk-text): Add new optional arg LINE-OFFSET,
	and return a cons if it's non-nil.
	(diff-apply-hunk): Try to jump to the line in the source text
	corresponding to the position of point in the in the hunk.

	* info.el (Info-title-3-face, Info-title-2-face)
	(Info-title-1-face): Use face inheritance and relative sizes
	instead of hard-wiring things.

	* faces.el (secondary-selection): Make dark-background variant sane.

2000-09-16  Andrew Innes  <andrewi@gnu.org>

	* makefile.nt (compile-files): No need to make .elc files
	read-only, since they aren't under VC now.

	* makefile.w32-in (compile-files-CMD): No need to make .elc files
	read-only, since they aren't under VC now.

2000-09-17  Dave Love  <fx@gnu.org>

	* tmm.el: Replace mapcar with mapc in several places.

	* loadhist.el (unload-feature): Maybe call elp-restore-list and
	ad-unadvise.

	* international/latin1-disp.el: New file.

	* calendar/cal-move.el (scroll-calendar-left)
	(scroll-calendar-right): Make arg optional (for active mode line).

	* calendar/calendar.el (calendar-mode-line-format): Make fields
	mouse-sensitive.
	(calendar-read-date, calendar-read-date, calendar-window-list):
	Unquote lambda.
	(calendar-month-name): Use aref, not sref.

	* view.el (minor-mode-alist): Propertize the string.

	* international/characters.el (standard-case-table): Add entries
	for Greek.

2000-09-18  Miles Bader  <miles@gnu.org>

	* info.el (info-node, info-xref): Add dark-background variants.

	* faces.el (header-line): Change defaults to be less confusing
	when mixed with mode-lines.

	* info.el (Info-fontify-node): Make a few cleanups.
	Add extra `help-echo' and `local-map' props to node xrefs.
	Use header-specific faces for node-names & xrefs.
	(Info-use-header-line): New variable.
	(info-header-xref, info-header-node): New faces.
	(Info-setup-header-line): New function.
	(Info-select-node): Call Info-setup-header-line when enabled.
	(Info-extract-pointer): Work even if the header line is hidden.
	(Info-header-line): New variable.

2000-09-16  Stefan Monnier  <monnier@cs.yale.edu>

	* vms-patch.el (print-region-function): Don't quote lambda.

	* tempo.el (tempo-expand-if-complete): Quote paren in docstring.

	* emacs-lisp/lisp-mnt.el (lm-header-prefix): Cleanup the regexp.
	(lm-get-header-re): Allow spaces between the header and the colon.
	(lm-header): Allow $ in non-RCS headers.
	(lm-header-multiline): Put the strings back into order.
	Stop at an empty line.  Don't require two space chars if the
	line is clearly not another header line.

	* emacs-lisp/lmenu.el (popup-menu, popup-menu-internal)
	(popup-menu-popup): Remove.

2000-09-15  Gerd Moellmann  <gerd@gnu.org>

	* toolbar/toolbar.el (toolbar-add-item): Use the same image
	specification if or if not tool-bar item contains an `:enabled'
	property.

	* menu-bar.el (menu-bar-files-menu): Disable ``Save'' if
	current buffer has no file name.

2000-09-15  Dave Love  <fx@gnu.org>

	* strokes.el: Sync with maintainer's current version with changes
	for Emacs, but avoid runtime cl and levents.
	(toplevel):  Change autoloads and compilation requires.
	(strokes-version, strokes-bug-address, strokes-lift): Values
	changed.
	(strokes-xpm-header, strokes-insinuated): New variable.
	(strokes): Add :link.
	(strokes-mode): Customized.
	(strokes-while-inhibiting-garbage-collector): New macro.
	(strokes-remassoc): Avoid remove-if.
	(strokes-fix-button2-command): Don't use ad-do-it.
	(strokes-insinuate): New function.
	(strokes-button-press-event-p, strokes-button-release-event-p):
	New functions, used instead of non-`strokes-' versions..
	(strokes-mouse-event-p): Rewritten.
	(strokes-event-closest-point): Avoid event-point.
	(strokes-get-grid-position): Avoid cdadr, caadr
	(strokes-read-stroke, strokes-read-complex-stroke): Avoid levents
	functions.
	(strokes-help): Use with-output-to-temp-buffer.
	(strokes-window-configuration-changed-p): New function.
	(strokes-update-window-configuration): Use buffer-live-p,
	strokes-window-configuration-changed-p.
	(strokes-mode): Use strokes-insinuate.  Alter mouse bindings.
	(strokes-char-face): New face.
	(strokes-char-table, strokes-base64-chars): New variable.
	(strokes-xpm-for-stroke, strokes-list-strokes)
	(strokes-xpm-char-on-p, strokes-xpm-char-bit-p)
	(strokes-xpm-encode-length-as-string, strokes-xpm-decode-char)
	(strokes-xpm-to-compressed-string, strokes-decode-buffer)
	(strokes-encode-buffer, strokes-xpm-for-compressed-string)
	(strokes-compose-complex-stroke, strokes-alphabetic-lessp): New
	functions.

2000-09-15  Gerd Moellmann  <gerd@gnu.org>

	* toolbar/toolbar.el (toolbar-add-item): Use image-mask-p.

	* image.el (create-image): Doc fix.

	* toolbar/toolbar.el (toolbar-add-item): Use `:mask heuristic'
	instead of `:heuristic-mask t'.

2000-09-14  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in: Revert to Unix line endings.

2000-09-14  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in: Add bootstrap support.  Also copy lisp source
	when installing.

	* makefile.nt (DONTCOMPILE): Fix typo.

	* shell.el (shell-write-history-on-exit): New function.
	(shell-dumb-shell-regexp): New custom variable.
	(shell-mode): Make shell-write-history-on-exit the process
	sentinel if shell name matches shell-dumb-shell-regexp.

	* w32-fns.el: Comment out before-init-hook function which resets
	source-directory based; this breaks bootstrap.

2000-09-14  Dave Love  <fx@gnu.org>

	* toolbar/cancel.xpm, toolbar/close.xpm, toolbar/copy.xpm,
	toolbar/cut.xpm, toolbar/exit.xpm, toolbar/fld_open.xpm,
	toolbar/help.xpm, toolbar/info.xpm, toolbar/mail.xpm,
	toolbar/mail_compose.xpm, toolbar/new.xpm, toolbar/open.xpm,
	toolbar/paste.xpm, toolbar/preferences.xpm, toolbar/print.xpm,
	toolbar/save.xpm, toolbar/saveas.xpm, toolbar/search-replace.xpm,
	toolbar/search.xpm, toolbar/spell.xpm, toolbar/undo.xpm:  New.
	From Tuomas Kuosmanen <tigert@gimp.org>.  (Gnome icons fetched
	from <URL:http://tigert.gimp.org/gnome/gnome-stock/>.)

	* toolbar/toolbar.el: New.

	* subdirs.el: Add toolbar.

2000-09-14  Gerd Moellmann  <gerd@gnu.org>

	* indent.el (indent-for-tab-command): Doc fix.

2000-09-14  Alex Schroeder  <alex@gnu.org>

	* ansi-color.el (ansi-colors): Doc change.
	(ansi-color-get-face): Simplified regexp.
	(ansi-color-faces-vector): Added more faces, doc change.
	(ansi-color-names-vector): Doc change.
	(ansi-color-regexp): Simplified regexp.
	(ansi-color-parameter-regexp): New regexp.
	(ansi-color-filter-apply): Doc change.
	(ansi-color-filter-region): Doc change.
	(ansi-color-apply): Use ansi-color-regexp and ansi-color-get-face,
	deal with zero length parameters.
	(ansi-color-apply-on-region): Doc change.
	(ansi-color-map): Doc change.
	(ansi-color-map-update): Removed debugging message.
	(ansi-color-get-face-1): Added condition-case to trap
	args-out-of-range errors.
	(ansi-color-get-face): Doc change.
	(ansi-color-make-face): Removed.
	(ansi-color-for-shell-mode): New option.

2000-09-13  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-start-translation): Translate KEY
	if necessary even if it doesn't have any mapping in the current
	input method.
	(quail-start-conversion): Likewise.
	(quail-help): The output message is improved.

2000-09-13  Miles Bader  <miles@gnu.org>

	* comint.el (comint-output-filter): Revert to using
	`insert-before-markers'.  Add bletcherous hack to undo damage
	caused by `insert-before-markers'.  Put `front-sticky' property on
	overlays created here so that the field code understands how the
	overlay works.  Use a let when making comint-last-prompt-overlay,
	so that the code is easier to read.

2000-09-13  Dave Love  <fx@gnu.org>

	* wid-edit.el (widget-default-format-handler): DTRT when
	doc-property is a function.

2000-09-12  Francesco Potorti`  <pot@gnu.org>

	* mail/sendmail.el (mail-mode-fill-paragraph): Do not get the
	filed name if it's not there.

2000-09-12  Dave Love  <fx@gnu.org>

	* simple.el (read-mail-command): Doc fix.
	(mail-user-agent): Add gnus-user-agent option for upcoming Gnus.

	* vc.el (vc-dired-listing-switches): Fix :version.

	* vc-hooks.el: Doc fixes.

	* subr.el (add-minor-mode): Use toggle-fun arg.

	* speedbar.el: Add :version to several defcustoms.

	* imenu.el (imenu--truncate-items, imenu--cleanup)
	(imenu--generic-function): Avoid mapcar.
	(imenu--replace-spaces): Function removed.
	(imenu--completion-buffer): Use subst-char-in-string.
	(imenu-add-to-menubar): Use keymap inheritance.

2000-09-12  Miles Bader  <miles@gnu.org>

	* diff-mode.el (diff-hunk-text): Use `with-temp-buffer'.
	(diff-mode-map): Bind `diff-test-hunk'.
	(diff-apply-hunk): Use `select-window' instead of `pop-to-buffer'.

2000-09-11  Gerd Moellmann  <gerd@gnu.org>

	* bytecomp.el (byte-compile-defvar): Undo last change
	because it breaks '(make-variable-buffer-local (defvar ...)'
	which is used at least in dired.

2000-09-12  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-define-package): Docstring
	modified.

2000-09-12  Kenichi Handa  <handa@etl.go.jp>

	* international/titdic-cnv.el (quail-cxterm-package-ext-info): Add
	extra docstrings for "chinese-ccdospy", "chinese-ecdict",
	"chinese-etzy", "chinese-sw", and "chinese-ziranma".  Modify the
	docstring of "chinese-py".

	* international/quail.el (quail-translation-docstring): New
	variable.
	(quail-show-keyboard-layout): Docstring modified.
	(quail-select-current): Likewise.
	(quail-build-decode-map): Change arg MAP to MAP-LIST to avoid
	infinite recursive call.
	(quail-help): Check quail-translation-docstring.  Format of the
	output changed.
	(quail-help-insert-keymap-description): Adjusted for the above
	change.

2000-09-11  Gerd Moellmann  <gerd@gnu.org>

	* bytecomp.el (byte-compile-defvar): Only cons onto
	current-load-list in top-level forms.  Else this leaks a cons cell
	every time a defun is called.

2000-09-11  Miles Bader  <miles@lsi.nec.co.jp>

	* diff-mode.el (diff-apply-hunk): Function basically rewritten.
	Now understands non-unified diffs.  Some functionality moved into
	`diff-hunk-text' and `diff-find-text'.  Add OTHER-FILE, DRY-RUN,
	POPUP, and NOERROR arguments.  If DRY-RUN is true, don't actually
	modify anything.  Only reposition point in the patched file if the
	patch succeeds.  Only pop up another window if POPUP is true.
	Emit a message describing what happened if successful, and at what
	line-offset.  Automatically detect reversed hunks and do something
	appropriate.
	(diff-hunk-text, diff-find-text): New functions.
	(diff-filter-lines): Function removed.
	(diff-test-hunk): New function.
	(diff-goto-source): Rewritten in terms of diff-apply-hunk.

2000-09-10  Dave Love  <fx@gnu.org>

	* textmodes/tildify.el: Minor doc/commentary fixes.
	(tildify) <defgroup>: Add :version.

	* faces.el (face-x-resources): Make custom type more specific.
	(frame-background-mode): Use mapc.
	(region) <defcustom>: Add :version.

2000-09-08  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-sccs.el (vc-sccs-register):
	* vc-rcs.el (vc-rcs-register):
	* vc-cvs.el (vc-cvs-register): Don't clear file's properties.
	* vc.el (vc-register): Clear file's properties.

2000-09-08  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-spec-set): Only face-spec-reset-face when
	ATTRS is non-nil.

2000-09-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* help.el (help-insert-xref-button): Fix a typo in doc string.

2000-09-07  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/titdic-cnv.el (quail-cxterm-package-ext-info):
	Fix doc strings of chinese-py-b5, chinese-py, and chinese-tonepy input
	methods.

	* menu-bar.el (read-mail-item-name): New function.
	(menu-bar-tools-menu): Use it to compute and display the package
	used to read email.
	(menu-bar-tools-menu): Fix typo in GUD's help string.

2000-09-07  Dave Love  <fx@gnu.org>

	* diff-mode.el (diff-mouse-goto-source): New function.

	* vc-sccs.el: Doc fixes.
	(vc-sccs-register-switches, vc-sccs-master-templates): Add :version.

	* vc-rcs.el: Doc fixes.
	(vc-rcs-register-switches, vc-rcs-checkin-switches)
	(vc-rcs-checkout-switches, vc-rcs-header)
	(vc-rcs-master-templates): Add or change :version.

	* vc-cvs.el: Doc fixes.
	(vc-cvs-register-switches, vc-cvs-header, vc-cvs-use-edit)
	(vc-cvs-stay-local): Add :version.

	* menu-bar.el (menu-bar-options-menu): Fix the font-lock toggle.

2000-09-07  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-help): Fix previous change.

2000-09-07  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (color-values): Doc fix.

	* faces.el (frame-set-background-mode): Use frame-parameter
	instead of frame-parameters.

	* frame.el (filtered-frame-list): Reduce consing.
	(frames-on-display-list): Call frame-parameter instead of
	frame-parameters.

2000-09-07  Kenichi Handa  <handa@etl.go.jp>

	* language/devan-util.el (devanagari-to-indian-region): In the
	loop, change the following char, not preceding char.

2000-09-07  Gerd Moellmann  <gerd@gnu.org>

	* menu-bar.el (menu-bar-update-buffers): Call frame-parameter
	instead of frame-parameters.

	* faces.el (set-face-attribute): Simplify by calling
	internal-set-lisp-face-attribute with FRAME being 0.

	* vc.el: Remove `Id' version control keyword.

2000-09-07  Kenichi Handa  <handa@etl.go.jp>

	* help.el (help-make-xrefs): Adjusted for the change of
	help-xref-mule-regexp.
	(help-insert-xref-button): New function.

	* international/mule-cmds.el (help-xref-mule-regexp-template):
	Include the pattern for character set.
	(leim): New group.

	* international/quail.el: Don't require face.
	(quail): New group.
	(quail-other-command): Dummy command to make quail-help work better.
	(quail-keyboard-layout-alist): Add Keyboard type "jp106".
	(quail-keyboard-layout-substitution): New variable.
	(quail-update-keyboard-layout): New function.
	(quail-keyboard-layout-type): New customizable variable.
	(quail-set-keyboard-layout): Call quail-update-keyboard-layout.
	(quail-keyboard-translate): Pay attention to
	quail-keyboard-layout-substitution.
	(quail-insert-kbd-layout): New function.
	(quail-show-keyboard-layout): New function.
	(quail-get-translation): If the definition is a vector of length
	1, and the element is a string of length 1, return the character
	in that string.
	(quail-update-current-translations): Fix the case of
	relative-index out of range.
	(quail-build-decode-map, quail-insert-decode-map): New Functions.
	(quail-help): Show keyboard layout by quail-insert-kbd-layout.
	Show key sequences for all available characters.
	(quail-help-insert-keymap-description): Don't show such verbose
	key bindings as quail-self-insert-command.

	* international/titdic-cnv.el (quail-cxterm-package-ext-info):
	Format changed, and each element now have extra documentations.
	(tit-process-header): Delete invalid characters from TIT-PROMPT.
	Adjusted for the change of quail-cxterm-package-ext-info.

2000-09-06  Gerd Moellmann  <gerd@gnu.org>

	* vc-hooks.el (toplevel): Don't require `vc' during compilation;
	requiring it leads to a recursive loading of vc.el and vc-hooks.el
	during bootstrap.

2000-09-05  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el: (toplevel): Don't require `dired' at run-time.
	(vc-dired-resynch-file): Remove autoload cookie.

2000-09-05  Andre Spiegel  <spiegel@gnu.org>

	* vc.el: Made several backend functions optional.
	(vc-default-responsible-p): New function.
	(vc-merge): Use RET for first version to trigger merge-news, not
	prefix arg.
	(vc-annotate): Handle backends that do not support annotation.
	(vc-default-merge-news): Removed.  The existence of a merge-news
	implementation is now checked on caller sites.

	* vc-hooks.el (vc-default-mode-line-string): Removed CVS special
	case.

	* vc-cvs.el (vc-cvs-mode-line-string): New function, handles the
	special case that has been removed from the default in vc-hooks.el.

2000-09-05  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-log-edit): Properly handle the case where FILE is nil.

2000-09-05  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el: Require vc during compilation.
	(vc-file-setprop): Use `vc-touched-properties' if bound by the new
	macro `with-vc-properties' in vc.el.
	(vc-file-getprop): Doc fix.
	(vc-after-save): Call `vc-dired-resynch-file' only if vc is loaded.

	* vc.el: Require dired-aux during compilation.
	(vc-name-assoc-file): Moved to vc-sccs.el.
	(with-vc-properties): New macro.
	(vc-checkin, vc-checkout, vc-revert, vc-cancel-version,
	vc-finish-steal): Use it.
	(vc-cancel-version): Moved RCS-specific code to vc-rcs.el.  The call
	to the backend-specific function is now supposed to do the checkout,
	too.
	(vc-log-edit): Handle FILE being nil and added a FIXME for log-edit.

	* vc-cvs.el (vc-cvs-checkin, vc-cvs-checkout): Don't bother to
	set file properties; that gets done in the generic code now.

	* vc-rcs.el (vc-rcs-uncheck): Renamed to `vc-rcs-cancel-version'.
	Changed parameter list, added code from vc.el that does the
	checkout, possibly with a double-take.

	* vc-sccs.el (vc-sccs-name-assoc-file): Moved here from vc.el.
	(vc-sccs-add-triple, vc-sccs-rename-file, vc-sccs-lookup-triple): Use
	the above under the new name.
	(vc-sccs-uncheck): Renamed to `vc-sccs-cancel-version'.  Changed
	parameter list, added checkout command.
	(vc-sccs-checkin, vc-sccs-checkout): Don't bother to set file
	properties; that gets done in the generic code now.

2000-09-05  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el: Docstring fixes (courtesy of checkdoc).

2000-09-05  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-checkout-writable-buffer-hook)
	(vc-checkout-writable-buffer): Remove.
	(vc-start-entry): Always call vc-log-edit, never vc-log-mode.
	(vc-log-mode): Make it into a clean derived major mode.
	(vc-log-edit): Mark buffer unmodified (as vc-log-mode did) and use
	vc-log-mode if log-edit is not available.
	(vc-dired-mode-map): Don't set-keymap-parent yet.
	(vc-dired-mode): Do set-keymap-parent here.
	(vc-dired-buffers-for-dir): Nop if dired is not loaded.

2000-09-05  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (set-face-attribute, face-spec-reset-face)
	(face-spec-set): Avoid consing by removing calls to `apply'.

	* frame.el (frame-parameter): Move to C code.

2000-09-05  Dave Love  <fx@gnu.org>

	* help.el (help-manyarg-func-alist): Add ml-prefix-argument-loop,
	insert-before-markers-and-inherit.  Now checked systematically!

2000-09-05  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-postgres): Use sql-postgres-options.
	(sql-postgres-options): New variable.

2000-09-05  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-mode-menu): Work around missing variable mark-active
	in XEmacs.
	(sql-mode): Added call to easy-menu-add for XEmacs compatibility.
	(sql-interactive-mode): Added call to easy-menu-add for XEmacs
	compatibility.

2000-09-04  Gerd Moellmann  <gerd@gnu.org>

	* vc.el (vc-dired-resynch-file): Add autoload cookie.

	* vc.el (toplevel): Require `dired' at run-time for dired-mode-map.

	* Makefile.in (DONTCOMPILE): Fix typo in file name.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc-sccs.el (vc-sccs-latest-on-branch-p): Always return t; we
	don't support anything else under SCCS yet.

	* vc-hooks.el: Minor doc fixes.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-next-action-on-file): Do not visit the file if it's
	not necessary.  If verbose in state `needs-patch', do the same as
	under `up-to-date'.  When NOT verbose and `needs-patch', check out
	latest version instead of `merge-news'.
	(vc-next-action-dired): Don't mess with default-directory here; it
	breaks other parts of dired.  It is the job of the
	backend-specific functions to adjust it temporarily if they need it.
	(vc-next-action): Remove a special CVS case.
	(vc-clear-headers): New optional arg FILE.
	(vc-checkin, vc-checkout): Set properties vc-state and
	vc-checkout-time properly.
	(vc-finish-steal): Call steal-lock, not steal, which doesn't exist.
	(vc-print-log): Use new backend function `show-log-entry'.
	(vc-cancel-version): Do the checks in a different order.  Added a
	FIXME concerning RCS-only code.

	* vc-rcs.el (vc-rcs-show-log-entry): New function.
	(vc-rcs-checkin, vc-rcs-checkout): Don't set all properties.

	* vc-cvs.el (vc-cvs-show-log-entry): New function.

	* vc-hooks.el (vc-default-mode-line-string): Show state
	`needs-patch' as a `-' too.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-responsible-backend): New optional arg REGISTER.
	(vc-default-could-register): New function.
	(vc-dired-buffers-for-dir, vc-dired-resynch-file): New functions.
	(vc-resynch-buffer): Call vc-dired-resynch-file.
	(vc-start-entry, vc-finish-logentry, vc-revert-buffer): Use
	vc-resynch-buffer instead of vc-resynch-window.
	(vc-next-action-dired): Don't redisplay here, that gets done as a
	result of the individual file operations.
	(vc-retrieve-snapshot): Corrected prompt order.

	* vc-hooks.el (vc-after-save): Call vc-dired-resynch-file.

	* vc-cvs.el (vc-cvs-stay-local): Allow it to be a hostname regexp
	as well.
	(vc-cvs-remote-p): Renamed to vc-cvs-stay-local-p.  Handle
	hostname regexps.  Updated all callers.
	(vc-cvs-responsible-p): Handle directories as well.
	(vc-cvs-could-register): New function.
	(vc-cvs-retrieve-snapshot): Parse "cvs update" output, keep file
	properties up-to-date.

	* vc-rcs.el (vc-rcs-register): If there is no RCS subdir, ask the
	user whether to create one.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-file-not-found-hook): Ask the user whether to
	check out a non-existing file.

	* vc-cvs.el (vc-cvs-checkout): Do the right thing when the
	workfile does not exist.

	* vc.el (vc-version-diff): Use `require' to check for existence of
	diff-mode.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc-cvs.el (vc-cvs-registered): Use new function
	vc-cvs-parse-entry to do the actual work.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-find-backend-function): If function doesn't
	exist, return nil instead of error.
	(vc-call-backend): Doc fix.

	* vc.el (vc-do-command): Doc fix.
	(vc-finish-logentry): When checking in from vc-dired, choose the
	right backend for logentry check.
	(vc-dired-mode-map): Inherit from dired-mode-map.
	(vc-dired-mode): Local value of dired-move-to-filename-regexp
	simplified.
	(vc-dired-state-info): Removed, updated caller.
	(vc-default-dired-state-info): Use parentheses instead of hyphens.
	(vc-dired-hook): Use vc-BACKEND-dir-state, if available.
	(vc-dired-listing-switches): New variable.
	(vc-directory): Use it, instead of dired-listing-switches.

	* vc-cvs.el (vc-cvs-remote-p): Allow FILE to be a directory, too.
	(vc-cvs-dir-state): New function.
	(vc-cvs-dir-state-heuristic): New function, subroutine of the above.
	(vc-cvs-parse-entry): New function, also to be used in
	vc-cvs-registered.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-revert-buffer): Hide the frame for dedicated windows
	*or* single-window-frames.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-update-changelog): Split into generic part and default
	implementation.  Doc string adapted.
	(vc-default-update-changelog): New function.  Call the `rcs2log'
	script in exec-directory, to fix a long-standing nuisance.

	* vc-sccs.el (vc-sccs-update-changelog): Dummy implementation that
	simply signals an error.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-cvs.el (vc-cvs-checkout): Slight restructuring to make the
	control-flow more clear and to avoid running `cvs' twice.

	* vc.el (vc-next-action-on-file): Doc fix.
	(vc-maybe-resolve-conflicts): Don't just toggle smerge-mode.
	(vc-print-log): Eval `file' before constructing the continuation.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-next-action-on-file): Corrected several messages.
	(vc-merge): Add prefix arg `merge-news'; handle it.

	* vc-cvs.el (vc-cvs-workfile-version): Removed comment that this
	is not reached.  It is.
	(vc-cvs-merge): Set state to 'edited after merge.
	(vc-cvs-merge-news): Set workfile version to nil if not known.
	(vc-cvs-latest-on-branch-p): Recommented.  Candidate for removal.

	* vc-*.el (vc-*-checkout): Switch off coding systems for checkout
	via stdout. (Merge from main line.)

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-finish-logentry): Thinko in the "same comment"
	detection.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-parent-buffer, vc-parent-buffer-name): Protect them
	against kill-all-local-variables.
	(vc-log-edit): Don't save vc-parent-buffer any more.
	(vc-last-comment-match): Initialize to an empty string.
	(vc-post-command-functions): New hook.
	(vc-do-command): Run it.
	(vc-next-action-on-file): Remove unnecessary pop-to-buffer.
	(vc-finish-logentry): Only add the comment to the ring if it's
	different from the last comment entered.
	(vc-new-comment-index): New function.
	(vc-previous-comment): Use it.  Make the minibuffer message
	slightly less terse.
	(vc-comment-search-reverse): Make it work forward as well.  Don't
	set vc-comment-ring-index if no match is found.  Use
	vc-new-comment-index.
	(vc-comment-search-forward): Use vc-comment-search-reverse.
	(vc-dired-mode-map): Don't inherit from dired-mode-map since
	define-derived-mode will do it for us.  Bind `v' to a keymap that
	inherits from vc-prefix-map so that we can bind `vt' without
	binding C-x v t.
	(vc-retrieve-snapshot): Parenthesis typo.

	* vc-cvs.el (vc-cvs-checkin): Raise the max-correct status from 0
	to 1.  Make sure to switch to *vc* before looking for an error
	message.  Use vc-parse-buffer.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-create-snapshot, vc-default-create-snapshot): Swap DIR
	and NAME.
	(vc-retrieve-snapshot): Split into two parts.
	(vc-default-retrieve-snapshot): New function.

	* vc-cvs.el ((vc-cvs-create-snapshot): Swap DIR and NAME.
	(vc-cvs-retrieve-snapshot): New function (untested).
	(vc-cvs-stay-local): Default to t.
	(vc-cvs-remote-p): New function and property.
	(vc-cvs-state): Stay local only if the above is t.
	(vc-handle-cvs): Removed.
	(vc-cvs-registered): Don't check vc-handle-cvs -- it should all be
	done via vc-handled-backends now.
	(vc-cvs-header): Escape Id.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-do-command): Remove unused commands.
	(vc-version-diff): Make sure default-directory ends with a slash.
	Move the window commands into a vc-exec-after.
	(vc-print-log): Move more of the code into the `vc-exec-after'.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-exec-after): Fix disassembly of previous sentinel.
	(vc-print-log): Search current revision from beginning of buffer.
	(vc-revert-buffer): Clear echo area after the diff is finished.
	(vc-prefix-map): Removed definition of "t" for terse display in vc
	dired.
	(vc-dired-mode-map): Inherit from dired-mode-map.  Added
	definition of "vt" for terse display.
	(vc-dired-mode): Fix dired-move-to-filename-regexp.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-exec-after): Avoid caddr.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-exec-after): New function.
	(vc-do-command): Use it to add a termination message for async
	procs.
	(vc-checkout): Try to handle a missing-backend situation.
	(vc-version-diff): Use vc-exec-after to fix the behavior for diffs
	of a directory with a backend using async diffs.
	(vc-print-log): Use vc-exec-after and use log-view-goto-rev if
	present.

	* vc-sccs.el (vc-sccs-state-heuristic): Use
	file-ownership-preserved-p.

	* vc-rcs.el (vc-rcs-state-heuristic): Use
	file-ownership-preserved-p.
	(vc-rcs-checkout): Remove the error-handling for missing-rcs.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc-sccs.el (vc-sccs-workfile-unchanged-p): Fix call to
	vc-do-command.

	* vc.el (vc-next-action-on-file): Use vc-revert-buffer to revert
	when there are no changes.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc-sccs.el (vc-sccs-state-heuristic): Don't use file-writable-p.

	* vc-rcs.el (vc-rcs-state-heuristic): Don't use file-writable-p.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-hooks.el (vc-prefix-map): Move the autoload from vc.el.

	* vc.el (vc-prefix-map): Move the autoload to vc-hooks.el and move
	the `fset' outside of the defvar so that it works even if
	vc-prefix-map was already defined.
	(vc-setup-buffer): New function, split out of vc-do-command.
	(vc-do-command): Allow BUFFER to be t to mean `just use the
	current buffer without any fuss'.
	(vc-version-diff): Change the `diff' backend operation to just put
	the diff in the current buffer without erasing it.  Always use
	*vc-diff* even for directory-diffs.  Use vc-setup-buffer.  Protect
	shrink-window-if-larger-than-buffer.
	(vc-print-log): Change the `print-log' backend operation to just
	put the log in the current buffer without erasing it.  Protect
	shrink-window-if-larger-than-buffer.
	(vc-update-change-log): Fix setd typo.

	* vc-sccs.el (vc-sccs-workfile-unchanged-p): Fix parenthesis.
	(vc-sccs-print-log, vc-sccs-diff): Insert in the current buffer.

	* vc-rcs.el (vc-rcs-print-log): Insert in the current buffer.
	(vc-rcs-diff): Insert in the current buffer and remove unused arg
	CMP.

	* vc-cvs.el (vc-cvs-state, vc-cvs-fetch-status): Use
	with-temp-file.  Use the new BUFFER=t argument to vc-do-command.
	(vc-cvs-print-log, vc-cvs-diff): Insert in the current buffer.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-workfile-unchanged-p): If checkout-time comparison is
	not possible, use vc-BACKEND-workfile-unchanged-p.
	(vc-default-workfile-unchanged-p): New function.  Delegates to a
	full vc-BACKEND-diff.

	* vc-hooks.el (vc-simple-command): Removed.

	* vc-rcs.el (vc-rcs-workfile-unchanged-p): Use vc-do-command
	instead of vc-simple-command.
	(vc-rcs-fetch-master-state): Removed check for unlocked-changes to
	avoid doing a diff when opening a file.
	(vc-rcs-state): Added check for unlocked-changes.
	(vc-rcs-header): Escape Id.
	(vc-rcs-workfile-unchanged-p): Remove optional arg VERSION.
	(vc-rcs-state): Call vc-workfile-unchanged-p, not the RCS-specific
	version.

	* vc-sccs.el (vc-sccs-workfile-unchanged-p): Rewritten.
	(vc-sccs-diff): Remove optional arg CMP.
	(vc-sccs-state): Call vc-workfile-unchanged-p, not the
	SCCS-specific function.

	* vc-cvs.el (vc-cvs-state): Use vc-do-command instead of
	vc-simple-command.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-editable-p): Renamed from vc-writable-p.
	(with-vc-file, vc-merge): Use vc-editable-p.
	(vc-do-command): Remove unused var vc-file and fix the
	doubly-defined `status' var.  Add a user message when starting an
	async command.
	(vc-restore-buffer-context, vc-resynch-buffer, vc-start-entry)
	(vc-finish-steal, vc-checkin, vc-finish-logentry, vc-rename-file):
	Use with-current-buffer.
	(vc-buffer-sync): Use unless.
	(vc-next-action-on-file): If the file is 'edited by read-only,
	make it read-write instead of trying to commit.
	(vc-version-diff, vc-update-change-log): Use `setq
	default-directory' rather than `cd'.
	(vc-log-edit): Don't forget to set default-directory in the
	buffer.

	* vc-sccs.el (vc-sccs-state): Fix obviously wrong parenthesis.
	(vc-sccs-state-heuristic): Use file-writable-p instead of
	comparing userids.
	(vc-sccs-checkout): Use `unless'.

	* vc-rcs.el (vc-rcs-state-heuristic): Use file-writable-p instead
	of comparing userids.
	(vc-rcs-fetch-master-state): Handle the case where rcs is missing.
	Simplify the logic by eliminating unreachable code.
	(vc-rcs-diff): Only pass `2' to vc-do-command if necessary and
	just do a recursive call if we need to retry.
	(vc-rcs-checkout): Handle the case where rcs is missing by making
	the buffer read-write if requested and re-signalling the error.

	* vc-cvs.el (vc-cvs-diff): Remove unused and unsupported argument CMP.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-hooks.el (vc-handled-backends): Docstring change.
	(vc-ignore-vc-files): Mark obsolete.
	(vc-registered): Check vc-ignore-vc-files.
	(vc-find-file-hook, vc-file-not-found-hook): Don't check
	vc-ignore-vc-files.

	* vc-cvs.el (vc-cvs-registered): Obey vc-handle-cvs.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-checkout): Don't do anything special for ange-ftp
	files since ange-ftp already has vc-registered return nil.

	* vc-sccs.el (vc-sccs-state): Use with-temp-buffer.
	(vc-sccs-workfile-version): Use with-temp-buffer and new
	vc-parse-buffer and don't bother setting the property.
	(vc-sccs-add-triple): Use with-current-buffer and
	find-file-noselect.
	(vc-sccs-lookup-triple): New vc-parse-buffer and turn cond -> if.

	* vc-rcs.el (vc-rcs-find-most-recent-rev): New function.  The code
	derives from the old vc-parse-buffer but uses the revision number
	rather than the date (much easier to compare robustly).
	(vc-rcs-fetch-master-state): Use `with-temp-buffer'.  Adapt to the
	new vc-parse-buffer (and vc-rcs-find-most-recent-rev).  Find the
	locking-user more directly.  Check strict locking and set
	checkout-model appropriately.
	(vc-rcs-parse-locks): Remove.
	(vc-rcs-latest-on-branch-p): Use with-temp-buffer and adapt to the
	new vc-parse-buffer (and vc-rcs-find-most-recent-rev).
	(vc-rcs-system-release): Use with-current-buffer and
	vc-parse-buffer.
	(vc-rcs-register, vc-rcs-checkout): Use with-current-buffer.

	* vc-hooks.el (vc-parse-buffer): Lobotomize the monster.
	(vc-simple-command): Docstring fix.
	(vc-registered): Align the way the file-handler is called with the
	way the function itself works.
	(vc-file-owner): Remove.

	* vc-cvs.el (vc-cvs-registered): Use with-temp-buffer.  Reorder
	extraction of fields and call to file-attributes because of a
	temporary bug in rcp.el.
	(vc-cvs-fetch-status): Use with-current-buffer.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-do-command): Use file-relative-name.
	(vc-responsible-backend): Use vc-backend if possible.
	(vc-create-snapshot): Improve the `interactive' spec. Add support
	for branches and dispatch to backend-specific `create-snapshot'.
	(vc-default-create-snapshot): New function, containing the bulk of
	the old vc-create-snapshot.
	(vc-retrieve-snapshot): Improve the interactive spec.

	* vc-hooks.el (vc-header-alist): Move the dummy def from vc.el.
	(vc-backend-hook-functions): Remove.
	(vc-find-backend-function): Don't try to load vc-X-hooks anymore.
	(vc-backend): Reintroduce the test for `file = nil' now that I
	know why it was there (and added a comment to better remember).

	* vc-sccs-hooks.el: Merge into vc-sccs.el * vc-sccs.el: Merge in
	code from vc-sccs-hooks.el.
	(vc-sccs-release, vc-sccs-system-release): Remove.  Don't require
	'vc anymore.
	(vc-sccs-responsible-p): Use expand-file-name instead of concat
	and file-directory-p instead of file-exists-p.
	(vc-sccs-check-headers): Simplify the regexp.

	* vc-rcs-hooks.el: Merge into vc-rcs.el * vc-rcs.el: Merge in code
	from vc-rcs-hooks.el.  Don't require 'vc anymore.
	(vc-rcs-responsible-p): Use expand-file-name instead of concat and
	file-directory-p instead of file-exists-p.

	* vc-cvs-hooks.el: Merge into vc-cvs.el * vc-cvs.el: Merge in code
	from vc-cvs-hooks.el.
	(proto vc-cvs-registered): Require 'vc-cvs instead of
	'vc-cvs-hooks.  Don't require 'vc anymore.
	(vc-cvs-responsible-p): Use expand-file-name instead of concat and
	file-directory-p instead of file-exists-p.
	(vc-cvs-create-snapshot): New function, replacing
	vc-cvs-assign-name.
	(vc-cvs-assign-name): Remove.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-cvs.el (vc-cvs-header): New var.

	* vc-rcs.el (vc-rcs-exists): Remove.
	(vc-rcs-header): New var.

	* vc-sccs.el (vc-sccs-responsible-p, vc-sccs-register): Use
	`vc-sccs-search-project-dir' instead of `vc-sccs-project-dir'.
	(vc-sccs-header): New var.

	* vc.el (vc-do-command): Get rid of the `last' argument.
	(vc-header-alist): Remove, replaced by vc-X-header.
	(vc-insert-headers): Use vc-X-header instead of vc-header-alist.
	(vc-dired-hook): Use expand-file-name instead of concat.
	(vc-directory): Use file-name-as-directory.
	(vc-snapshot-precondition, vc-create-snapshot)
	(vc-retrieve-snapshot): Allow the command to operate on any
	directory.

	* vc-{rcs,sccs,cvs}.el: Update calls to vc-do-command by either
	just removing the 'WORKFILE argument or by removing the 'MASTER
	argument and replacing `file' with (vc-name file).

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el: Update Copyright and add a crude list of backend funs.
	(vc-writable-p): New function.
	(with-vc-file): Use vc-writable-p.
	(vc-next-action-on-file): Update call to vc-steal-lock and cleanup.
	(vc-register): Avoid vc-name.
	(vc-locking-user): Remove.
	(vc-steal-lock): Make the `owner' arg non-optional.
	(vc-merge): Use vc-writable-p instead of vc-locking-user and
	vc-checkout-model.
	(vc-default-dired-state-info): Use vc-state instead of
	vc-locking-user and return special strings for special states.
	(vc-dired-hook): Use vc-up-to-date-p instead of vc-locking-user
	and get rid of one of the special CVS cases.
	(vc-cancel-version): prettify error message with \\[...].
	(vc-rename-master): New function.
	(vc-rename-file): Use vc-BACKEND-rename-file (which might in turn
	use vc-rename-master) instead of vc-BACKEND-record-rename.  Make
	the CVS special case generic.
	(vc-default-record-rename): Remove.
	(vc-file-tree-walk-internal): Only call FUNC for files that are
	under control of some VC backend and replace `concat' with
	expand-file-name.
	(vc-file-tree-walk): Update docstring.
	(vc-version-diff, vc-snapshot-precondition, vc-create-snapshot)
	(vc-retrieve-snapshot): Update call to vc-file-tree-walk.

	* vc-sccs.el (vc-sccs-rename-file): Renamed from
	vc-sccs-record-rename.  Use `find-file-noselect' rather than
	`find-file' and call `vc-rename-master' to do the actual move.
	(vc-sccs-diff): Remove unused `backend' variable.

	* vc-sccs-hooks.el (vc-sccs-registered): Preloaded trivial version
	to delay loading of vc-sccs until it is really used.
	(vc-sccs-master-templates): Preload.
	(vc-sccs-state): Update call to vc-sccs-parse-locks.
	(vc-sccs-project-dir): Remove (merged into
	vc-sccs-search-project-dir).
	(vc-sccs-search-project-dir): Rewrite using file name handling ops
	rather than `concat', make sure it is preloaded and don't bother
	to check that the file actually exists.
	(vc-sccs-parse-locks): Remove unused `file' argument, remove
	`locks' argument (use buffer's content instead) and eliminate n^2
	behavior.

	* vc-rcs.el: Update Copyright.
	(vc-rcs-rename-file): New function.
	(vc-rcs-diff): Remove unused `backend' variable.

	* vc-hooks.el: Update Copyright.
	(vc-backend): Don't accept a nil argument any more.
	(vc-up-to-date-p): Turn into a defsubst.
	(vc-possible-master): New function.
	(vc-check-master-templates): Use `vc-possible-master' and allow
	funs in vc-X-master-templates to return a non-existent file.

	* vc-cvs.el: Update Copyright.
	(vc-cvs-diff): Remove unused `backend' variable.
	(vc-cvs-checkout): Only toggle read-only if the buffer is setup right.

	* vc-cvs-hooks.el: Preload a proto vc-cvs-registered.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-rcs-hooks.el (vc-rcs-registered): Provide a trivial version
	since it can be called from vc-rcs.el.
	(vc-rcs-parse-locks): Cleanup to remove an n^2 behavior.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-version-diff): Expand file name read from the
	minibuffer.  Handle the case when a previous version number can't
	be guessed.  Give suitable messages when there were no differences
	found.
	(vc-clear-headers): Call backend-specific implementation, if one
	exists.
	(vc-cancel-version): Made error checks generic.  When done, clear
	headers generically, too.

	* vc-rcs.el (vc-rcs-clear-headers): New function; code moved here
	from vc-clear-headers in vc.el.

	* vc-rcs-hooks.el (vc-rcs-fetch-master-state): Use vc-parse-buffer
	correctly.
	(vc-rcs-latest-on-branch-p): Made second argument VERSION
	optional.  Handle the case when it's not there.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-locking-user): Moved from vc-hooks.el.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-hooks.el (vc-loadup): Remove.
	(vc-find-backend-function): Use `require'.  Also, handle the case
	where vc-BACKEND-hooks.el doesn't exist.
	(vc-call-backend): Cleanup.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-rcs-hooks.el (vc-rcs-templates-grabbed,
	vc-rcs-grab-templates)
	(vc-rcs-registered): Remove.  The default function works as well.
	* vc-sccs-hooks.el (vc-sccs-templates-grabbed,
	vc-sccs-grab-templates)
	(vc-sccs-registered): Remove.  The default function works as well.

	* vc.el (vc-version-diff): Left out a vc- in call to
	vc-call-backend.
	(vc-default-dired-state-info, vc-default-record-rename)
	(vc-default-merge-news): Update for the new backend argument.

	* vc-hooks.el (vc-find-backend-function): Return a cons cell if
	using the default function.
	(vc-call-backend): If calling the default function, pass it the
	backend as first argument.  Update the docstring accordingly.
	(vc-default-state-heuristic, vc-default-mode-line-string): Update
	for the new backend argument.
	(vc-make-backend-sym): Renamed from vc-make-backend-function.
	(vc-find-backend-function): Use the new name.
	(vc-default-registered): New function.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-merge): Use vc-find-backend-function.

	* vc-hooks.el (vc-backend-functions): Remove.
	(vc-loadup): Don't setup 'vc-functions.
	(vc-find-backend-function): New function.
	(vc-call-backend): Use above fun and populate 'vc-functions
	lazily.
	(vc-backend-defines): Remove.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-register): Put a FIXME note for a newly found bug.
	Call vc-call-backend without the leading vc-.
	(vc-responsible-backend, vc-finish-logentry, vc-annotate)
	(vc-check-headers): Call vc-call-backend without the leading vc-.
	(vc-annotate-time-span): Replace confusing use of `cond' with `or'.
	(vc-annotate-display): Replace confusing use of `cond' with `or'.
	Call vc-call-backend without the leading vc-.

	* vc-cvs.el (tail): Provide vc-cvs.
	* vc-sccs.el (tail): Provide vc-sccs.
	* vc-rcs.el (tail): Provide vc-rcs and remove vc-rcs-logentry-check.

	* vc-hooks.el (vc-backend-hook-functions, vc-backend-functions)
	(vc-make-backend-function, vc-call): Pass names without leading
	`vc-' to vc-call-backend so we can blindly prefix them with vc-BACKEND.
	(vc-loadup): Don't load vc-X-hooks if vc-X is requested.
	(vc-call-backend): Always try to load vc-X-hooks.
	(vc-registered): Remove vc- in call to vc-call-backend.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-process-filter): New function.
	(vc-do-command): Setup `vc-process-filter' for the async process.
	(vc-maybe-resolve-conflicts): New function to reduce
	code-duplication.  Additionally, it puts the buffer in
	`smerge-mode' if applicable.
	(vc-next-action-on-file): Use `vc-maybe-resolve-conflicts' after
	calling `merge-news'.
	(vc-merge): Use `vc-maybe-resolve-conflicts' after calling `merge'.
	(vc-log-edit): New function.  Replacement for `vc-log-mode' by
	interfacing to log-edit.el.
	(vc-start-entry): Call `vc-log-edit' instead of `vc-log-mode' if
	log-edit is available.
	(vc-resolve-conflicts): Delegate to `smerge-ediff' if available.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-register): Remove `vc-buffer-backend' setup.
	(vc-log-mode-map): New name for vc-log-entry-mode and merge the
	defvar and the initialization.
	(vc-log-mode): Minor docstring fix and use vc-log-mode-map.

	* vc-hooks.el (vc-default-back-end, vc-buffer-backend): Remove.
	(vc-kill-buffer-hook): Remove `vc-buffer-backend' handling.

	* vc-cvs-hooks.el (vc-handle-cvs): Make it a defvar and add a FIXME.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-file-clear-masterprops): Removed.
	(vc-checkin, vc-revert-buffer): Removed calls to the above.
	(vc-version-diff): Use buffer-size without argument.
	(vc-register): Heed vc-initial-comment.

	* vc-rcs-hooks.el (vc-rcs-fetch-master-state): Fix regexp for
	default branch.

	* vc-rcs.el (vc-rcs-register): Parse command output to find master
	file name and workfile version.
	(vc-rcs-checkout): Removed call to vc-file-clear-masterprops.

	* vc-cvs.el (vc-cvs-merge-news, vc-cvs-checkout): Removed call to
	vc-file-clear-masterprops.

	* vc-sccs.el (vc-sccs-checkout): Removed call to
	vc-file-clear-masterprops.  If writable, set vc-state to 'edited
	rather than user login name.


2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-workfile-unchanged-p): Remove unused argument
	`want-differences-if-changed' and simplify.
	(vc-next-action-on-file) [needs-merge]: Resynch the buffer.
	(vc-revert-buffer): Use `unchanged-p' rather than vc-diff's status
	output (which is invalid for async vc-diff) to decide whether to
	do the revert silently or not.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-hooks.el (vc-loadup): Load files quietly.
	(vc-call-backend): Oops, brain fart.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-cvs.el (vc-cvs-state): Typo.
	(vc-cvs-merge-news): Return the status code rather than the error msg.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (with-vc-file, vc-next-action, vc-version-diff)
	(vc-dired-mark-locked): Replaced usage of vc-locking-user with
	vc-state or vc-up-to-date-p.
	(vc-merge): Use vc-backend-defines to check whether merging is
	possible.  Set state to 'edited after successful merge.

	* vc-hooks.el (vc-locking-user): If locked by the calling user,
	return that name.  Redocumented.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-recompute-state, vc-next-action-on-file): Update to
	new `vc-state' semantics.
	(vc-finish-steal): Set 'vc-state to 'edited rather than setting
	'vc-locking-user to the current user.
	(vc-merge): Inline vc-backend-merge.  Comment out code that I
	don't understand and hence can't adapt to the new `vc-state' and
	`vc-locking-user' semantics.
	(vc-backend-merge): Remove.

	* vc-{sc,r}cs.el (vc-{sc,r}cs-check{in,out}): Update 'vc-state
	rather than 'vc-locking-user.

	* vc-rcs-hooks.el (vc-rcs-consult-headers): Adapt to new `vc-state'.

	* vc-hooks.el (vc-user-login-name): Simplify the code a tiny bit.
	(vc-state): Don't use 'reserved any more.  Just use the same
	convention as the one used for vc-<backend>-state where the
	locking user (as a string) is returned.
	(vc-locking-user): Update, based on the above convention. The
	'vc-locking-user property has disappeared.
	(vc-mode-line, vc-default-mode-line-string): Adapt to new `vc-state'.

	* vc-cvs.el (vc-cvs-state): Don't overwrite a non-heuristic state
	with a heuristic one.
	(vc-cvs-merge-news): Just use 'edited for the case with conflicts.
	(vc-cvs-checkin): Do a trivial parse to set the state in case of
	error.  That allows us to get to 'needs-merge even in the
	stay-local case.  There's still no way to detect 'needs-patch in
	such a setup (or to force an update for that matter).
	(vc-cvs-logentry-check): Remove, the default works as well.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-cvs.el (vc-cvs-print-log, vc-cvs-diff): Run cvs asynchronously.

	* vc.el (vc-do-command): kill-all-local-variables, to reset any
	major-mode in which the buffer might have been put earlier.  Use
	`remove' and `when'.  Allow `okstatus' to be `async' and use
	`start-process' in this case.
	(vc-version-diff): Handle the case where the diff looks empty
	because of the use of an async process.

2000-09-04  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-next-action-on-file): Removed optional parameter
	`simple'.  Recompute state unconditionally.
	(vc-default-toggle-read-only): Removed.

	* vc-hooks.el (vc-backend-functions): Removed vc-toggle-read-only.
	(vc-toggle-read-only): Undid prev change.

	* vc-cvs.el (vc-cvs-stay-local): Renamed from
	vc-cvs-simple-toggle.  Redocumented.
	(vc-cvs-state): If locality is wanted, use vc-cvs-state-heuristic.
	(vc-cvs-toggle-read-only): Removed.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-backend-dispatch, vc-annotate-mode-syntax-table): Remove.
	(vc-prefix-map): Move from vc-hooks.el and make autoloaded.
	(vc-release-greater-or-equal-p): Move to vc-rcs.el.
	(vc-file-clear-masterprops): Braindead "fix".  It was a nop and
	still is. So maybe it should be removed.
	(vc-head-version, vc-find-binary): Remove.
	(vc-recompute-state): Move from vc-hooks.el.
	(vc-next-action-on-file): Add a `simple' argument to allow
	avoiding the `recompute' step (use for vc-cvs-simple-toggle).
	(vc-default-toggle-read-only, vc-default-record-rename): New funs.
	(vc-next-action, vc-dired-hook): Use vc-state instead of vc-cvs-status.
	(vc-dired-mode-map): Properly defvar it.
	(vc-print-log): Call log-view-mode if available.
	(small-temporary-file-directory): defvar instead of use boundp.
	(vc-merge-news): Moved to vc-cvs.el.
	(vc-default-merge-news): New function.

	* vc-sccs.el: Require 'vc and 'vc-sccs-hooks.
	(vc-sccs-register-switches): New var, copied off of vc-rcs-hooks.
	(vc-sccs-latest-on-branch-p): Add a `FIXME' for a call to the
	unknown `vc-latest-version' function.  It should probably refer to
	vc-workfile-version or somesuch, but it's very unclear to me and I
	don't have SCCS to test things.

	* vc-sccs-hooks.el: Provide 'vc-sccs-hooks.
	(vc-sccs-state-heuristic): Fix typo.
	(vc-sccs-workfile-unchanged-p): Add missing argument.

	* vc-rcs.el: Require vc and vc-rcs-hooks.
	(vc-rcs-trunk-p, vc-rcs-branch-part): Move to vc-rcs-hooks.
	(vc-rcs-backend-release-p): Remove (use vc-rcs-release-p).
	(vc-release-greater-or-equal-p): Move from vc.
	(vc-rcs-trunk-p, vc-rcs-branch-p, vc-rcs-branch-part,
	vc-rcs-minor-part, vc-rcs-previous-version): Remove duplicates.
	(vc-rcs-checkout): Add a missing `new-version' argument in the
	call to vc-rcs-latest-on-branch-p.  Hopefully that was the right one.

	* vc-rcs-hooks.el: Provide 'vc-rcs-hooks.
	(vc-rcs-trunk-p, vc-rcs-branch-part): Moved from vc-rcs.el.
	(vc-rcs-latest-on-branch-p): Use the `version' argument rather
	than the apparently unbound `workfile-version'.

	* vc-hooks.el (vc-master-templates): Def the obsolete var.
	(vc-file-prop-obarray): Use `make-vector'.
	(vc-backend-functions): Add new hookable functions
	vc-toggle-read-only, vc-record-rename and vc-merge-news.
	(vc-loadup): If neither backend nor default functions exist, use
	the backend function rather than nil.
	(vc-call-backend): If the function if not bound yet, try to load
	the non-hook file to see if it provides it.
	(vc-call): New macro plus use it wherever possible.
	(vc-backend-subdirectory-name): Use neither `vc-default-back-end'
	nor `vc-find-binary' since it's only called from
	vc-mistrust-permission which is only used once the backend is known.
	(vc-checkout-model): Fix parenthesis.
	(vc-recompute-state, vc-prefix-map): Move to vc.el.

	* vc-cvs.el: Require 'vc and 'vc-cvs-hooks (for compiler warnings).
	(vc-cvs-release, vc-cvs-system-release): Remove.
	(vc-cvs-use-edit, vc-cvs-simple-toggle): New config variables.
	(vc-cvs-dired-state-info): Use `cvs-state' and slightly different
	status symbols.
	(vc-cvs-parse-status, vc-cvs-state): Move from vc-cvs-hooks.el.
	(vc-cvs-toggle-read-only): First cut at a function to allow a
	cvs-status-free vc-toggle-read-only.
	(vc-cvs-merge-news): Move from cvs-merge-news in vc.el.
	(vc-cvs-checkin): Use vc-recompute-state+vc-state instead of
	vc-cvs-status.  Also set vc-state rather than vc-locking-user.
	(vc-cvs-checkout): Modify access rights directly if the user
	requested not to use `cvs edit'.  And refresh the mode line.

	* vc-cvs-hooks.el: Provide 'vc-cvs-hooks.
	(vc-cvs-state, vc-cvs-parse-status): Move to vc-cvs.el.

2000-09-04  Stefan Monnier  <monnier@cs.yale.edu>

	* vc-cvs.el (vc-cvs-checkout): Docstring fix.  Added a `(if
	workfile' that got lost when the code was extracted from vc.el.
	And merged the tail with the rest of the code (not possible in the
	old vc.el where the tail was shared among all backends).  And
	explicitly set the state to 'edited if `writable' is set.

	* vc-cvs-hooks.el (vc-cvs-registered): Use expand-file-name.
	(vc-cvs-state): Be careful to return the value from
	vc-cvs-parse-state.
	(vc-cvs-parse-status): Use expand-file-name.  Don't set 'vc-state
	property but return it instead.  Also be careful to handle a nil
	or "" `rev' when workfile is non-nil (it was handled properly when
	workfile was nil).

	* vc.el: Removed those pesky unnecessary `(function' quotes.
	(vc-annotate-mode-map, vc-annotate-mode-syntax-table): Initialize
	directly in the defvar.
	(vc-do-command): Bind inhibit-read-only so as to properly handle
	the case where the destination buffer has been made read-only.
	(vc-diff): Delegate to vc-version-diff in all cases.
	(vc-version-diff): Setup the *vc-diff* buffer as was done in vc-diff.
	(vc-annotate-mode-variables): Removed (code moved partly to
	defvars and partly to vc-annotate-add-menu).
	(vc-annotate-mode): Turned into a derived-mode.
	(vc-annotate-add-menu): Moved in code in
	vc-annotate-mode-variables.
	(vc-update-change-log): Use make-temp-file if available.

2000-09-04  Martin Lorentzson  <martinl@delysid.gnu.org>

	* vc-cvs.el (vc-cvs-revert,vc-cvs-checkout): References to
	`vc-checkout-model' updated to `vc-cvs-update-model'.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-next-action-on-file): Added handling of state
	`unlocked-changes'.
	(vc-checkout-carefully): Is now practically obsolete, unless the
	above is too slow to be enabled unconditionally.
	(vc-update-change-log): Fixed typo.

	* vc-sccs.el (vc-sccs-steal-lock): Renamed from `vc-sccs-steal'.

	* vc-sccs-hooks.el (vc-sccs-state): Somewhat rewritten.
	Now handles state `unlocked-changes'.
	(vc-sccs-workfile-unchanged-p): New function, to support the above.

	* vc-rcs.el (vc-rcs-steal-lock): Renamed from `vc-rcs-steal'.

	* vc-rcs-hooks.el (vc-rcs-state): Fixed typo.
	(vc-rcs-fetch-master-state): Bug fixes.  Recognize state
	`unlocked-changes'.
	(vc-rcs-workfile-unchanged-p): Renamed from
	`vc-rcs-workfile-unchanged'.  This is not a real backend-specific
	function yet, but supposed to become one soon.

	* vc-hooks.el (vc-backend-functions): Renamed `vc-steal' to
	`vc-steal-lock'.
	(vc-call-backend): Changed error message.
	(vc-state): Added description of state `unlocked-changes'.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-cvs-hooks.el (vc-cvs-registered): Fixed bug that caused it to
	always return t in CVS-controlled directories.

	* vc.el (vc-responsible-backend): New function.
	(vc-register): Largely rewritten.
	(vc-admin): Removed (implementation moved into vc-register).
	(vc-checkin): Redocumented.
	(vc-finish-logentry): If no backend defined yet (because we are in
	the process of registering), use the responsible backend.

	* vc-hooks.el (vc-backend-hook-functions, vc-backend-functions):
	Updated function lists.
	(vc-call-backend): Fixed typo.

	* vc-sccs.el, vc-rcs.el, vc-cvs.el (vc-BACKEND-responsible-p):
	New functions.
	(vc-BACKEND-register): Renamed from `vc-BACKEND-admin'.
	Removed query option.  Redocumented.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-rcs.el, vc-cvs.el: Updated everything to use `vc-checkout-model'.

	* vc.el: Updated callers of `vc-checkout-required' to use
	`vc-checkout-model'.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-rcs.el (vc-rcs-backend-release-p): function added.  other
	stuff updated to reference this function instead of the old
	`vc-backend-release-p'.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-sccs-hooks.el (vc-uses-locking): Renamed to
	vc-checkout-model.  Return appropriate values.  Updated callers.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc.el (vc-backend-release, vc-backend-release-p): Moved to vc-rcs.el.
	(vc-backend-revert): Function moved into `vc-revert';
	`vc-next-action' must be updated to accomodate this change.
	(vc-backend-steal): Function moved into `vc-finish-steal'.
	(vc-backend-logentry-check): Function moved into
	`vc-finish-logentry'.
	(vc-backend-printlog): Function moved into `vc-print-log'.
	(vc-backend-uncheck): Function moved into `vc-cancel-version'.
	(vc-backend-assign-name): Function moved into
	`vc-create-snapshot'.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-rcs-hooks.el, vc-cvs-hooks.el (vc-uses-locking):
	Rename to vc-checkout-model.  Return appropriate values.
	Update callers.

	* vc-hooks.el (vc-backend-hook-functions): Rename vc-uses-locking
	to vc-checkout-model.
	(vc-checkout-required): Rename to vc-checkout-model.
	Re-implement and re-comment.
	(vc-after-save): Use vc-checkout-model.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc.el (vc-workfile-unchanged-p,vc-diff,vc-version-diff):
	Update to use the vc-BACKEND-diff functions instead.
	`vc-diff' is now working.

	* vc-rcs.el (vc-rcs-logentry-check): New function.

	* vc-cvs.el (vc-cvs-logentry-check): New function.

	* vc-sccs.el (vc-sccs-diff): Function changed name from
	`vc-backend-diff'.  This makes `vc-diff' work.

	* vc-hooks.el (vc-backend-functions): Add `vc-diff' to the list
	of functions possibly implemented in a vc-BACKEND library.
	(vc-checkout-required): Fix bug that caused an error to be
	signaled during `vc-after-save'.

	* vc.el: Fix typo.
	This checkin is made with our new VC code base for the very first time.
	A simple `(vc-checkin (buffer-file-name))' was used to perform it.

	* vc-cvs.el (vc-cvs-revert,vc-cvs-checkout): Function calls to
	`vc-checkout-required' updated to `vc-cvs-uses-locking'.

	* vc-hooks.el (vc-backend-hook-functions): `vc-checkout-required'
	updated to `vc-uses-locking'.
	(vc-checkout-required): Call to backend function.
	`vc-checkout-required' updated to `vc-uses-locking' instead.

	* vc-rcs-hooks.el (vc-rcs-fetch-master-state): Function calls to
	`vc-checkout-required' updated to `vc-rcs-uses-locking'.

	* vc.el (vc-checkin): Merge with `vc-backend-checkin' and update
	to match the split into various backends.
	(vc-backend-checkin): Remove.  Merge with `vc-checkin'.
	(vc-retrieve-snapshot): Bug fix.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-sccs.el (vc-sccs-release): Doc fix.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc.el (vc-next-action-on-file): Bug found and fixed.
	(vc-checkout, vc-version-other-window, vc-retrieve-snapshot)
	(vc-cancel-version): Handle of vc-BACKEND-checkout updated.

	* vc-rcs.el (vc-rcs-checkin, vc-rcs-previous-version)
	(vc-rcs-checkout): Name space cleaned up.  No more revision number
	crunching function names that are not prefixed with vc-rcs.
	(vc-rcs-checkout-model): Function added.  References to
	`vc-checkout-model' replaced.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-next-action-on-file): Rewritten for the new state model.
	(vc-backend-merge-news): Renamed to `vc-merge-news'.  (Specific parts
	still need to be split, and implemented for RCS).

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-sccs-hooks.el (vc-sccs-state-heuristic): Bug found and fixed.

	* vc-sccs.el (vc-sccs-admin): Added the query-only option as
	required by the vc.el file.

	* vc-rcs.el (vc-rcs-admin): Added the query-only option as
	required by the vc.el file.
	(vc-rcs-exists): Function added.

	* vc-cvs.el (vc-cvs-admin): Added the query-only option as
	required by the vc.el file.

	* vc.el (vc-admin): Updated to handle selection of appropriate
	backend.  Current implementation is crufty and need re-thinking.

	* vc-hooks.el (vc-parse-buffer): Bug found and fixed.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-cvs.el (vc-cvs-annotate-difference): Updated to handle
	beginning of annotate buffers correctly.

	* vc.el (vc-annotate-get-backend, vc-annotate-display-default)
	(vc-annotate-add-menu, vc-annotate, vc-annotate-display): Annotate
	functionality updated quite a lot to support multiple backends.
	Variables `vc-annotate-mode', `vc-annotate-buffers',
	`vc-annotate-backend' added.

	* vc-hooks.el (vc-backend-functions): `vc-annotate-command',
	`vc-annotate-difference' added to supported backend functions.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-rcs.el, vc-sccs.el, vc-cvs.el (vc-*-checkout):
	Use with-temp-file instead of /bin/sh.  Merged from mainline

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-sccs-hooks.el (vc-sccs-registered): Updated.

	* vc-rcs-hooks.el (vc-rcs-registered): Updated.

	* vc-cvs-hooks.el (vc-cvs-registered): Updated.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-hooks.el: vc-state-heuristic added to
	vc-backend-hook-functions.

	* vc-sccs-hooks.el (vc-sccs-registered): Bug fix.

	* vc-rcs-hooks.el (vc-rcs-registered): Bug fix.

	* vc.el, vc-sccs-hooks.el, vc-rcs-hooks.el, vc-hooks.el: Rename
	`vc-uses-locking' to `vc-checkout-required'.  Rename the `locked'
	state to `reserved'.

	* vc-cvs.el, vc-cvs-hooks.el: Rename `vc-uses-locking' to
	`vc-checkout-required'.  Rename the `locked' state to `reserved'.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-rcs-hooks.el: Implement new state model.  Hardly anything
	untouched.

	* vc-rcs.el (vc-rcs-latest-on-branch-p): Move to vc-rcs-hooks.el.

	* vc.el (vc-update-change-log): Use small-temporary-file-directory,
	if defined.  (Merged from main line, slightly adapted.)

	* vc-cvs.el (vc-cvs-annotate-difference): Handle possible
	millenium problem (merged from mainline).

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-cvs.el: Split the annotate feature into a BACKEND-specific
	part and moved the non-BACKEND stuff to vc.el.

	* vc.el: Split the annotate feature into a BACKEND specific part
	and moved it from the vc-cvs.el file to this one.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el: Implement new state model.
	(vc-state, vc-state-heuristic, vc-default-state-heuristic): New funs.
	(vc-locking-user): Simplify.  Now only needed if the file is
	locked by somebody else.
	(vc-lock-from-permissions): Remove.  Functionality is in
	vc-sccs-hooks.el and vc-rcs-hooks.el now.
	(vc-mode-line-string): New name for former vc-status.  Adapted.
	(vc-mode-line): Adapt to use the above.  Remove optional parameter.

	* vc-cvs-hooks.el (vc-cvs-state, vc-cvs-state-heuristic): New funs.
	Various simplifications and adaptations all over the place.

	* vc-sccs-hooks.el (vc-sccs-state, vc-sccs-state-heuristic): New funs.
	Simplify and adapt the rest.

	* vc.el (vc-resynch-window): Add TODO comment: check for
	interaction with view mode according to recent RCS change.
	(vc-backend-merge-news): Merge "CMUP" patch from mainline.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc.el: Convert the remaining function comments to docstrings.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc.el (vc-backend-release, vc-release-greater-or-equal)
	(vc-backend-release-p, vc-trunk-p, vc-branch-p, vc-branch-part)
	(vc-minor-part, vc-previous-version): Functions that operate and
	compare revision numbers got proper documentation.  Comments added
	about their possible removal.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc.el (vc-latest-on-branch-p): Function removed and replaced in
	the vc-backend.el files.

	* vc-sccs.el (vc-sccs-latest-on-branch-p): Function added.

	* vc-rcs.el (vc-rcs-latest-on-branch-p, vc-rcs-trunk-p)
	(vc-rcs-branch-p, vc-rcs-branch-part, vc-rcs-minor-part)
	(vc-rcs-previous-version): Functions added.

	* vc-cvs.el (vc-cvs-latest-on-branch-p): Function added.

	* vc-rcs-hooks.el (vc-rcs-master-templates): Extra `)' removed.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el (vc-master-templates): Is really obsolete.
	Comment out the definition for now.  What is the right procedure
	to get rid of it?
	(vc-registered, vc-backend, vc-buffer-backend, vc-name): Largely
	rewritten.
	(vc-default-registered): Remove.
	(vc-check-master-templates): New function; does mostly what the
	above did before.
	(vc-locking-user): Don't rely on the backend to set the property.

	* vc-rcs-hooks.el (vc-rcs-master-templates): Use simpler values.
	Rewrite documentation.
	(vc-rcs-templates-grabbed): New variable.
	(vc-rcs-grab-templates): New function.
	(vc-rcs-registered): Rewrite to use above mechanism.

	* vc-sccs-hooks.el (vc-sccs-master-templates): Use simpler values.
	Rewrite documentation.
	(vc-sccs-templates-grabbed): New variable.
	(vc-sccs-grab-templates): New function.
	(vc-sccs-registered): Rewrite to use above mechanism.
	(vc-sccs-search-project-dir): Rename from vc-search-sccs-project-dir.
	Don't throw the result, simply return it.

	* vc-cvs-hooks.el (vc-cvs-master-templates): Remove.
	(vc-cvs-find-master): Remove.  Code is now in vc-cvs-registered.
	(vc-cvs-registered): Does the check itself now.  Simplify.

	* vc-cvs.el (vc-cvs-revert): Merge and adapt "unedit" patch
	from main line.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-cvs.el (vc-cvs-diff): New function.

	* vc-sccs.el (vc-sccs-diff): New function.

	* vc-rcs.el (vc-rcs-diff): New function.
	(vc-rcs-checkout): Bug (typo) found and fixed.
	(vc-rcs-register-switches): New variable.

	* vc.el (vc-backend-diff): Function removed and placed in the
	backend files.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-cvs.el (vc-cvs-checkout): Function `vc-cvs-checkout' added.

	* vc.el (vc-backend-checkout): Function removed and replaced in
	the vc-backend.el files.

	* vc-sccs.el (vc-sccs-checkout): Added function `vc-sccs-checkout'.

	* vc.el (vc-backend-admin): Removed and replaced in the
	vc-backend.el files.

	* vc.el (Martin): Removed all the annotate functionality since it
	is CVS backend specific.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* spec.txt: Added specification of vc-state.

	* vc-sccs-hooks.el (vc-sccs-master-properties):
	Remove handling of vc-latest-version and
	vc-your-latest-version.  What used to be vc-latest-version, is now
	returned as vc-workfile-version.
	(vc-sccs-workfile-version): Adapt.

2000-09-04  Dave Love  <fx@gnu.org>

	* vc.el: [Merged from mainline.]
	(vc-dired-mode): Make the dired-move-to-filename-regexp
	regexp match the date, to avoid treating date as file size.
	Add YYYY S option to WESTERN/

2000-09-04  Dave Love  <fx@gnu.org>

	* vc.el: Require `compile' when compiling.
	(vc-logentry-check-hook): New option.
	(vc-steal-lock): Use compose-mail.
	(vc-dired-mode-map): Defvar when compiling.
	(vc-add-triple, vc-record-rename, vc-lookup-triple): Moved to
	vc-sccs.el and renamed.  Callers changed.
	(vc-backend-checkout, vc-backend-logentry-check)
	(vc-backend-merge-news): Doc fix.
	(vc-default-logentry-check): New function.
	(vc-backend-checkin, vc-backend-revert, vc-backend-steal)
	(vc-backend-uncheck, vc-backend-print-log, vc-backend-assign-name)
	(vc-backend-merge): Doc fix.  Use backend functions.
	(vc-check-headers): Use backend functions.

	* vc-cvs.el: Require vc when compiling.
	(vc-cvs-register-switches): Doc fix.
	(vc-annotate-color-map, vc-annotate-menu-elements): Fix custom type.
	(vc-cvs-print-log, vc-cvs-assign-name, vc-cvs-merge)
	(vc-cvs-check-headers, vc-cvs-steal, vc-cvs-revert, vc-cvs-checkin):
	New functions (code from vc.el).
	(vc-annotate-display-default): Fix interactive spec.
	(vc-annotate-time-span): Doc fix.

	* vc-rcs.el: Require vc when compiling.
	(vc-rcs-print-log, vc-rcs-assign-name, vc-rcs-merge)
	(vc-rcs-check-headers, vc-rcs-steal, vc-rcs-uncheck, vc-rcs-revert)
	(vc-rcs-checkin): New functions (code from vc.el).
	(vc-rcs-previous-version, vc-rcs-system-release, vc-rcs-checkout):
	Doc fix.
	(vc-rcs-release): Deleted.  (Duplicated vc-rcs-system-release).

	* vc-sccs.el: Require vc when compiling.
	(vc-sccs-print-log, vc-sccs-assign-name, vc-sccs-merge)
	(vc-sccs-check-headers, vc-sccs-steal, vc-sccs-uncheck)
	(vc-sccs-revert)
	(vc-sccs-checkin, vc-sccs-logentry-check): New functions (code
	from vc.el).
	(vc-sccs-add-triple, vc-sccs-record-rename)
	(vc-sccs-lookup-triple): Moved from vc.el and renamed.
	(vc-sccs-admin): Doc fix.

2000-09-04  Martin Lorentzson  <martinl@gnu.org>

	* vc-rcs.el (vc-rcs-trunk-p, vc-rcs-branch-p, vc-rcs-branch-part)
	(vc-rcs-minor-part, vc-rcs-previous-version, vc-rcs-release)
	(vc-rcs-release-p, vc-rcs-admin, vc-rcs-checkout): New functions
	from vc.el.

	* vc-sccs.el (vc-admin-sccs): Added from vc.el

	* vc-cvs.el: Moved the annotate functionality from vc.el.
	(vc-cvs-admin, vc-cvs-fetch-status): Added from vc.el.

2000-09-04  Dave Love  <fx@gnu.org>

	* vc.el (vc-backend-release): Call vc-system-release.

	* vc-sccs.el (vc-sccs-system-release):
	Renamed from vc-sccs-backend-release.

	* vc-rcs.el (vc-rcs-system-release):
	Renamed from vc-rcs-backend-release.

	* vc-cvs.el (vc-cvs-system-release):
	Renamed from vc-cvs-backend-release.

2000-09-04  Dave Love  <fx@gnu.org>

	* vc.el (vc-rcs-release, vc-cvs-release, vc-sccs-release): Moved to
	backend files.
	(vc-backend-release): Dispatch to backend functions.
	(vc-backend-release-p): Don't mention CVS, RCS.  [The SCCS case
	probably needs attention.]

	* vc-sccs.el, vc-rcs.el (vc-sccs-release): Moved from vc.el.
	(vc-sccs-backend-release): New function.

	* vc-cvs.el (vc-cvs-release): Moved from vc.el.
	(vc-cvs-backend-release): New function.

	* vc.el (vc-dired-mode, vc-dired-reformat-line, vc-dired-purge):
	Doc fix.
	(vc-fetch-cvs-status): Moved to vc-cvs.el and renamed.
	(vc-default-dired-state-info): New function.
	(vc-dired-state-info): Dispatch to backends.
	(vc-dired-hook): Doc fix.  Simplify, pending removal of CVS specifics.

	* vc-cvs.el (vc-cvs-dired-state-info, vc-cvs-fetch-status): Moved
	from vc.el and renamed.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (vc-file-clear-masterprops, vc-latest-on-branch-p)
	(vc-version-other-window, vc-backend-assign-name): Removed
	references to vc-latest-version; sometimes changed into
	vc-workfile-version.

	* vc-rcs-hooks.el (vc-master-workfile-version): Renamed to
	vc-rcs-master-workfile-version.
	(vc-rcs-workfile-version): Use the above.  Don't call
	vc-latest-version (that was unreachable code, anyway).
	(vc-rcs-fetch-master-properties): Doc fix.

	* vc-hooks.el (vc-latest-version, vc-your-latest-version): Removed.
	(vc-backend-hook-functions): Removed them from this list, too.
	(vc-fetch-properties): Removed.
	(vc-workfile-version): Doc fix.

	* vc-rcs-hooks.el (vc-rcs-consult-headers): New function.
	(vc-rcs-workfile-version, vc-rcs-locking-user)
	(vc-rcs-uses-locking): Use it.

	* vc-hooks.el (vc-consult-rcs-headers):
	Moved into vc-rcs-hooks.el, under the name
	vc-rcs-consult-headers.

	* vc-cvs-hooks.el (vc-cvs-workfile-version): Don't consult RCS
	headers.
	(vc-cvs-find-master): Use this name only; correct different
	versions of the name.

	* vc-sccs-hooks.el (vc-sccs-master-locks, vc-sccs-master-locking-user):
	New functions.
	(vc-sccs-locking-user): Use the latter.

	* vc-rcs-hooks.el (vc-rcs-master-locks, vc-rcs-master-locking-user):
	New functions.

	* vc-hooks.el (vc-master-locks, vc-master-locking-user):
	Moved into both
	vc-rcs-hooks.el and vc-sccs-hooks.el.  These properties and access
	functions are implementation details of those two backends.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-rcs-hooks.el (vc-rcs-fetch-master-properties)
	(vc-rcs-parse-locks): RCS-specific code moved here from vc-hooks.

	* vc-sccs-hooks.el (vc-sccs-fetch-master-properties)
	(vc-sccs-parse-locks): SCCS-specific code moved here from
	vc-hooks.

	* vc-cvs-hooks.el (vc-cvs-fetch-master-properties): CVS-specific
	code moved here from vc-hooks.

	* vc-hooks.el (vc-parse-locks, vc-fetch-master-properties): Split
	into back-end specific parts and removed.  Callers not updated
	yet; because I guess these callers will disappear into back-end
	specific files anyway.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc.el (with-vc-file, vc-next-action-on-file, vc-merge)
	(vc-backend-checkout): Changed calls to `vc-checkout-model' to
	`vc-uses-locking'.

	* vc-hooks.el (vc-checkout-model): Renamed to vc-uses-locking.
	Store yes/no in the property, and return t/nil.  Updated all
	callers.

	* vc-sccs-hooks.el (vc-sccs-checkout-model): Renamed to
	vc-sccs-uses-locking.  Don't set property.
	(vc-sccs-locking-user): Don't set property.

	* vc-cvs-hooks.el (vc-cvs-checkout-model): Renamed to
	vc-cvs-uses-locking.  Don't set property here; leave that to
	vc-hooks.
	(vc-cvs-locking-user): Reflect above change.  Streamlined.

	* vc-rcs-hooks.el (vc-rcs-checkout-model): Renamed to
	vc-rcs-uses-locking.
	(vc-rcs-locking-user): Reflect above change.

2000-09-04  Dave Love  <fx@gnu.org>

	* vc-sccs-hooks.el (vc-sccs-checkout-model): New function.

	* vc-rcs-hooks.el (vc-rcs-checkout-model): New function.

	* vc-hooks.el (vc-checkout-model): Punt to backends.

	* vc-cvs-hooks.el (vc-cvs-checkout-model): New function.

	* vc.el (vc-fetch-cvs-status): Use renamed vc-cvs-parse-status.

	* vc-rcs-hooks.el (vc-rcs-workfile-version, vc-rcs-locking-user):
	New functions.

	* vc-sccs-hooks.el (vc-sccs-workfile-version, vc-sccs-locking-user):
	New functions.

	* vc-cvs-hooks.el (vc-handle-cvs): Doc fix.
	(vc-cvs-workfile-version, vc-cvs-locking-user): New functions.

	* vc-hooks.el (vc-default-locking-user): New function.
	(vc-locking-user, vc-workfile-version): Punt to backends.

2000-09-04  Dave Love  <fx@gnu.org>

	* vc-hooks.el (vc-rcsdiff-knows-brief, vc-rcs-lock-from-diff)
	(vc-master-workfile-version): Moved from vc-hooks.

	* vc-rcs-hooks.el: Fix duplicate code in last change.

	* vc-rcs-hooks.el: Require vc-hooks when compiling.
	(vc-rcs-master-templates): Improve :type.
	(vc-rcsdiff-knows-brief, vc-rcs-lock-from-diff,
	vc-master-workfile-version): Moved from vc-hooks.

	* vc-sccs-hooks.el: Require vc-hooks when compiling.
	(vc-sccs-master-templates): Improve :type.
	(vc-sccs-lock-file): Moved/renamed from vc-hooks.el vc-lock-file.

	* vc-hooks.el (vc-lock-file): Moved to vc-sccs-hooks and renamed.

	* vc-cvs-hooks.el: Require vc-hooks when compiling.
	(vc-cvs-master-templates): Improve :type.  Use
	vc-cvs-find-cvs-master.
	(vc-handle-cvs, vc-cvs-parse-status, vc-cvs-status): Moved here
	from vc-hooks.
	(vc-vc-find-cvs-master): Renamed to vc-cvs-find-cvs-master.

	* vc-hooks.el (vc-handle-cvs, vc-cvs-parse-status, vc-cvs-status):
	Moved to vc-cvs-hooks.

	* vc-hooks.el: Add doc strings in various places.  Simplify the
	minor mode setup.
	(vc-handled-backends): New user variable.
	(vc-parse-buffer, vc-insert-file, vc-default-registered): Minor
	simplification.

2000-09-04  Dave Love  <fx@gnu.org>

	* vc.el: Some doc fixes for autoloaded and interactive functions.
	Fix compilation warnings from ediff stuff.
	(vc-rcs-release, vc-cvs-release, vc-sccs-release): Custom fix.

	* vc-sccs-hooks.el (vc-sccs-master-templates): Add :version.

	* vc-cvs-hooks.el (vc-cvs-master-templates): Add :version.

	* vc-rcs-hooks.el (vc-rcs-master-templates): Add :version.

2000-09-04  Dave Love  <fx@gnu.org>

	* vc-hooks.el (vc-backend-hook-functions, vc-backend-functions):
	New variable.
	(vc-make-backend-function, vc-loadup, vc-call-backend)
	(vc-backend-defines): New functions.

	* vc-hooks.el: Various doc fixes.
	(vc-default-back-end, vc-follow-symlinks): Custom fix.
	(vc-match-substring): Function removed.  Callers changed to use
	match-string.
	(vc-lock-file, vc-consult-rcs-headers, vc-kill-buffer-hook):
	Simplify.

2000-09-04  Dave Love  <fx@gnu.org>

	* vc-sccs-hooks.el (vc-sccs-master-templates): Fix doc, custom
	type.
	(vc-sccs-project-dir, vc-search-sccs-project-dir)
	(vc-sccs-registered): Doc fix.

	* vc-cvs-hooks.el (vc-cvs-master-templates): Fix doc, custom type.
	(vc-cvs-registered): Doc fix.

	* vc-rcs-hooks.el (vc-rcs-master-templates): Fix doc, custom type.
	(vc-rcs-registered): Doc fix.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-rcs-hooks.el, vc-cvs-hooks.el, vc-sccs-hooks.el: New file.

	* vc-hooks.el: vc-registered has been renamed
	vc-default-registered.  Some functions have been moved to the
	backend specific files.  they all support the
	vc-BACKEND-registered functions.

2000-09-04  Andre Spiegel  <spiegel@inf.fu-berlin.de>

	* vc-hooks.el: This is 1.113 from the emacs sources

	* vc.el: This is 1.244 from the emacs sources

2000-09-04  Dave Love  <fx@gnu.org>

	* mouse.el (mouse-major-mode-menu, mouse-popup-menubar): Run
	menu-bar-update-hook.

	* help.el (help-manyarg-func-alist): Add
	find-operation-coding-system.

	* wid-edit.el (widget-sexp-validate): Fix garbled code.

	* custom.el (custom-set-variables): Print message about errors in
	setting.

2000-09-03  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in: Change to DOS line endings.

2000-09-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* mouse.el (mouse-popup-menubar): Supply the prompt string for
	minor-mode keymaps, if they don't have one.

2000-09-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* eshell/esh-module.el (eval-when-compile): Don't lose if
	esh-module.el's file name is truncated to DOS 8+3 limits.

2000-09-01  John Wiegley  <johnw@gnu.org>

	* pcomplete.el (pcomplete-dirs-or-entries): Added a missing
	predicate, which caused entries in the completion list to be
	doubled.

2000-08-30  John Wiegley  <johnw@gnu.org>

	* eshell/esh-mode.el (eshell-mode): Bound C-c M-d to toggle direct
	sending to subprocesses.  Also, hook pre-command-hook if
	`eshell-send-direct-to-subprocesses' is non-nil.
	(eshell-send-direct-to-subprocesses): New config variable.  If t,
	subprocess input is send immediately.
	(eshell-toggle-direct-send): New function.
	(eshell-self-insert-command): New function.
	(eshell-intercept-commands): New function.
	(eshell-send-input): If direct subprocess sending is enabled,
	don't echo any input to the Eshell buffer.  Let the subprocess
	handle that.  This requires "stty echo" in bash, for example.

2000-08-28  John Wiegley  <johnw@gnu.org>

	* eshell/esh-var.el (pcomplete/eshell-mode/unset): Added
	completion function for Eshell's implementation of `unset'.

2000-09-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (Info-directory-list): Doc fix.

2000-08-31  Peter Breton  <pbreton@ne.mediaone.net>

	* filecache.el (file-cache-add-directory-using-find): Don't quote
	wildcards on MS-DOS. Suggested by Eli Zaretskii <eliz@is.elta.co.il>.

2000-08-31  Kenichi Handa  <handa@etl.go.jp>

	* help.el (help-make-xrefs): Don't make hyperlinks for incorrect
	coding systems.

2000-08-30  Andrew Innes  <andrewi@gnu.org>

	* timer.el (run-with-idle-timer): Undo last change, so that timer
	is not activated immediately if Emacs is already idle.  Some
	existing code relies on this behaviour.

2000-08-30  Miles Bader  <miles@gnu.org>

	* frame.el (set-frame-font): Do completion of font-name for
	interactive use.

2000-08-30  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-start-translation): Bind locally
	last-command-event, last-command, and this-command.
	(quail-start-conversion): Likewise.
	(quail-self-insert-command): Fix docstring.

2000-08-29  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/executable.el
	(executable-make-buffer-file-executable-if-script-p): Check that
	buffer contains at least 2 characters.

2000-08-29  Eli Zaretskii  <eliz@is.elta.co.il>

	* help.el (help-make-xrefs, help-xref-mule-regexp): Doc fix.

2000-08-29  Dave Love  <fx@gnu.org>

	* diff-mode.el (diff-mode) <defgroup>: Add :version.
	(diff-mode-shared-map): Bind mouse-2.
	(diff-imenu-generic-expression): New variable.
	(diff-mode): Use it.

	* mouse.el (mouse-major-mode-menu): Use local-key-binding.
	(mouse-popup-menubar): Add minor mode menus.
	(popup-menu): Check for lookup-key returning number.

2000-08-29  Miles Bader  <miles@gnu.org>

	* comint.el (comint-send-input): Create overlays using the proper
	front/read-advance arguments.

2000-08-29  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Even/odd pages printing.  Doc fix.
	(ps-print-version): New version number (6.0).
	(ps-setup, ps-print-page-p, ps-background-text, ps-background-image)
	(ps-background, ps-begin-file, ps-begin-job): Code fix.
	(ps-print-duplex-feature): Variable eliminated.
	(ps-even-or-odd-pages): New variable.

	* progmodes/ebnf2ps.el: Doc fix.
	(ebnf-version): New version (3.3).
	(ebnf-user-arrow): Change variable customization to sexp.
	(ebnf-user-arrow): Function eliminated.
	(ebnf-eps-finish-and-write, ebnf-insert-ebnf-prologue): Code fix.

2000-08-29  Kenichi Handa  <handa@etl.go.jp>

	* help.el (help-xref-mule-regexp): New variable.
	(help-make-xrefs): Handle help-xref-mule-regexp.

	* international/mule-cmds.el (help-xref-mule-regexp-template): New
	variable.
	(describe-input-method): Temporarily activate the specfied input
	method to display the information.
	(describe-language-environment): Hyperlinks to mule related items.

	* international/mule-diag.el (charset-multibyte-form-string): New
	function.
	(list-character-sets-1): Use charset-multibyte-form-string.
	(describe-character-set): New function.
	(describe-coding-system): Hyperlinks to safe character sets.

	* international/quail.el (quail-help): New arg PACKAGE.
	Hyperlinks to mule related items.
	(quail-help-insert-keymap-description): Use
	substitute-command-keys instead of describe-bindings.
	(quail-translation-help): Hyperlinks to mule related items.

2000-08-28  John Wiegley  <johnw@gnu.org>

	* eshell/esh-util.el (eshell-flatten-list): It's not too wise to
	have a defsubst call itself.  Made `eshell-flatten-list' back into
	a function again.

	* eshell/em-smart.el (eshell-smart-redisplay): Added a safety
	catch, in case re-centering point at bottom messes up the display.
	This happens frequently in Emacs 21, due I believe to variable
	line heights.

	* eshell/esh-mode.el (eshell-find-tag): Require `etags', in order
	to call `find-tag-interactive'.

	* eshell/em-dirs.el (eshell/cd): Use buffered printing to display
	the list of remember directories.

2000-08-28  John Wiegley  <johnw@gnu.org>

	* align.el: Test align-region-separate to see if it's a symbol.

2000-08-28  John Wiegley  <johnw@gnu.org>

	* eshell/esh-util.el (eshell-flatten-list): Made this function
	into a defsubst form.  It gets used very frequently, although
	calls don't occur all that often.

	* eshell/em-dirs.el (eshell/cd): Flatten the argument list before
	examining it.

	* eshell/esh-cmd.el (eshell-rewrite-while-command):
	(eshell-rewrite-for-command): Use `eshell-copy-handles' instead of
	`eshell-protect'.
	(eshell-copy-handles): Created a new macro for duplicating the
	current set of open handles.  This is needed by the looping
	functions.
	(eshell-do-eval): Fixed while and if, so that the eshell-test-body
	is not incorrectly stomped on.

	* eshell/em-cmpl.el (eshell-cmpl-use-paring): Mirror
	declaration for pcomplete-use-paring.
	(eshell-cmpl-initialize): Set pcomplete-use-paring based on the
	value of eshell-cmpl-use-paring.
	* pcomplete.el (pcomplete-use-paring): New config variable, to
	indicate whether paring should be used.
	(pcomplete-do-complete): If pcomplete-use-paring is t, pare out
	completion alternatives that have already been used.

	* eshell/esh-mode.el (eshell-repeat-argument): Added function,
	bound to C-c C-y, which will repeat the previous N arguments
	(based on prefix argument).
	(eshell-mode): Bind C-c C-y to eshell-repeat-argument.

	* eshell/esh-cmd.el (eshell/which): Don't kill the *Help* buffer
	if there is no *Help* buffer.  This is for XEmacs, which renames
	its help buffers uniquely.  TODO: Find out what the current buffer
	name to delete is.

	* eshell/esh-util.el (eshell-read-passwd-file): Only keep the
	first entry that correlates to a passwd/group number.  Later
	entries (used for group/user name aliasing to multiple IDs) are
	ignored.

	* eshell/em-xtra.el (eshell/expr):
	* eshell/em-unix.el (eshell/du, eshell/cat, eshell/make)
	(eshell-grep, eshell/diff, eshell/locate):
	* eshell/em-dirs.el (eshell-dirs-substitute-cd): Flatten the
	argument list, before passing it to the system command.

	* eshell/esh-mode.el (eshell-find-tag): Added a special version of
	`find-tag' for use at final position in Eshell buffers (which
	otherwise triggers an error on Emacs 21).
	(eshell-mode): Bind M-. to `eshell-find-tag' with the Eshell
	buffer, if it is currently bound to `find-tag'.

	* pcmpl-gnu.el (pcmpl-gnu-makefile-regexps): Include GNUmakefile
	in the list of matched Makefile names.
	(pcmpl-gnu-make-rule-names): If GNUmakefile exists in the current
	directory, prefer its contents to Makefile.

	* eshell/em-dirs.el (eshell/cd): cd commands that look up
	directory parts (like "cd old new", or "cd =regexp"), are now case
	sensitive on non-Windows/DOS platforms.

	* eshell/esh-mode.el (eshell-parse-command-input): When a user
	types RET after an open delimiter (like "), display a message
	indicating that Eshell is waiting for the closing delimiter.

	* eshell/esh-var.el (eshell/unset): Added a command for unsetting
	environment variables.

	* eshell/em-unix.el (eshell/diff): Added logic to fail more
	gracefully if the user enters incorrect arguments.

	* eshell/esh-mode.el (eshell-mode): Disable auto-fill-function in
	Eshell buffers.

	* eshell/esh-var.el (eshell-interpolate-variable):
	* eshell/esh-mode.el (eshell-move-argument):
	* eshell/em-unix.el (eshell-du-sum-directory):
	* eshell/em-rebind.el (eshell-delchar-or-maybe-eof):
	* eshell/em-ls.el (eshell-ls-decorated-name): Use /= instead of
	(not (= ...)).

	* eshell/em-unix.el (eshell-shuffle-files): Added use of `apply',
	to ensure the `preserve' flag gets propagated when doing recursive
	directory copies.

2000-08-28  Stefan Monnier  <monnier@cs.yale.edu>

	* eshell/em-hist.el (eshell-put-history, eshell-get-history):
	Don't convert \n into \0177 in memory.
	(eshell-read-history, eshell-write-history): Convert \n to \0177,
	and back again, when reading and writing.

2000-08-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* eshell/esh-util.el (eshell-processp): Added to relieve constant
	testing of `fboundp' on `processp'.

	* eshell/esh-proc.el (eshell/kill): Use eshell-processp.
	(eshell/jobs): Don't call process-list if it is not bound.
	(eshell-gather-process-output): Support systems where async
	subprocesses aren't supported.
	(eshell-scratch-buffer, eshell-last-sync-output-start): New
	variables.

	* eshell/esh-cmd.el (eshell-resume-eval): Handle the case when
	eshell-do-eval returns t.
	(eshell-do-pipelines-synchronously): New defmacro.
	(eshell-execute-pipeline): Call it instead of eshell-do-pipelines
	when async subprocesses aren't supported.
	(eshell-do-eval): Use eshell-processp.  Don't throw eshell-defer
	if async subprocesses aren't supported.
	(eshell-resume-command): Don't assume STATUS is a string.

	* eshell/em-unix.el (eshell/rm): Use eshell-processp.

	* eshell/esh-io.el (eshell-virtual-targets): Doc fix.
	(eshell-close-target, eshell-get-target): Use eshell-processp.
	(eshell-print, eshell-error, eshell-errorn, eshell-printn): Doc
	fix.
	(eshell-get-target, eshell-create-handles): Doc fix.

2000-08-28  Miles Bader  <miles@lsi.nec.co.jp>

	* eshell/em-smart.el (eshell-smart-maybe-jump-to-end): Change the
	criterion to include commands that output something, as long as it
	leaves both the command and the end-of-buffer visible when the
	command has exited.
	(eshell-review-quick-commands): Adjust the help doc string
	accordingly.

2000-08-28  Peter Breton  <pbreton@ne.mediaone.net>

	* locate.el (locate): Cleaned up locate command's interactive prompting
	Thanks to Fran,Ag(Bois_Pinard <pinard@iro.umontreal.ca> for suggestions.

	* filecache.el (file-cache-case-fold-search): New variable
	(file-cache-assoc-function): New variable
	(file-cache-minibuffer-complete): Use file-cache-assoc-function.
	Use file-cache-case-fold-search variable
	(file-cache-add-file): Use file-cache-assoc-function
	(file-cache-delete-file): likewise
	(file-cache-directory-name): likewise
	(file-cache-debug-read-from-minibuffer): likewise

2000-08-28  Gerd Moellmann  <gerd@gnu.org>

	* abbrev.el (list-abbrevs): Add optional parameter LOCAL.
	(abbrev-table-name): New function.
	(prepare-abbrev-list-buffer): Add optional parameter LOCAL.
	If non-nil list local abbrev, only.

2000-08-28  Stanislav Shalunov  <shalunov@internet2.edu>

	* mail/uce.el (uce-reply-to-uce): Remove hard-coded "*Article*"
	from Gnus support code, and use special article copy buffer
	`(gnus-original-article-buffer)' instead.  This allows to get rid
	of article-hide-headers usage (which breaks in the latest Gnus
	version).  Thanks to Detlev Zundel.

2000-08-28  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-use-package): Hide "... loaded"
	message.
	(quail-start-translation, quail-start-conversion): Likewise.

	* international/kkc.el (kkc-region): Hide "... loaded" message.

2000-08-27  Dave Love  <fx@gnu.org>

	* emacs-lisp/bytecomp.el (mapc): Use byte-compile-funarg.

2000-08-27  Miles Bader  <miles@gnu.org>

	* faces.el (read-face-font, read-face-and-attribute): Tweak prompts.

2000-08-27  Kenichi Handa  <handa@etl.go.jp>

	* international/ja-dic-cnv.el (skkdic-convert): Insert (require
	'ja-dic-cnv), not (require 'skkdic-cnv).

2000-08-26  Miles Bader  <miles@gnu.org>

	* faces.el (face-x-resources): Add entry for :inherit.
	* cus-face.el (custom-face-attributes): Add support for :inherit
	attribute.  Add support for relative face heights.
	(custom-face-attributes-get): Treat `nil' as being a default value
	for :inherit (as well as `unspecified').

	* faces.el (set-face-attribute): Update doc string.
	(face-attribute-name-alist): Add :inherit.
	(face-valid-attribute-values): Handle :inherit.
	(face-read-string): Rephrase prompt to be less confusing.
	Assume that DEFAULT is a string, since we must return a string.
	(face-read-integer): Use `format' to turn DEFAULT into an
	acceptable default for face-read-string.  Match NEW-VALUE against
	the string "unspecified", not the symbol `unspecified', since
	that's what face-read-string returns.
	(read-face-attribute): Lookup a name for old-value in valid, and
	use it as a default if we find one.  Treat all values from
	face-read-string as strings.  If the default is used, don't do any
	more processing on the value, just use the old value directly.
	(read-face-and-attribute, modify-face): Tweak prompt.
	(read-face-name): Don't assume prompt ends with a space.

	* faces.el (describe-face): Add support for :inherit attribute.

2000-08-25  Kenichi Handa  <handa@etl.go.jp>

	* terminal.el (terminal-emulator): Fix args to `concat'.  Now
	concat doesn't accept interger.

	* international/kkc.el: Remove SKK from Keywords.  Require
	ja-dic-utl instead of skkdic-utl.

	* international/ja-dic-cnv.el: Renamed from skkdic-cnv.el.
	Provide ja-dic-cnv instead of skkdic-cnv.
	(ja-dic-filename): Renamed from skkdic-filename.  Referers changed
	(iso-2022-7bit-short): Add safe-charsets property.
	(skkdic-convert-postfix): Search Japanese chou-on character in
	addition to Hiragana character.
	(skkdic-convert-prefix, skkdic-collect-okuri-nasi): Likewise.
	(skkdic-convert): Change file names from skkdic.el to ja-dic.el
	(batch-skkdic-convert): Likewise.

	* international/ja-dic-utl.el: Renamed from skkdic-utl.el.
	Provide ja-dic-utl instead of skkdic-utl.
	(skkdic-lookup-key): Load ja-dic/ja-dic, not skkdic/skkdic.

2000-08-24  Dave Love  <fx@gnu.org>

	* disp-table.el (standard-display-default): Make the test of `l'
	useful.

	* language/european.el ("Latin-8", "Latin-9"): Add input methods,
	mod sample text.

	* international/iso-ascii.el: Make pilcrow convenient string
	consistent with section.
	(iso-ascii-display): Set up multibyte characters as well as
	unibyte.

2000-08-24  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (reset-language-environment): Set
	default-process-coding-system to '(undecided . iso-latin-1), which
	makes process I/O almost consistent with file I/O.   Call this
	function when mule-cmds.el[c] is loaded.

2000-08-22  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in: New file.

2000-08-22  Miles Bader  <miles@lsi.nec.co.jp>

	* comint.el (comint-output-filter): Compare end of
	comint-last-output-overlay with the start of the newly inserted
	text, not the end, when deciding whether to extend it.
	Set saved-point's insertion type to advance after insertion.

	* shell.el (shell-font-lock-keywords): Remove prompt highlighting,
	since this is now done independently of font-lock mode.

2000-08-21  Gerd Moellmann  <gerd@gnu.org>

	* server.el (server-kill-new-buffers): New user option.
	(server-existing-buffer): New buffer-local variable.
	(server-visit-files): When using an existing buffer, set
	server-existing-buffer to t.
	(server-buffer-done): If server-kill-new-buffers is t, kill the
	buffer, unless it was already present before visiting it with
	Emacs server.

2000-08-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* man.el (Man-init-defvars): Don't reset Man-fontify-manpage-flag,
	even if the display doesn't support colors: some displays will
	support bold/underline faces.

2000-08-21  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/cl.el (cl-macroexpand): Doc fix.

	* startup.el (command-line): If user's init file had an error,
	add explanatory text to *Messages*.

2000-08-21  Kenichi Handa  <handa@etl.go.jp>

	* man.el (Man-getpage-in-background): Decode the process output by
	the system locale coding system.

2000-08-20  Dave Love  <fx@gnu.org>

	* wid-edit.el (widget-choose, widget-choice-mouse-down-action):
	Don't test x-popup-menu.
	(function) <complete-function>: Complete only fbound symbols.
	<validate, value>: New.
	(variable) <complete-function>: Complete only bound symbols.
	(coding-system): Add :base-only, :complete-function, :validate,
	:value, :prompt-match.
	(widget-coding-system-prompt-value): Use read-coding-system and
	act on :base-only.
	(editable-field): Add :help-echo.
	(widget-push-button-gui, widget-push-button-cache)
	(widget-gui-action, widget-editable-list-gui): COmment out, along
	with uses.
	(widget-at): Make arg optional.
	(widget-echo-help): Adjust for current help-echo calling sequence.
	(widget-specify-field, widget-specify-button)
	(widget-specify-insert, widget-get-sibling, widget-image-find)
	(widget-convert, widget-insert, widget-leave-text)
	(widget-beginning-of-line, widget-end-of-line, widget-kill-line)
	(widget-setup, widget-field-find, widget-before-change)
	(widget-after-change, widget-default-complete)
	(widget-default-create, widget-default-delete)
	(widget-push-button-value-create, editable-field)
	(widget-field-prompt-value, widget-field-validate)
	(widget-choice-value-create, widget-choice-action)
	(widget-choice-validate, widget-checklist-add-item)
	(widget-radio-add-item, widget-radio-chosen)
	(widget-radio-value-inline, widget-editable-list-value-create)
	(widget-editable-list-entry-create)
	(widget-documentation-link-add)
	(widget-documentation-string-value-create)
	(widget-regexp-validate, widget-file-complete)
	(widget-sexp-validate, widget-plist-convert-widget)
	(widget-plist-convert-widget, widget-alist-convert-widget)
	(widget-alist-convert-widget, widget-color-complete): Simplify,
	particularly to avoid bindings which aren't optimized out.

	* emacs-lisp/lisp.el (defun-prompt-regexp, parens-require-spaces):
	Doc fix.
	(down-list, backward-up-list, up-list, kill-sexp)
	(backward-kill-sexp, mark-sexp): Make arg optional.
	(lisp-complete-symbol): Add optional arg PREDICATE.

	* cus-start.el: Add display-buffer-reuse-frames,
	file-coding-system-alist.

2000-08-20  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (command-line): Clear realized faces after
	modifying TTY color mappings.

2000-08-20  Miles Bader  <miles@gnu.org>

	* faces.el (face-attr-match-p): Don't return true if ATTRS are
	merely a subset of FACE's attributes.

2000-08-19  Miles Bader  <miles@gnu.org>

	* comint.el (comint-output-filter): Save the point with a marker,
	not just a buffer position.

	* international/mule.el (set-buffer-process-coding-system): Make
	interactive prompt less confusing.

2000-08-19  Gerd Moellmann  <gerd@gnu.org>

	* hilit-chg.el: General cleanup of doc strings, comments and
	code formatting.

2000-08-19  Miles Bader  <miles@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-beginning-of-line):
	Compiler macro removed; beginning-of-line is no longer always
	equivalent to forward-line, in the presence of fields.

	* comint.el (comint-output-filter): Remove ad-hoc saving of
	restriction, and just use save-restriction, now that it works
	correctly.  Don't adjust comint-last-input-start to account for
	our insertion; it shouldn't have moved because we don't use
	insert-before-markers anymore.  Comment out call to
	`force-mode-line-update'; why is it here?

	* gud.el (gud-basic-call): Temporarily widen gud comint buffer
	while checking for prompt to delete.  Use `forward-line 0'
	instead of beginning-of-line.
	(gud-filter): Temporarily widen gud comint buffer while
	examining output.

2000-08-18  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/sh-script.el: Big bag of typos.

	* textmodes/ispell.el (ispell-menu-map-needed): Put back the boundp
	check since ispell-process is not bound when ispell is not yet loaded.

2000-08-18  Dave Love  <fx@gnu.org>

	* image.el (find-image): Copy `spec' before using plist-put.

2000-08-18  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/ispell.el (ispell-dictionary-alist-6): Add
	`portugues'.

	* bindings.el (esc-map): Bind `C-delete' and `C-backspace' to
	backward-kill-sexp, analogous to kill-sexp.

	* progmodes/icon.el (icon-indent-line)
	(icon-is-continuation-line): Handle comments specially.

2000-08-17  Ken Stevens <k.stevens@ieee.org>

	* ispell.el: Set to standard author/maintainer/keyword fields.
	Fine tuning to menu map appearance and operation, and added help.
	Remove `start' and `end' error messages when compiling.
	(ispell-choices-win-default-height): Fixed comment string.
	(ispell-dictionary-alist-1): Fixed regexp in castellano and
	castellano8 dictionaries.
	(ispell-dictionary-alist-3): Fixed regexp in francais dictionary.
	(ispell-dictionary-alist-4): Fixed regexp in francais-tex
	dictionary, added italiano dictionary.
	(ispell-skip-region-alist): Removed regexp thrashing when `-' is a
	word character
	(ispell-tex-skip-alists): Added psfig support.
	(ispell-skip-html): Renamed from ispell-skip-sgml.
	(ispell-begin-skip-region-regexp, ispell-skip-region)
	(ispell-minor-check): Improved html skipping support to skip across
	code, and recognize `&' commands without propper `;' syntax;
	(ispell-process-line): Fix alignment error when manually
	correcting spelling.
	(ispell): Fix comment string.
	(ispell-add-per-file-word-list): Always put word list on new line.

2000-08-17  Gerd Moellmann  <gerd@gnu.org>

	* format.el (format-encode-run-method): Fix error message to say
	`encode' instead of `decode'.  Use save-window-excursion around
	shell-command-on-region as in format-decode-run-method because
	shell-command-on-region can display a buffer with error output.
	(format-decode): Don't record undo information for the decoding.
	(format-annotate-function): Add parameter FORMAT-COUNT.  Make
	that number part of the temporary buffer name so that more than
	one decoding using a temporary buffer can happen safely.

	* enriched.el (enriched-annotation-regexp): Use `A-Z' instead
	of `A-z' in the regexp.

	* hilit-chg.el: Fix typos in commentary.

	* help.el (view-emacs-news): Rewritten for new naming scheme
	for old NEWS files.

	* startup.el (command-line): Pop to *Messages* in case an error
	is signaled while loading user-init-file.

2000-08-17  Andreas Schwab  <schwab@suse.de>

	* files.el (insert-directory): Don't lose original file name,
	undoing an undocumented change.

2000-08-17  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-magic-go): Use comint-bol.
	(sql-copy-column): Use comint-line-beginning-position.
	(comint-line-beginning-position): Define a replacement for
	comint-line-beginning-position if it is not fboundp.

2000-08-17  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-mode-map): TAB is no longer defined in sql-mode-map;
	it didn't have any effect anyway.

2000-08-17  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-postgres): Jason Beegan's patch uses the parameters
	--pset and pager=off instead of sending \\o|cat at the beginning
	of the session.

2000-08-17  Miles Bader  <miles@gnu.org>

	* progmodes/octave-inf.el: Add compatibility definition of
	comint-line-beginning-position.

2000-08-17  Kenichi Handa  <handa@etl.go.jp>

	* startup.el (normal-top-level): Look in each dir in load-path for
	a leim-list.el file too.  This assures of loading leim-list.el
	that is created at Emacs installation time even if a user have his
	own leim-list.el.

2000-08-17  Miles Bader  <miles@gnu.org>

	* hi-lock.el (hi-yellow, hi-pink, hi-green, hi-blue): Force the
	foreground color to black if the background is dark.

2000-08-16  Stefan Monnier  <monnier@cs.yale.edu>

	* loadhist.el (unload-feature): Typo.

	* finder.el (finder-compile-keywords):
	* cus-dep.el (custom-make-dependencies): Add local-variable settings
	to the generated file.

	* mail/mh-e.el (mh-make-local-vars):
	Replace make-variable-buffer-local with make-local-variable.

	* play/landmark.el:
	* options.el (Edit-options-{set,toggle,t,nil}):
	* mail/mailabbrev.el (mail-abbrevs-mode):
	* textmodes/tex-mode.el (tex-expand-files):
	* textmodes/outline.el (outline-minor-mode): Don't quote lambda.

	* term/bg-mouse.el (bg-mouse-report): screen-height -> frame-height.

	* emacs-lisp/ewoc.el (ewoc-locate): Default POS to (point).
	(ewoc-goto-prev, ewoc-goto-next): Remove arg POS.
	Allow going past the last element.
	* pcvs.el (cvs-mode-previous-line, cvs-mode-next-line, cvs-mode-mark)
	(cvs-mode-unmark-up, cvs-get-marked): Update calls to ewoc.
	(cvs-mouse-toggle-mark): Don't move point.
	(cvs-revert-if-needed): Avoid re-eval of local variables and modes.

	* progmodes/compile.el (grep): Provide a default set of files.
	(next-error): Docstring fix.
	(compilation-find-file): Avoid find-file (fails in a dedicated window).

	* emacs-lisp/easy-mmode.el (define-minor-mode):
	Use `symbol-value' to keep the byte-compiler quiet.

	* diff-mode.el (diff-mode-map): Bind diff-apply-hunk.
	(diff-find-source-location): New fun, extracted from diff-goto-source.
	(diff-goto-source): Use it.
	(diff-next-complex-hunk, diff-filter-lines): New function.
	(diff-apply-hunk): New command.

	* smerge-mode.el (smerge-mode-menu): Doc fix.

	* msb.el (msb-mode): Define it in terms of define-minor-mode.

2000-08-16  Dave Love  <fx@gnu.org>

	* windmove.el (windmove) <defgroup>: Add :version.

	* net/goto-addr.el: Don't require browse-url.  Require thingatpt.
	(goto-address-fontify-p, goto-address-highlight-p)
	(goto-address-url-face, goto-address-url-mouse-face)
	(goto-address-mail-face, goto-address-mail-mouse-face): Doc fix.
	(goto-address-url-regexp): Use thing-at-point-url-regexp.
	(goto-address-fontify, goto-address-at-mouse): Simplify,
	(goto-address-at-point): browse-url-url-at-point,
	goto-address-find-address-at-point can return nil.
	(goto-address-find-address-at-point): Return nil on failure.

	* align.el (align) <defgroup>: Add :version.

	* calculator.el (calculator): Add :version.
	(calculator): Use two lines for calculator window if `modeline'
	face is boxed.

	* play/5x5.el: Doc fixes.
	(5x5) <defgroup>: Add :version.

	* play/fortune.el (fortune) <defgroup>: Add :version.
	(fortune-append): Fix error message.
	(fortune-from-region): Doc fix.

	* play/pong.el (pong): Doc fix.

	* play/morse.el: Keywords, commentary, autoloads.

2000-08-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* desktop.el (desktop-save): Don't look at symbol-value of a
	member of minor-mode-alist, unless it is boundp.

2000-08-16  Sam Steingold  <sds@gnu.org>

	* buff-menu.el (list-buffers-noselect): Use `dolist' instead Of
	`while'; use `with-current-buffer' instead of `save-excursion'.
	Removed unnecessary kludges now that "*Buffer List*" is excluded.

2000-08-16  Kenichi Handa  <handa@etl.go.jp>

	* international/ccl.el (declare-ccl-program): Docstring modified.
	(ccl-execute-with-args): Likewise.

2000-08-16  Miles Bader  <miles@gnu.org>

	* progmodes/sql.el: Add compatibility definition of
	comint-line-beginning-position.

2000-08-15  Gerd Moellmann  <gerd@gnu.org>

	* buff-menu.el (list-buffers-noselect): Set `buffer' as well as
	'buffer-menu' property.
	(Buffer-menu-buffer): Use `buffer' property if `buffer-name'
	fails.
	(Buffer-menu-execute): When deleting, test `(and buf (buffer-name
	buf))', instead of `(Buffer-menu-buffer nil)', to see if buffer
	wasn't killed.

	* buff-menu.el (list-buffers-noselect): Don't display the
	*Buffer List* buffer.

	* font-lock.el: Require jit-lock to prevent a very late
	`Loading jit-lock' message.

	* emacs-lisp/cust-print.el, emacs-lisp/cl-specs.el
	* emacs-lisp/edebug.el, progmodes/hideif.el: Change authors'
	mail address.

2000-08-15  Miles Bader  <miles@gnu.org>

	* textmodes/ispell.el (ispell-graphic-p): New constant.
	(ispell-choices-win-default-height, ispell-help): Use
	`ispell-graphic-p' instead of `xemacsp'.

2000-08-15  Dave Love  <fx@gnu.org>

	* simple.el: Autoload widget-convert when compiling.
	(mail-user-agent): Doc fix.

	* help.el (function-called-at-point, variable-at-point): Use
	with-syntax-table.
	(help-manyarg-func-alist): Add insert-and-inherit.

	* thingatpt.el (thing-at-point-url-regexp): Prepend `\<'.

	* delsel.el (delsel-unload-hook): New function.

	* find-file.el: Doc fixes.  Move provide to end.
	(ff) <defgroup>: Add :link.
	(ff-goto-click): Deleted.
	(ff-mouse-find-other-file, ff-mouse-find-other-file-other-window):
	Use mouse-set-point.

	* textmodes/tildify.el: Doc fixes.
	(tildify) <defgroup>: Add:version.

	* progmodes/glasses.el (glasses) <defgroup>: Add :version.
	(glasses-custom-set): Use set-default, not set.
	(minor-mode-alist): Propertize the lighter.
	(glasses-mode): Provide optional arg.

	* progmodes/cwarn.el (cwarn) <defgroup>: Add :version, :link.
	(global-cwarn-mode): Don't make it a user option.  Unquote lambda.
	(cwarn-font-lock-feature-keywords-alist): Don't make it a user
	option.  Provide :type.
	(cwarn-configuration): Provide :type.
	(cwarn-mode): Doc fix.

	* add-log.el (change-log-merge): Doc fix.
	(change-log-redate): New command.

	* net/browse-url.el (browse-url-filename-alist): Add a clause for
	Doze and Dog.
	(browse-url): Use dolist, not mapcar.
	(browse-url-at-point): Check for null url.
	(browse-url-event-buffer, browse-url-event-point): Functions
	deleted.
	(browse-url-at-mouse, browse-url-netscape): Simplify.

	* msb.el (msb--few-menus, msb--very-many-menus): Use current Gnus
	modes.
	(msb--init-file-alist, msb--aggregate-alist, msb--add-separators):
	Fix previous change to mapcan.
	(msb--init-file-alist, msb--add-separators)
	(msb--make-keymap-menu): Simplify.
	(msb--choose-file-menu): Use copy-sequence.
	(msb-mode-map): Add title to keymap.
	(msb-unload-hook): New function.

	* bs.el: Fix indentation.
	(bs) <defgroup>: Add :links.
	(bs-show): Doc fix.
	(bs-apply-sort-faces): Don't use window-system.
	(bs-mode-font-lock-keywords): Avoid testing for XEmacs.

2000-08-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* calendar/timeclock.el (timeclock-file): Run .timelog through
	convert-standard-filename.

2000-08-14  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/authors.el: New file.

	* paren.el (show-paren-priority): New user option.
	(show-paren-function): Set overlay priorities to
	show-paren-priority.

2000-08-14  Miles Bader  <miles@gnu.org>

	* comint.el (comint-bol): Use `forward-line 0' instead of calling
	beginning-of-line with inhibit-field-text-motion bound.

2000-08-14  Gerd Moellmann  <gerd@gnu.org>

	* calendar/timeclock.el: New file.

2000-08-14  David Ponce  <david@dponce.com>

	* recentf.el (recent-dialog-mode-map): Bind down-mouse-1 to
	`widget-button-click'. so that one can use left mouse button to
	click on dialog buttons.

2000-08-14  Emmanuel Briot  <briot@gnat.com>

	* xml.el (xml-parse-tag, xml-parse-attlist): Do not downcase
	identifiers, since XML is case sensitive

2000-08-12  Miles Bader  <miles@gnu.org>

	* comint.el (comint-output-filter): Don't bother frobbing
	window-start, it doesn't seem to be necessary.

	* comint.el (comint-send-string, comint-send-region): Make into
	real functions.  Snapshot the prompt before sending.

2000-08-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (Info-find-emacs-command-nodes): Rewrite to use
	technique similar to Info-index, instead of relying on specific
	names of relevant Index nodes.
	(Info-goto-emacs-command-node): Bind Info-history to nil when
	going to the first node found by Info-find-emacs-command-nodes.

2000-08-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el (menu-bar-help-menu): Add a :help string.

2000-08-10  Miles Bader  <miles@gnu.org>

	* comint.el (comint-output-filter): Doc fixes & misc code cleanup.

2000-08-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (Info-file-list-for-emacs): More elements for the
	autotype, vip, ebrowse, cl, idlwave, reftex, widget, pcl-cvs,
	and woman manuals.

2000-08-10  Miles Bader  <miles@lsi.nec.co.jp>

	* comint.el (comint-send-input): Make the newline boundary overlay
	rear-nonsticky.  Use `insert' instead of `insert-before-markers'.
	(comint-output-filter): Use `insert' instead of
	`insert-before-markers'.  Extend comint-last-output-overlay when
	necessary since we can't rely on insert-before-markers to do it.
	* gud.el (gud-filter): Use `with-current-buffer' instead of
	save-excursion when inserting the output, so that point gets
	updated correctly; the old method relied on a rather dodgy
	side-effect of comint-output-filter to avoid the effect of
	save-excursion.

2000-08-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (recover-file): Call insert-directory instead of
	invoking `ls' directly.

2000-08-10  Miles Bader  <miles@gnu.org>

	* comint.el (comint-highlight-prompt, comint-highlight-prompt-face)
	(comint-last-prompt-overlay): New variables.
	(comint-output-filter): Implement prompt highlighting.
	(comint-snapshot-last-prompt): New function.
	(comint-send-input): Snapshot the last prompt.
	Use comint-highlight-input-face.
	(comint-highlight-input-face): Renamed from `comint-highlight-face'.
	Use defface instead of defcustom.
	(send-invisible, comint-send-eof): Snapshot the last prompt.
	(comint-delchar-or-maybe-eof): Use comint-send-eof.
	(comint-mode): Make `comint-last-prompt-overlay' buffer-local.

2000-08-09  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/regexp-opt.el (make-bool-vector): Remove.
	(regexp-opt-group): Use a list of chars for `letters'.
	(regexp-opt-charset): `chars' is now a list of chars.
	Use a char-table rather than a vector so it works for multibyte chars.

	* pcvs.el (cvs-menu): Don't move point.  Use popup-menu.
	Set cvs-minor-current-files to the selected fileinfo.
	(cvs-get-marked): Accept fileinfos in cvs-minor-current-files.
	(cvs-mode-insert): Manually macroexpand `ignore-errors'.

2000-08-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (insert-directory): Don't call access-file on
	directories on DOS and Windows.

2000-08-09  Kenichi Handa  <handa@etl.go.jp>

	* international/ccl.el (ccl-embed-data): Make ccl-program-vector
	longer if necessary.
	(ccl-embed-code): Call ccl-embed-data to store CODE in
	ccl-program-vector.

2000-08-09  Miles Bader  <miles@gnu.org>

	* comint.el (comint-output-filter): Properly handle the case where
	the text surrounded by comint-last-output-overlay was deleted.

2000-08-08  Gerd Moellmann  <gerd@gnu.org>

	* info.el (Info-insert-dir): Use Info-additional-directory-list if
	non-nil.
	(Info-file-list-for-emacs): Remove "info" from the list because
	that leads to trying to use the documentation from file `info'
	in various situations where it isn't appropriate, for instance
	C-h C-k C-h i.

	* ffap.el (ffap-read-file-or-url-internal): Handle case that
	DIR and/or STRING are nil.

	* progmodes/compile.el (compilation-setup): Make variable
	compilation-error-screen-columns buffer-local, as some comment
	in the code suggests it should be.

	* files.el (auto-mode-interpreter-regexp): New variable.
	(set-auto-mode): Use it.

	* indent.el (indent-for-tab-command): Doc fix.

	* mouse-sel.el (mouse-sel-mode): Doc fix.

	* emacs-lisp/lisp-mode.el (eval-last-sexp-1): Handle `#N='
	labels.

	* help.el (print-help-return-message): When
	display-buffer-reuse-frames is set, let the help window been quit,
	instead of deleting it, which might delete a reused frame.

2000-08-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired-aux.el (dired-do-create-files): On DOS/Windows, allow to
	rename a directory to a name that differs only by its letter case.

2000-08-08  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-define-rules): Handle Quail decode
	map correctly.  Add code for supporting annotations.
	(quail-install-decode-map): New function.
	(quail-defrule-internal): New optional arguments decode-map and
	props.
	(quail-advice): New function.

2000-08-07  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/cl-indent.el (toplevel): Indent `defclass',
	`defconst', `define-condition', `with-slots'.
	* font-lock.el (lisp-font-lock-keywords-2): Added `with-' and `do-'.

2000-08-03  Miles Bader  <miles@gnu.org>

	* comint.el (comint-use-prompt-regexp-instead-of-fields):
	New variable.
	(comint-prompt-regexp, comint-get-old-input): Document dependence on
	comint-use-prompt-regexp-instead-of-fields.
	(comint-send-input): Add `input' field property to stuff we send to
	the process, if comint-use-prompt-regexp-instead-of-fields is nil.
	(comint-output-filter): Add `output' field property to process
	output, if comint-use-prompt-regexp-instead-of-fields is nil.
	(comint-replace-by-expanded-history)
	(comint-get-old-input-default, comint-show-output)
	(comint-backward-matching-input, comint-forward-matching-input)
	(comint-next-prompt, comint-previous-prompt):  Use field
	properties if comint-use-prompt-regexp-instead-of-fields is nil.
	(comint-line-beginning-position): New function.
	(comint-bol): Use comint-line-beginning-position.  Make ARG optional.
	(comint-replace-by-expanded-history-before-point): Use
	comint-line-beginning-position and line-end-position.
	(comint-last-output-overlay): New variable.
	(comint-mode): Make `comint-last-output-overlay' buffer-local.

	* shell.el (shell-prompt-pattern): Doc change.
	(shell-backward-command): Use line-beginning-position.

	* gud.el (gud-gdb-complete-command): Use
	comint-line-beginning-position.

	* ielm.el (ielm-indent-line): Detect a "prompt" line by seeing if
	comint-bol doesn't actually go to the beginning of the line.

	* hippie-exp.el (try-expand-line): Only use comint-prompt-regexp
	if comint-use-prompt-regexp-instead-of-fields is non-nil.
	(try-expand-line-all-buffers): Likewise.

	* progmodes/sql.el (sql-magic-go): Use comint-bol instead of
	explicitly matching comint-prompt-regexp.
	(sql-copy-column): Use comint-line-beginning-position instead of
	explicitly matching comint-prompt-regexp.

	* progmodes/octave-inf.el (inferior-octave-complete): Use
	comint-line-beginning-position.

	* progmodes/inf-lisp.el (inferior-lisp-prompt): Doc change.

	* progmodes/idlw-shell.el (idlwave-shell-send-command): When
	looking for a prompt, use `forward-line 0' instead of
	`beginning-of-line', to avoid getting caught by an input field.

2000-08-07  Gerd Moellmann  <gerd@gnu.org>

	* files.el (shell-quote-wildcard-pattern): Make sure to return
	PATTERN, in the Unix case.

2000-08-07  Eli Zaretskii  <eliz@is.elta.co.il>

	* play/zone.el (zone): Discard any pending input before running
	the randomly-chosen pgm.

2000-08-07  Kenichi Handa  <handa@etl.go.jp>

	* emacs-lisp/bytecomp.el (byte-compile-fix-header): Fix the way of
	checking the existence of any multibyte characters.

2000-08-06  Gerd Moellmann  <gerd@gnu.org>

	* help.el (describe-mode): Test minor-mode symbol for being
	bound before testing its value for being nil.

	* pcvs-util.el, cvs-status.el, pcvs.el: Use `nth' instead of
	`first', `second', and `third'.

	* emacs-lisp/cl.el (third...tenth): Undo change of 2000-08-05.
	(second): Make it an alias for `cadr'.

2000-08-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* bs.el (bs-apply-sort-faces): Don't use window-system, since all
	types of display support faces now.

2000-08-05  Gerd Moellmann  <gerd@gnu.org>

	* pcvs.el (require): Require `cl' during compilation, only.

	* emacs-lisp/cl.el (first, ..., tenth): Make them macros.
	(toplevel): Remove `remq' and `remove' from autoloads.
	(cl-fake-autoloads): New variable.  If set, arrange for an error
	when CL functions etc. are autoloaded.

2000-08-04  Eli Zaretskii  <eliz@is.elta.co.il>

	* play/zone.el (zone, zone-pgm-stress): Don't use window-system.

	* hi-lock.el (hi-lock-unface-buffer): If a menu of regexps is
	popped up, but the user clicks outside the menu, return an empty
	regexp (that causes unhighlight-regexp to have no effect).

	* menu-bar.el (menu-bar-games-menu): Add Zone.

	* hi-lock.el (toplevel): Require font-lock.

2000-08-03  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* progmodes/ebnf2ps.el: Get around a bug on skip-chars-forward.
	(ebnf-8-bit-chars): New var for bug fix.
	(ebnf-string): Bug fix.

2000-08-03  Sam Steingold  <sds@gnu.org>

	* pcvs.el (cvs-do-commit): Use `buffer-substring-no-properties'
	instead of `buffer-string'.
	(require 'cl): Always, not just when compiling.
	`ignore-errors' in `interactive', `list*', `defun*' &c make this
	necessary.

2000-08-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule-cmds.el (select-safe-coding-system): Make
	the message text about selecting a safe coding system more clear.

2000-08-02  Gerd Moellmann  <gerd@gnu.org>

	* hi-lock.el: New file.

	* play/zone.el: New file.

	* replace.el (occur): Set tab-width in the *Occur* buffer to the
	value of tab-width in the original buffer.  Choose a line number
	format that's a multiple of the original buffer's tab width, so
	that lines appear right.

	* textmodes/ispell.el (ispell): New function, replacing an alias.
	Spell-check active region if in transient-mark-mode and mark
	is active; otherwise spell-check buffer.

2000-08-02  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-mule.el: Fix a customization problem on
	ps-mule-font-info-database-default.

2000-08-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* progmodes/ebrowse.el (ebrowse-tree-mode-map): Use
	display-mouse-p instead of window-system.
	(ebrowse-member-mode-map): Ditto.

2000-08-01  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* progmodes/ebnf2ps.el: Update ps-print functions call.
	Indentation fix.  Doc fix.
	(ebnf-version): New version number (3.2).
	(ebnf-format-color, ebnf-begin-job): Code fix.

2000-08-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* net/net-utils.el (nslookup-font-lock-keywords): Don't condition
	font lock support on window-system.
	(ftp-font-lock-keywords, smbclient-font-lock-keywords): Likewise.

	* textmodes/ispell.el (ispell-highlight-spelling-error): Use
	display-color-p, if fboundp, instead of window-system.

2000-07-31  Eli Zaretskii  <eliz@is.elta.co.il>

	* calendar/appt.el (appt-disp-window): Use display-multi-frame-p
	instead of window-system.

	* wid-edit.el (widget-choose): Use display-mouse-p instead of
	window-system.
	(widget-choice-mouse-down-action): Use display-popup-menus-p
	instead of window-system.

	* strokes.el (strokes-file): Run the file name through
	convert-standard-filename.
	(strokes-mode): Call display-mouse-p instead of looking at
	window-system.  Change the error message accordingly.

	* progmodes/cpp.el (toplevel): Support faces on tty's.

	* play/landmark.el (lm-font-lock-face-O, lm-font-lock-face-X)
	(lm-plot-square, lm-init-display): Don't use window-system.

	* play/gomoku.el (gomoku-font-lock-O-face, gomoku-font-lock-X-face)
	(gomoku-plot-square, gomoku-init-display): Don't use window-system.

	* mail/rmail.el (rmail-start-mail): Use display-multi-frame-p
	instead of looking at window-system.

2000-07-30  Gerd Moellmann  <gerd@gnu.org>

	* iswitchb.el (iswitchb-entryfn-p): Test this-command instead
	of testing if iswitchb-prepost-hooks is bound, because the
	latter will always be true when invoking a recursive minibuffer
	from an active Iswitchb buffer.

2000-07-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (shell-quote-wildcard-pattern): New function.
	(insert-directory): Call it.  Only prepend "\" to command on Unix
	and GNU/Linux systems.

2000-07-30  Gerd Moellmann  <gerd@gnu.org>

	* eshell/esh-groups.el: Change custom :link file names
	from `eshell.info' to `eshell'.

2000-07-30  Francis Wright  <fjw@maths.qmw.ac.uk>

	* dired.el (dired-build-subdir-alist): Expand subdirectory names
	correctly in recursive ange-ftp listings.

2000-07-30  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Fix bug 1: if ps-font-size-internal,
	ps-header-font-size-internal and
	ps-header-title-font-size-internal variables are not set,
	ps-nb-pages and ps-line-lengths-internal crashes.  Fix bug 2: if
	face text property is (foreground-color . COLOR) or
	`(background-color . COLOR)', ps-print crashes.  Doc fix.
	(ps-print-version): New version number (5.2.4).
	(ps-plot-region): Code fix.
	(ps-nb-pages, ps-line-lengths-internal): Bug fix 1.
	(ps-face-attribute-list, ps-face-attributes, ps-face-background):
	Bug fix 2.

2000-07-30  Milan Zamazal  <pdm@freesoft.cz>

	* glasses.el (glasses-make-readable): Fix uncapitalization of
	identifiers like `myXMLDocument'.

2000-07-28  Karl Fogel  <kfogel@red-bean.com>

	* mail/mail-hist.el (mail-hist-previous-input)
	(mail-hist-next-input): Do the obvious code factorization.
	(mail-hist-retrieve-and-insert): New func, contains common
	code of above two.
	If inserting a message body, leave point at top.

2000-07-28  Sam Steingold  <sds@gnu.org>

	* net/ange-ftp.el (ange-ftp-verify-visited-file-modtime):
	Use `<=', not `<' to compare times!
	(ange-ftp-ls): Remove.

2000-07-27  Gerd Moellmann  <gerd@gnu.org>

	* play/cookie1.el: Add explanation of how to make cookie.el
	compatible with strfile(1) to comment.

	* subr.el (remove, remq): New functions.

	* midnight.el (clean-buffer-list-kill-never-regexps): Correctly
	escape `*' in regexps.
	(midnight-find): Reverse order of arguments in the funcall of
	TEST.

	* bindings.el (completion-ignored-extensions): Add `.la', `.lo',
	and `.class'.

	* play/meese.el: Add Commentary section.

2000-07-27  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-ms): Added autoload cookie.
	(sql-ingres, sql-solid, sql-mysql, sql-informix, sql-sybase)
	(sql-oracle): Ditto.
	(sql-help): Doc change.

	(sql-mode-oracle-font-lock-keywords): Added PL/SQL keywords, data
	types and exceptions.

2000-07-27  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-placeholder-history): New variable.
	(sql-query-placeholders-and-send): New function that will query
	the user and replace placeholders with user input.
	(sql-oracle): If running on NT, set comint-input-sender to
	sql-query-placeholders-and-send.

	(sql-stop): If in the SQLi buffer, insert stop notification, else
	present it as a message.

2000-07-27  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-input-ring-separator): Doc change.
	(sql-input-ring-file-name): Doc change.
	(sql-interactive-mode): Use `sql-input-ring-separator' and
	`sql-input-ring-file-name' to set the comint-mode equivalents
	without making them local variables.
	(sql-stop): Don't bind `sql-input-ring-separator' and
	`sql-input-ring-file-name' dynamically to their comint-mode
	equivalents.

2000-07-27  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (register-char-codings): New function.
	(make-coding-system): Handle `safe-chars' specification in the arg
	PROPERTY.

	* international/mule-cmds.el
	(find-coding-systems-region-subset-p): This function deleted.
	(sort-coding-systems-predicate): New variable.
	(sort-coding-systems): New function.
	(find-coding-systems-region): Use
	find-coding-systems-region-internal.
	(find-coding-systems-string): Use find-coding-systems-region.
	(find-coding-systems-for-charsets): Check
	char-coding-system-table.
	(select-safe-coding-system-accept-default-p): New variable.
	(select-safe-coding-system): Mostly rewritten.  New argument
	ACCEPT-DEFAULT-P.
	(select-message-coding-system): Call select-safe-coding-system
	with ACCEPT-DEFAULT-P arg.
	(reset-language-environment): Reset default-sendmail-coding-system
	to the default value iso-latin-1.
	(set-language-environment): Don't set the obsolete variable
	charset-origin-alist.

	* international/codepage.el (cp-coding-system-for-codepage-1):
	Give `safe-chars' property to make-coding-system.

	* mail/sendmail.el (sendmail-send-it): Improve the way to avoid
	calling select-message-coding-system twice.

	* language/cyrillic.el (cyrillic-koi8): Use `safe-chars' property
	instead of `safe-charsets'.
	(cyrillic-alternativnyj): Likewise.
	(ccl-encode-alternativnyj): Don't check the charset
	cyrillic-iso8859-5.

2000-07-27  Kenichi Handa  <handa@etl.go.jp>

	* composite.el (compose-chars-after): Preserve match data.

2000-07-26  Sam Steingold  <sds@gnu.org>

	* net/ange-ftp.el (ange-ftp-file-newer-than-file-p): New function.
	(ange-ftp-real-file-newer-than-file-p): New function.
	(ange-ftp-verify-visited-file-modtime): Use `float-time'.
	(ange-ftp-dot-to-slash): Removed (use `subst-char-in-string').

	* tooltip.el (tooltip-float-time): Removed (use `float-time').
	* midnight.el (midnight-float-time): Ditto.

2000-07-26  Andreas Schwab  <schwab@suse.de>

	* files.el (normal-backup-enable-predicate): Correct
	interpretation of the return value of compare-strings.

2000-07-26  Gerd Moellmann  <gerd@gnu.org>

	* isearch.el (isearch-resume): New function.
	(isearch-done): Add something to command-history to resume
	the search.
	(isearch-yank-line, isearch-yank-word): Use
	buffer-substring-no-properties instead of buffer-substring.

	* textmodes/flyspell.el (flyspell-mouse-map): Use `map' instead
	of flyspell-mouse-map.

	* progmodes/make-mode.el (makefile-mode-abbrev-table): Remove
	duplicate definition.
	(makefile-mode): Remove duplicate setting of local-abbrev-table.

	* progmodes/m4-mode.el (m4-mode-abbrev-table): New variable.
	(m4-mode): Set local-abbrev-table to m4-mode-abbrev-table.

2000-07-25  Sam Steingold  <sds@gnu.org>

	* net/ange-ftp.el: Get modtime over the net.
	(ange-ftp-file-modtime): New function.
	(ange-ftp-write-region, ange-ftp-insert-file-contents)
	(ange-ftp-file-attributes, ange-ftp-verify-visited-file-modtime):
	Use it.
	(ange-ftp-dot-to-slash): New function.
	(ange-ftp-fix-name-for-vms): Use it.

	* midnight.el (midnight-buffer-display-time): Use
	`with-current-buffer'.

2000-07-25  Gerd Moellmann  <gerd@gnu.org>

	* find-dired.el: Update copyright notice.
	(find-dired): Offer to kill a running `find'.

	* enriched.el (enriched-face-ans): For a `foreground-color'
	property, return '(("x-color" COLOR))' so that COLOR will be
	output as a parameter of the x-color annotation.  Likewise for the
	`background-color' property.  In the case of normal face
	properties, don't return annotations for unspecified foreground
	and background face attributes.

2000-07-25  Kenichi Handa  <handa@etl.go.jp>

	* language/japan-util.el (japanese-katakana-region): Fix handling
	HANKAKU argument.

2000-07-25  Miles Bader  <miles@gnu.org>

	* simple.el (line-move): Pass INHIBIT-CAPTURE-PROPERTY argument to
	constrain-to-field.  Pass nil ESCAPE-FROM-EDGE argument to
	constrain-to-field.

2000-07-24  Andrew Innes  <andrewi@gnu.org>

	* timer.el (timer-activate-when-idle): Add optional parameter
	DONT-WAIT.  Update docstring.
	(run-with-idle-timer): Specify extra parameter to
	timer-activate-when-idle, so that timer will be activated
	immediately if Emacs is already idle.

	* w32-fns.el (w32-using-nt): Fix docstring.

2000-07-24  Dave Love  <fx@gnu.org>

	* mouse.el (popup-menu): Set last-command-event.
	(mouse-major-mode-menu-prefix): Declare.

2000-07-24  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/flyspell.el: Update to author's version 1.5d.

	* progmodes/hideshow.el: Update copyright notice.

	* vcursor.el: Set maintainer to FSF, since author cannot
	be reached.

2000-07-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (Info-goto-emacs-key-command-node): Leave a space after
	the prompt.

	* mouse.el (popup-menu): Run the keymap through indirect-function,
	in case it was defined with define-prefix-key.  If the menu is a
	list of keymaps, look up the binding of user's choice in each one
	of the keymaps.
	(mouse-popup-menubar): If the global and local menu-bar keymaps
	don't have a prompt string, create one and insert it into the
	keymap.  Don't barf if current-local-map returns nil.

2000-07-24  Francis Wright  <fjw@maths.qmw.ac.uk>

	* dired.el (dired-sort-R-check): Added to allow recursive listing
	to be undone.
	(dired-sort-other): Use it.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release of cc-mode 5.27

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block): Replaced a call to
	c-beginning-of-statement-1 that caused a bad case of recursion
	which could consume a lot of CPU in large classes in languages
	that have in-expression classes (i.e. Java and Pike).

	* cc-engine.el (c-guess-basic-syntax): Check for in-expression
	statements before top level constructs (i.e. case 6 is moved
	before case 5 and is now case 4) to catch in-expression
	classes in top level expressions correctly.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Less naive handling of
	objc-method-intro. Case 4 removed and case 5I added.

	* cc-langs.el (c-append-paragraph-start): New variable used by
	c-common-init to get paragraph-start correct.
	* cc-langs.el (c-common-init): Use c-append-paragraph-start to
	initialize paragraph-start to make it correct both with and
	without the javadoc special case.

	* cc-mode.el (java-mode): Use c-append-paragraph-start to
	initialize paragraph-start for javadoc markup.

	* cc-vars.el (c-style-variables-are-local-p): Incompatible
	change by defaulting this to t.  It's motivated by the
	confusing behavior that otherwise arise from the style system
	when editing both java and non-java files at the same time
	(see the comments about style setting in c-common-init).

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-new-comment-line): Added a kludge
	similar to the one in c-fill-paragraph to check the fill
	prefix from the adaptive fill function for sanity.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-end-of-defun-1): Fixed forward scanning into
	defun block.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi Documented the change of cpp-macro.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-multi-inher): Handle lines with
	leading comma nicely. Extended to handle member initializers
	too.

	* cc-engine.el: (c-beginning-of-inheritance-list,
	c-guess-basic-syntax): Fixed recognition of inheritance lists
	when the lines begins with a comma.

	* cc-mode.texi: Updated doc for c-lineup-multi-inher.

	* cc-vars.el (c-offsets-alist): Changed default for
	member-init-cont to c-lineup-multi-inher since it now handles
	member initializers and indents better for leading commas.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Fixed some bugs in the state
	handling that caused class open lines to be recognized as
	statement-conts in some cases.

	* cc-cmds.el (c-indent-new-comment-line): Keep the fill prefix
	guessed by the adaptive fill function unless point is on the
	first line of a block comment.

	* cc-engine.el (c-forward-syntactic-ws): Fixed an infloop bug
	when the buffer ends with a macro continuation char.

	* cc-engine.el (c-guess-basic-syntax): Added support for
	function definitions as statements in Pike.  The first
	statement in a lambda block is now labeled defun-block-intro
	instead of statement-block-intro.

	* cc-engine.el (c-narrow-out-enclosing-class): Whack the state
	so that the class surrounding point is selected, not the one
	innermost in the state.

	* cc-engine.el (c-guess-basic-syntax): Fixed bug in
	recognition of switch labels having hanging multiline
	statements.

	* cc-engine.el (c-beginning-of-member-init-list): Broke out
	some code in c-guess-basic-syntax to a separate function.
	* cc-engine.el (c-just-after-func-arglist-p): Fixed
	recognition of member inits with multiple line arglists.
	* cc-engine.el (c-guess-basic-syntax): New case 5B.3 to detect
	member-init-cont when the commas are in funny places.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-auto-newline): Removed this macro since it's
	not used anymore.

	* cc-engine.el (c-looking-at-bos): New helper function.
	* cc-engine.el (c-looking-at-inexpr-block): More tests to tell
	inexpr and toplevel classes apart in Pike.

	* cc-engine.el (c-guess-basic-syntax): Fixed bogus recognition
	of case 9A.

	* cc-langs.el, cc-mode.el (c-Pike-inexpr-class-key): New
	constant, since "class" can introduce an in-expression class
	in Pike nowadays.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-gnu-impose-minimum): Don't impose minimum
	indentation on cpp-macro lines.

	* cc-engine.el (c-guess-basic-syntax): Made the cpp-macro
	a syntax modifier like comment-intro, to make it possible to
	get syntactic indentation for preprocessor directives.  It's
	incompatible wrt to lineup functions on cpp-macro, but it has
	no observable effect in the 99.9% common case where cpp-macro
	is set to -1000.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed bug with missed
	member-init-cont when the preceding arglist is several lines.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-style-alist): The basic offset for the BSD
	style corrected to 8.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-style-alist): Adjusted the indentation of
	brace list openers in the gnu style.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-command): Obey c-syntactic-indentation.

	* cc-cmds.el (c-electric-brace, c-electric-slash,
	c-electric-star, c-electric-semi&comma, c-electric-colon,
	c-electric-lt-gt, c-electric-paren): Don't reindent old lines
	when c-syntactic-indentation is nil.

	* cc-engine.el (c-beginning-of-statement-1): Fixed bug where
	we were left at comments preceding the first statement when
	reaching the beginning of the buffer.

	* cc-vars.el (c-syntactic-indentation): New variable to turn
	off all syntactic indentation.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-fill-paragraph): Keep one or two spaces
	between the text and the block comment ender when it hangs,
	depending on how many there are before the fill.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-closest-statement): New helper
	function to go back to the closest preceding statement start,
	which could be inside a conditional statement.
	* cc-engine.el (c-guess-basic-syntax): Use
	c-beginning-of-closest-statement in cases 10B.2, 17B and 17C.

	* cc-engine.el (c-guess-basic-syntax): Better handling of
	arglist-intro, arglist-cont-nonempty and arglist-close when
	the arglist is nested inside parens.  Cases 7A, 7C and 7F
	changed.

	* cc-langs.el (c-Java-javadoc-paragraph-start): Brought
	up-to-date with javadoc 1.2.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Fixed handling of
	multiline Pike type decls.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-new-comment-line): Always break
	multiline comments in multiline mode, regardless of
	comment-multi-line.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed bug with
	fully::qualified::names in C++ member init lists.  Preamble in
	case 5D changed.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-common-init): Handling of obsolete variables
	moved to c-initialize-cc-mode.  More compatible style override
	when using global style variables.
	* cc-mode.el (c-initialize-cc-mode): Handling of obsolete
	variables moved here.

	* cc-mode.texi: Documented the special behavior of
	c-special-indent-hook as a style variable.  Don't talk about
	doing (c-make-styles-buffer-local t) in a mode hook, since
	that's already too late to work right.

	* cc-styles.el (c-make-styles-buffer-local): Flag style
	variable localness in c-style-variables-are-local-p to make
	the compatibility measure in c-common-init work well.

	* cc-styles.el (c-set-style-1): c-special-indent-hook can no
	longer contain set-from-style.
	* cc-styles.el (c-initialize-builtin-style): Don't check for
	set-from-style on c-special-indent-hook.
	* cc-styles.el (c-copy-tree): Obsolete.  The standard function
	copy-alist is sufficient now.

	* cc-styles.el (c-set-style, c-set-style-1,
	c-get-style-variables): Fixes to variable initialization so
	that duplicate entries in styles have the same effect
	regardless of DONT-OVERRIDE.

	* cc-styles.el (c-set-style-2): Fixed bug where the
	initialization of inheriting styles failed when the
	dont-override flag is set.

	* cc-vars.el (c-special-indent-hook): Don't use set-from-style
	on this.

2000-07-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-forward-comment): Removed the workaround
	introduced in 5.38 since it had worse side-effects.  If a line
	contains the string "//\"", it regarded the // as a comment
	start since the \ temporarily doesn't have escape syntax.

2000-07-17 Emmanuel Briot <briot@act-europe.fr>

	* ada-mode.el Got rid of all byte-compiler warnings on Emacs Load
	ada-xref.el before ada-prj.el, so that the Project menu is created
	when ada-prj tries to add to it.
	(ada-activate-keys-for-case): Suppress the characters that are not
	part of the Ada syntax. Better compatibility with else-mode
	(ada-adjust-case-interactive): When auto-casing is not active,
	correctly insert newlines (used to insert only ^M).  Prevent the
	syntax table from being changed in case of an error
	(or '_' becomes part of a word and some commands are confused).
	Do nothing if ada-auto-case is nil.
	(ada-after-keyword-p): Ignore keywords that are also attributes
	(ada-batch-reformat): Update usage comment
	(ada-call-from-contextual-menu): New function
	(ada-case-read-exceptions): Reinitialize the casing exception list
	first to nil first, so that the casing exception file can be
	shared.
	(ada-check-defun-name): Handles "configure" keyword for gnatdist
	files.
	(ada-compile-goto-error): Fix regexp used to detect a file:line
	anywhere in the error message
	(ada-contextual-menu-last-point): New variable
	(ada-create-keymap): If the variable delete-key-deletes-forward is
	t on XEmacs, it means that DEL should delete one character
	forward.
	(ada-create-menu): Use :included instead of :visible for XEmacs.
	New submenu "Options".
	(ada-end-stmt-re): Correctly indent "select ... then abort"
	statements.
	(ada-fill-comment-paragraph): Correctly delete all leading '--'
	even if they don't match ada-fill-comment-prefix Fix handling of
	paragraphs on the first or last line of a file.
	(ada-format-paramlist): Fix handling of default parameter values.
	(ada-get-body-name): New function.
	(ada-get-current-indent): Optimized by searchling directly for an
	existing generic part or a statement outside of it.  Handle
	ada-indent-align-comments when indenting comments Replaced some
	regexps by testing directly the next character. This results in a
	huge speedup on some files.  New indentation scheme for renames
	statements.  Stop looking for the 'while' or 'for' associated with
	a 'loop' at the first semicolon encountered.  A "return" can also
	match an anonymous access subprogram declaration.
	(ada-get-indent-noindent): Ignore strings and comments when
	looking for the keywords "record" and "private".
	(ada-goto-matching-decl-start): When matching "if", make sure we
	are not in fact seeing "end if".  Ignore "when" statements except
	when initial keyword was "begin".  Fix handling of nested
	procedures.  Add a recursive call to this function to skip over
	other 'end' statmts.  Fix indentation for "when .. => begin"
	(ada-in-open-paren-p): Fix indentation for complex boolean
	expressions, where 'and then', 'or else' and parenthesis
	statements are mixed up.
	(ada-in-paramlist-p): Skip comments while searching for the
	beginning Fix handling of operator declarations.
	(ada-indent-align-comments): New variable
	(ada-indent-current): Change the syntax table only in the
	protected section, so that we are sure it is restored correctly.
	(ada-indent-on-previous-lines): Use ada-use-indent and
	ada-with-indent Correctly indent "select ... then"
	(ada-indent-region): Slight speedup.
	(ada-indent-renames): New variable.
	(ada-last-which-function-subprog, ada-last-which-function-line):
	New variables
	(ada-looking-at-semi-private): Correctly indent the 'private'
	keyword when it is the first word in a package declaration.
	(ada-loose-case-word): Stop searching if at the end of the buffer.
	(ada-loose-case-word, ada-capitalize-word): Recase the whole word
	even if point is not initially at the end of the word.
	(ada-matching-decl-start-re): Add "when".
	(ada-mode): Add support for abbrev-mode, outline-mode and
	which-func-mode Override the old find-file.el entry in
	ff-special-constructs since it is using the obsolete
	ada-spec-suffix variable
	(ada-no-auto-case): New function
	(ada-scan-paramlist): When parsing the argument type, accept
	spaces (as in "X 'Class", generated by Rational Rose).
	(ada-other-file-name): No longer loads the other file.
	(ada-popup-menu): Save and restore the current buffer and cursor
	position before and after displaying the menu.
	(ada-search-ignore-complex-boolean): New function.
	(ada-uncomment-region): Emacs21 already knows how to delete
	comments not starting in the first column.
	(ada-use-indent): New variable
	(ada-which-function): New function.
	(ada-with-indent): New variable
	(ada-xemacs): evaluate it at compile time too, so that ada-mode.el
	can be batch-compiled from the command line.

	* ada-xref.el: Got rid of all byte-compiler warnings on Emacs.
	Add to the menu when the file is loaded, not in ada-mode-hook.
	Add -toolbar to the default ddd command Switches moved from
	ada-prj-default-comp-cmd and ada-prj-default-make-cmd to
	ada-prj-default-comp-opt
	(ada-add-ada-menu): Remove the map and name parameters Add the Ada
	Reference Manual to the menu
	(ada-check-current): rewritten as a call to ada-compile-current
	(ada-compile): Removed.
	(ada-compile-application, ada-compile-current, ada-check-current):
	Set the compilation-search-path so that compile.el automatically
	finds the sources in src_dir.  Automatic scrollong of the
	compilation buffer.  C-uC-cC-c asks for confirmation before
	compiling
	(ada-compile-current): New parameter, prj-field
	(ada-complete-identifier): Load the .ali file before doing
	processing
	(ada-find-ali-file-in-dir): prepend build_dir to obj_dir to
	conform to gnatmake's behavior.
	(ada-find-file-in-dir): New function
	(ada-find-references): Set the environment variables for gnatfind
	(ada-find-src-file-in-dir): New function.
	(ada-first-non-nil): Removed
	(ada-gdb-application): Add support for jdb, the java debugger.
	(ada-get-ada-file-name): Load the original-file first if not done
	yet.
	(ada-get-all-references): Handles the new ali syntax (parent types
	are found between <>).
	(ada-initialize-runtime-library): New function
	(ada-mode-hook): Always load a project file when a file is opened,
	so that the casing exceptions are correctly read.
	(ada-operator-re): Add all missing operators ("abs", "rem", "**").
	(ada-parse-prj-file): Use find-file-noselect instead of find-file
	to open the project file, since the latter does not work with
	speedbar Get default values before loading the prj file, or the
	default executable file name is wrong.  Use the absolute value of
	src_dir to initialize ada-search-directories and
	compilation-search-path,...  Add the standard runtime library to
	the search path for find-file.
	(ada-prj-default-debugger): Was missing an opening '{'
	(ada-prj-default-bind-opt, ada-prj-default-link-opt): New
	variables.
	(ada-prj-default-gnatmake-opt): New variable
	(ada-prj-find-prj-file): Handles non-file buffers For non-Ada
	buffers, the project file is the default one Save the windows
	configuration before displaying the menu.
	(ada-prj-src-dir, ada-prj-obj-dir, ada-prj-comp-opt,...): Removed
	(ada-read-identifier): Fix xrefs on operators (for "mod", "and",
	...)  regexp-quote identifiers names to support operators +,
	-,... in regexps.
	(ada-remote): New function.
	(ada-run-application): Erase the output buffer before starting the
	run Support remote execution of the application.  Use
	call-process, or the arguments are incorrectly parsed
	(ada-set-default-project-file): Reread the content of the active
	project file, not the one from the current buffer When a project
	file is set as the default project, all directories are
	automatically associated with it.
	(ada-set-environment): New function
	(ada-treat-cmd-string): New special variable ${current}
	(ada-treat-cmd-string): Revised.  The substitution is now done for
	any ${...} substring
	(ada-xref-current): If no body was found, compiles the spec
	instead.  Setup ADA_{SOURCE,OBJECTS}_PATH before running the
	compiler to get rid of command line length limitations.
	(ada-xref-get-project-field): New function
	(ada-xref-project-files): New variable
	(ada-xref-runtime-library-specs-path)
	(ada-xref-runtime-library-ali-path): New variables
	(ada-xref-set-default-prj-values): Default run command now does a
	cd to the build directory.  New field: main_unit Provide a default
	file name even if the current buffer has no prj file.

	* ada-prj.el:
	Rewritten to show a tabbed-dialog.
	(ada-prj-add-ada-menu): Remove the map and name parameters.
	(ada-prj-display-page, ada-prj-field, ada-prj-initialize-values):
	New function
	(ada-prj-load-directory, ada-prj-subdirs-of): New functions
	(ada-prj-load-from-file): New function
	(ada-prj-save): Always save fields that depend on the current buffer
	(ada-prj-show-value): New function

	* ada-stmt.el (ada-stmt-add-to-ada-menu): Hide the menu if not in
	Ada mode. This will allow us to display the Ada menu in any buffer
	we want (for project items).
	(ada-header-tmpl): Use ada-fill-comment-prefix to put the correct
	number of spaces in the header.

2000-07-24  Dave Love  <fx@gnu.org>

	* ediff-init.el (ediff-region-help-echo): Bind face-help.

2000-07-23  Noah Friedman  <friedman@splode.com>

	* type-break.el (type-break): perform autosave.
	Suggested by Stephen Gildea <gildea@intouchsys.com>.
	(type-break-do-query): Cancel query schedule while performing
	actual query, to avoid possibility of a second query being made
	while first one is already in progress.
	(type-break-time-stamp-format): New variable.
	(type-break-time-stamp): New function.
	(type-break-time-warning): Use it.
	(type-break-keystroke-warning): Use it.
	(type-break-noninteractive-query): Use it.

	* emacs-lisp/eldoc.el (eldoc-minor-mode-string): Add autoload
	cookie.
	Use add-minor-mode to set minor-mode-alist, if available.
	(eldoc-echo-area-use-multiline-p): New user option.
	(eldoc-echo-area-multiline-supported-p): New variable.
	(eldoc-docstring-format-sym-doc): Use them.
	(eldoc-mode): If not using idle timers, append to local post and
	pre command hooks.  Suggested by David Byers <davby@ida.liu.se>.
	(eldoc-display-message-no-interference-p): Don't interfere with
	edebug.
	Add autoload cookie for eldoc-mode minor-mode-alist initialization.
	(eldoc-function-arglist): New function.
	(eldoc-function-argstring): Use it.

	* menu-bar.el (menu-bar-files-menu [recover-session]): Make sure
	auto save directory exists before calling directory-files.

2000-07-23  Dave Love  <fx@gnu.org>

	* international/iso-transl.el (iso-transl-char-map): Fix ^e, ^i,
	^o, ^u.

2000-07-21  Dave Love  <fx@gnu.org>

	* ediff-init.el (ediff-region-help-echo): Modify to use overlay
	now passed to the function.  It now works properly.

	* smerge-mode.el (smerge-mode-menu): Fill it out.

2000-07-20  Gerd Moellmann  <gerd@gnu.org>

	* info-look.el (info-lookup): If *info* is shown in another frame
	on the same display, select that frame, instead of switching to
	the Info buffer in another window of the selected frame.

	* simple.el (universal-argument-map): Bind numeric keypad keys
	kp-0 to kp-9 and kp-subtract.
	(digit-argument): Handle these keys.

2000-07-20  Dave Love  <fx@gnu.org>

	* net/goto-addr.el (goto-address-fontify): Don't bother with
	buffer-modified and read-only stuff -- irrelevant with overlays.
	Put an extra property on the overlays and use it to clean up in
	case goto-address is re-run.

2000-07-19  Richard M. Stallman  <rms@gnu.org>

	* timer.el (run-with-idle-timer): Doc fix.

	* mail/mail-utils.el (mail-strip-quoted-names):
	Handle case where <...> appears inside "...".
	Use replace-match to edit the string more simply.
	(rmail-dont-reply-to): Cope with an unmatched ".

2000-07-19  Dave Love  <fx@gnu.org>

	* ediff-init.el (ediff-region-help-echo): Partially fix for Emacs
	implementation.

	* mouse.el (popup-menu): Allow a list of keymaps for menu arg.
	(mouse-popup-menubar, mouse-popup-menubar-stuff): New functions.
	(global-map): Bind c-down-mouse-3 to mouse-popup-menubar-stuff.

2000-07-19  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/refer.el: Correct maintainer's email address.

	* progmodes/hideif.el: Correct author's email address.
	Fix typo in comment.

	* xml.el: New file.

	* mail/mailheader.el: Correct author's mail address.

	* gnus/parse-time.el: Correct author's mail address.

2000-07-19  Colin Walters <walters@cis.ohio-state.edu>

	* comint.el (comint-highlight-input, comint-highlight-face):
	New user options.
	(comint-input-ring-file-name): Change custom type.
	(comint-mode-map): Bind mouse-2.
	(comint-insert-clicked-input): New function.
	(comint-send-input): Handle input highlighting.

2000-07-18  Stefan Monnier  <monnier@cs.yale.edu>

	* mouse.el (popup-menu): New function.
	(mouse-major-mode-menu): Use it.

2000-07-18  Dave Love  <fx@gnu.org>

	* bindings.el (mode-line-mule-info, mode-line-modified): help-echo
	improvements.

2000-07-18  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (face-font-selection-order)
	(face-font-family-alternatives): Add custom type.

2000-07-18  Dave Love  <fx@gnu.org>

	* cus-edit.el (custom-variable-reset-saved)
	(custom-variable-reset-standard): Remove unused bindings.

	* rect.el (open-rectangle-line): Remove unused let.

	* hl-line.el (hl-line-highlight): Check hl-line-mode.

2000-07-18  Gerd Moellmann  <gerd@gnu.org>

	* cdl.el: Fix `Maintainer' keyword.

	* play/pong.el: Add author's email address.

2000-07-17  Sam Steingold  <sds@gnu.org>

	* files.el (insert-directory): Call `split-string' instead of
	re-implementing it.

2000-07-18  Gerd Moellmann  <gerd@gnu.org>

	* mail/vms-pmail.el: Change maintainer to FSF.

	* net/goto-addr.el: Change maintainer to FSF.

	* recentf.el: Update from author.

	* info.el (Info-title-face-alist): Removed.

2000-07-18  Eli Zaretskii  <eliz@is.elta.co.il>

	* eshell/eshell.el (eshell): Replace links to eshell.info with
	links to eshell, to avoid problems on systems where the manual is
	installed as `eshell'.
	* eshell/esh-cmd.el (eshell-cmd): Ditto.
	* eshell/em-smart.el (eshell-smart): Ditto.
	* eshell/em-banner.el (eshell-banner): Ditto.
	* eshell/em-alias.el (eshell-alias, eshell-bad-command-tolerance): Ditto.

	* eshell/em-unix.el (eshell-shuffle-files): Don't disable
	same-file check in the MS-DOS version (it does support inodes).

	* eshell/em-alias.el (eshell-maybe-replace-by-alias): Doc fix.

	* eshell/eshell.el (eshell-directory-name):
	Run default directory name through convert-standard-filename.

2000-07-18  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (select-safe-coding-system):
	Fix typo in the comment.

	* language/european.el (compound-text):
	Force katakana-jisx0201 to be designated to G1.

	* international/mule-conf.el (oldjis-newjis-jisroman-ascii):
	Don't translate some national variant characters of latin-jisx0201.
	(x-ctext): Force katakana-jisx0201 to be designated to G1.

	* international/kkc.el (kkc-after-update-conversion-functions):
	New variable.
	(kkc-update-conversion): Run functions in it at the tail.

2000-07-16  John Wiegley  <johnw@gnu.org>

	* lisp/align.el (align-newline-and-indent):
	Adding new function.  for auto-aligning blocks of code on RET.
	(align-region): Fixed badly formatted minibuffer message.

2000-07-17  Kenichi Handa  <handa@etl.go.jp>

	* international/kkc.el (kkc-show-conversion-list-count): Customize it.
	(kkc-region): Update kkc-next-count and kkc-prev-count here.  Show
	the conversion list at first if appropriate.
	(kkc-next): Don't update kkc-next-count here.
	(kkc-prev): Don't update kkc-prev-count here.
	(kkc-show-conversion-list-update): Fix setting up of conversion
	list message.

2000-07-16  Stefan Monnier  <monnier@cs.yale.edu>

	* mouse.el (mouse-major-mode-menu-1): Get the submenu with lookup-key.

2000-07-16  Dave Love  <fx@gnu.org>

	* cus-edit.el (custom-buffer-create-internal): Use a help-echo
	function to be more specific.

	* wid-edit.el (widget-specify-field, widget-specify-button): Allow
	non-string help-echo.
	(widget-types-convert-widget): Defsubst it.
	(widget-echo-help): Try to cope with a help-echo function of two
	possible sorts.

2000-07-15  Jason Rumney  <jasonr@gnu.org>

	* w32-fns.el (w32-enable-italics, w32-charset-to-codepage-alist):
	Declare as obsolete.

	* term/w32-win.el: Make FONTNAME arg to set-fontset-font a cons.

2000-07-14  Gerd Moellmann  <gerd@gnu.org>

	* hilit-chg.el: Fix typo.

2000-07-14  Dave Love  <fx@gnu.org>

	* info.el (Info-mode-menu): Fix use of :help, :enable.

2000-07-14  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/easymenu.el (easy-menu-convert-item-1): Intern the label.

2000-07-13  Dave Love  <fx@gnu.org>

	* emacs-lisp/easymenu.el: Doc fixes.
	(easy-menu-remove): Defalias to ignore.

	* textmodes/reftex-cite.el (reftex-bibtex-selection-callback):
	Call throw correctly.

2000-07-13  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (frame-background-mode): Doc fix.

	* simple.el (eval-expression-print-length): Change custom type to
	allow entering nil as value.

2000-07-13  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el (fortran-imenu-generic-expression):
	Change definition layout.
	(fortran-mode-menu): Reinstate customize entries.

	* cus-edit.el (custom-group-menu-create, customize-menu-create):
	Use :filter, per old XEmacs code.

2000-07-12  Gerd Moellmann  <gerd@gnu.org>

	* term.el (term-send-raw-meta): Strip modifiers from the keyboard
	event when deciding what to send to the terminal.

2000-07-12  Dave Love  <fx@gnu.org>

	* cus-start.el: Add optional version as 4th element of specs and
	use it for several things new in v21.  Remove load-path.  Fix type
	of line-number-display-limit.

2000-07-11  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el: Don't require easymenu.
	Use repeat counts in various regexps.
	(fortran-mode-syntax-table): Defvar directly.
	(fortran-font-lock-keywords-1, fortran-font-lock-keywords-2)
	(fortran-font-lock-keywords-3, fortran-font-lock-syntactic-keywords):
	Use defvar, not defconst.
	(fortran-mode-map): Change locals in `let'.  Use `fortran-auto-fill'.
	(fortran-mode): Set fortran-comment-line-start-skip,
	fortran-comment-line-start-skip, dabbrev-case-fold-search.
	(fortran-comment-indent): Use defsubst.
	(fortran-indent-comment, fortran-indent-to-column, fortran-break-line):
	Use fortran-comment-indent, not fortran-comment-indent-function.
	(fortran-comment-region, fortran-electric-line-number): Simplify.
	(fortran-auto-fill): New function.
	(fortran-do-auto-fill): Deleted.
	(fortran-find-comment-start-skip):
	Check for non-null comment-start-skip.
	(fortran-auto-fill-mode, fortran-fill-statement):
	Use fortran-auto-fill.
	(fortran-fill): Use fortran-auto-fill.  Check for null
	comment-start-skip.  Simplify final clause and use end-of-line finally.

	* widget.el (widget-plist-member): New alias.

2000-07-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* eshell/esh-module.el (toplevel): Reference
	byte-compile-current-file only if it is bound.

2000-07-10  Gerd Moellmann  <gerd@gnu.org>

	* dired.el: Don't require `dired-aux'.

2000-07-10  Miles Bader  <miles@lsi.nec.co.jp>

	* dired-aux.el (dired-show-file-type): New function.
	* dired.el (dired-mode-map): Bind `w' to dired-show-file-type.
	(dired-show-file-type): Add autoload.

2000-07-10  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-diag.el (describe-font): Adjusted for the
	change of fontset-info.
	(print-fontset): Likewise.

2000-07-09  Stefan Monnier  <monnier@cs.yale.edu>

	* mouse.el (mouse-drag-region): Use functionp rather than fboundp.

2000-07-07  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el: Bind `[delete]' to delete-char.

	* dired.el (dired-find-alternate-file): New function.
	(dired-mode-map): Bind `a' to dired-find-alternate-file.
	(toplevel): Require dired-aux when compiling.
	(dired-buffers): Move defvar within file to avoid compiler warning.

	* info.el (Info-last-search): Variable removed.
	(Info-search-history): New variable.
	(Info-search): New Info-search-history.

	* battery.el, info-look.el: Change author's mail address.

2000-07-07  Jonathan I. Kamens  <jik@kamens.brookline.ma.us>

	* mail/rmail.el (rmail-clear-headers): Don't throw an error
	if rmail-ignored-headers is nil.
	(rmail-retry-failure): Bind rmail-ignored-headers and
	rmail-displayed-headers to nil.

2000-07-06  Gerd Moellmann  <gerd@gnu.org>

	* lpr.el (lpr-page-header-switches): Add `-h' switch.
	(print-region-1): Don't hard code `-h' here.

	* Makefile.in (TAGS-LISP): Don't use `$(lispsource)'.

2000-07-01  Francesco Potorti`  <pot@gnu.org>

	* rmail.el (mail-unsent-separator): Changed "the" to "\\w+", as
	exim can use "your message" instead of "the message".

2000-07-06  Stefan Monnier  <monnier@cs.yale.edu>

	* facemenu.el: Docstrings fixes.
	(facemenu-get-face): Don't use internal-find-face.
	(facemenu-iterate): Rename arg to match the docstring.

	* newcomment.el (uncomment-region): Be more careful when skipping
	backwards over `=' not to bump into BOBP.

2000-07-05  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-diff.el (ediff-wordify): Use syntax table.
	* ediff-init.el (ediff-has-face-support-p): Use
	ediff-color-display-p.
	(ediff-color-display-p): Use display-color-p, changed to defun
	from defsubst.
	Got rid of special cases for NeXT and OS/2.
	* ediff-wind.el (ediff-setup-control-frame): Set proper modeline
	face.

2000-07-05  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/lucid.el: Require CL.
	(copy-tree, remprop): Remove, it's provided by CL.
	(map-keymap): Define in terms of cl-map-keymap.
	(extent-property, set-extent-end-glyph): New functions.

	* emacs-lisp/cl-extra.el (cl-map-keymap): Handle char-tables.

2000-07-05  Gerd Moellmann  <gerd@gnu.org>

	* Makefile.in (DONTCOMPILE): Add comment that the name may
	not be changed without changing the make-dist script.

	* emacs-lisp/cl-extra.el (cl-old-mapc): Removed; don't defalias mapc.
	(cl-mapc): Use mapc instead of cl-old-mapc.

2000-07-05  Andrew Innes  <andrewi@gnu.org>

	* makefile.nt: Add support for `bootstrap' and related targets.

2000-07-05  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/easymenu.el (easy-menu-define): Docstring fix.
	(easy-menu-do-define): Use `menu-item' format.
	Handle case where easy-menu-create-menu returns a symbol.
	Manually call the potential top-level filter in the function binding.
	(easy-menu-filter-return): New arg NAME.
	Convert to a keymap if MENU is an XEmacs menu.
	(easy-menu-convert-item-1): New.  Extracted from easy-menu-do-add-item.
	(easy-menu-converted-items-table, easy-menu-convert-item):
	New var and fun to memoize easy-menu-convert-item-1.
	(easy-menu-do-add-item): Use it.
	(easy-menu-create-menu): Use easy-menu-convert-item.
	Wrap easy-menu-filter-return around any :filter specification.
	Don't convert the menu if a filter was specified.
	Tell easy-menu-make-symbol not to check for MENU being an expression.
	(easy-menu-make-symbol): New arg NOEXP.

2000-07-05  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/lisp-mode.el (eval-defun-2): Remove parameter
	EVAL-DEFUN-ARG-INTERNAL; always print to minibuffer.
	(eval-defun): If called with prefix arg, instrument code for
	Edebug.

	* emacs-lisp/edebug.el (edebug-eval-defun): Make doc string
	similar to that of eval-defun.

2000-07-04  Dave Love  <fx@gnu.org>

	* hl-line.el (hl-line-overlay): Make it permanent-local.

	* calendar/todo-mode.el: Replaced with a working version, based on
	revision 1.34 tidied up.

2000-07-03  Miles Bader  <miles@lsi.nec.co.jp>

	* paths.el (prune-directory-list): New function.
	(Info-default-directory-list): Rewritten to more methodically
	enumerate a big list of possible info directories (based on the
	list used by the standalone info reader).

	* info.el (info-initialize): Use prune-directory-list to remove
	non-existent directories from Info-directory-list.

	* paths.el (Info-default-directory-list): Try a list of possible
	info-directories instead of a single one.  Add the possible
	info directory "/usr/share/info".

	* woman.el (woman-man.conf-path): Explicitly include the debian
	man-db config file "/etc/manpath.config".
	(woman-parse-man.conf): Also handle MANDATORY_MANPATH entries, as
	are present in `manpath.config'.
	(woman-manpath): Include "/usr/share/man".

2000-07-03  Gerd Moellmann  <gerd@gnu.org>

	* frame.el (blink-cursor-mode): Don't hide cursor initially.

	* startup.el (command-line): Initialize blink-cursor based
	on window-system.

	* frame.el (blink-cursor): Default to nil if not running under
	a window-system.

	* faces.el (face-spec-set): Ignore invalid attributes like 20.x.
	(face-x-resources): Remove duplicate entry for :font.

	* textmodes/refer.el (refer-find-entry-internal): Use some-window
	instead of cycling through windows with next-window.

	* term/sup-mouse.el (sup-pos-to-window): Use some-window instead
	of cycling through windows with next-window.

	* term/bg-mouse.el (bg-window-from-x-y): Use some-window instead
	of cycling through windows with next-window.

	* emacs-lisp/edebug.el (edebug-window-live-p, edebug-window-list)
	(edebug-get-displayed-buffer-points): Use walk-windows/some-window
	instead of cycling through windows with next-window.

	* calendar/appt.el (appt-select-lowest-window): Use walk-windows
	instead of cycling through windows with next-window.

	* dabbrev.el (dabbrev--find-expansion): Use walk-windows instead
	of cycling through windows with next-window.

	* terminal.el (te-process-output): Use walk-windows instead of
	cycling through windows with next-window.

	* server.el (server-switch-buffer): Use some-window instead of
	cycling through windows with next-window.

	* window.el (some-window): New function.
	(walk-windows): Remove reference to walk-windows-start.

	* hilit19.el (hilit-lookup-face-create): Don't set face colors to nil.

2000-07-03  Richard Stallman  <rms@gnu.org>

	* window.el (walk-windows): Guarantee termination by keeping a list
	of all the windows already handled.

2000-06-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* mouse.el (mouse-show-mark, mouse-save-then-kill): Don't use
	window-system.

	* man.el (Man-notify-when-ready): Don't use window-system.  If
	Man-notify-method is newframe, and the display is not
	multi-frame, select the frame created for the man page.
	(Man-init-defvars): Doc fix.

2000-06-28  Gerd Moellmann  <gerd@gnu.org>

	* faces.el (region): Change background color for light background.

	* ediff-wind.el (ediff-setup-control-frame): Remove :box
	attribute from mode-line face of Ediff control frame.

	* replace.el (query-replace-map): Bind `e' like `E'.

2000-06-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el (menu-bar-edit-menu) <mark-whole-buffer>:
	Change name to "Select All".

	* dos-fns.el (convert-standard-filename): Fix last change.

2000-06-27  Gerd Moellmann  <gerd@gnu.org>

	* help.el (describe-variable): Don't insert a second `'s' in front
	of the string `value is shown below'.  Since the syntax-table is
	set to emacs-lisp-mode-syntax-table, forward-sexp skips over
	an existing `'s', so that this won't be deleted.

	* pcmpl-cvs.el, pcmpl-gnu.el, pcmpl-linux.el, pcmpl-rpm.el:
	* pcmpl-unix.el: New files.

2000-06-26  Stefan Monnier  <monnier@cs.yale.edu>

	* wid-edit.el (widget-member): Use the new plist-member.

2000-06-26  Gerd Moellmann  <gerd@gnu.org>

	* replace.el (perform-replace): Undo change of 2000-04-04.
	Instead, move backward 1 character at the end of the loop when
	necessary.

	* faces.el (fringe): Change face for different backgrounds.

	* eshell/esh-module.el (toplevel): Load defgroup's differently;
	patch from John.

	* eshell/*.el: Change spelling of the Free Software Foundation.

	* eshell/esh-toggle.el: Removed.

	* Makefile.in (DONTCOMPILE): Add eshell/esh-group.el.

	* menu-bar.el (menu-bar-tools-menu): Call read-mail-command
	interactively.

2000-06-26  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-interactive-mode-map): Use `kbd' in calls to
	`define-key'; instead of checking `(emacs-version)' check for
	`set-keymap-parent' and `set-keymap-name' directly.  Add entries
	for `;' and `o' which might be electric.

	(sql-electric-stuff): New user option.
	(sql-magic-go): New function which uses `sql-electric-stuff'.
	(sql-magic-semicolon): New function which uses
	`sql-electric-stuff'.

	(sql-accumulate-and-indent): Insert newline if `comint-accumulate'
	is not fboundp.

	(sql-oracle-options): New variable.
	(sql-oracle): Use it.

	(sql-imenu-generic-expression): Doc change.
	(sql-find-sqli-buffer): Make sure the default-value of sql-buffer
	is used.

	(sql-informix): Added command line parameter "-" to force
	sql-informix-program to use stdout.

2000-06-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/codepage.el (cp-coding-system-for-codepage-1): Doc fix.
	(cp864-decode-table): Doc fix.
	(cp720-decode-table): New variable, supports the Arabic OEM
	codepage used by Windows.
	(cp737-decode-table): New, Greek OEM codepage used by Windows.

2000-06-23  Dave Love  <fx@gnu.org>

	* font-lock.el (font-lock-support-mode) <defgroup>: Add :version.
	(font-lock-fontify-anchored-keywords): Use
	line-beginning-position.
	(global-font-lock-mode): Use mapc.

2000-06-23  Stefan Monnier  <monnier@cs.yale.edu>

	* eshell/esh-module.el: Require CL when compiling.

2000-06-23  Gerd Moellmann  <gerd@gnu.org>

	* comint.el (comint-substitute-in-file-name): Call replace-match
	with second and third arg t.

	* cus-edit.el (custom-button-face, custom-button-pressed-face):
	Specify foreground color.

	* faces.el (tool-bar, mode-line, header-line): Specify foreground
	color.

	* Makefile.in (DONTCOMPILE): Add eshell/esh-maint.el.

	* eshell/esh-cmd.el (eshell-rewrite-for-command): Use cdr and
	cddr instead of cdddr.

	* eshell/esh-util.el (eshell-sublist): Use eshell-copy-list
	instead of copy-list.

	* eshell/esh-mode.el (eshell-mode): Use eshell-copy-list instead
	of copy-list.

	* subdirs.el: Add eshell subdirectory.

	* eshell: New subdirectory containing the Eshell package.

	* pcomplete.el: New file.

2000-06-23  Paul Eggert  <eggert@twinsun.com>

	* mail/mailpost.el (post-mail-send-it): Make sure file has
	proper permissions from birth.

	* files.el (basic-save-buffer-2): When temporarily setting
	file modes, set them to current modes plus 0200, not to 0777.

	* emerge.el (emerge-make-temp-file): Make sure file has proper
	permissions from birth.

2000-06-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (make-backup-file-name-1): On DOS/Windows, run the
	backup file name through convert-standard-filename.

	* dos-fns.el (convert-standard-filename): Convert leading
	directories as well.  When long file names are supported, convert
	characters that are invalid in Windows file names.

2000-06-22  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Fix bug: if ^L is the very first buffer character,
	ps-print crashes.  New feature: page selection for printing.  Create
	raw-text-unix coding system for XEmacs.  Doc fix.
	(ps-print-version): New version number (5.2.3).
	(ps-plot-region): Bug fix.
	(ps-setup, ps-init-output-queue, ps-output, ps-begin-job, ps-end-file)
	(ps-header-sheet, ps-generate, ps-end-job): Code fix.
	(ps-restore-selected-pages, ps-selected-pages, ps-print-page-p): New
	funs.
	(ps-selected-pages, ps-last-selected-pages, ps-first-page)
	(ps-last-page): New vars.

2000-06-21  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/sh-script.el (sh-while-getopts): Fix handling of
	empty option string.

2000-06-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* man.el (man): Doc fix.

2000-06-21  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-cmds.el (set-language-info-alist): Docstring
	fixed.

2000-06-20  Gerd Moellmann  <gerd@gnu.org>

	* version.el (emacs-version): Use ISO date format.

	* emulation/pc-select.el (pc-selection-mode): Bind `M-\d'
	instead of `M-backspace'.

	* simple.el (turn-off-auto-fill): New function.

2000-06-20  Stefan Monnier  <monnier@cs.yale.edu>

	* jit-lock.el (with-buffer-prepared-for-jit-lock):
	Renamed from with-buffer-prepared-for-font-lock and use
	inhibit-modification-hooks rather than setting *-change-functions.
	Update all functions to use the new name.
	(jit-lock-first-unfontify-pos): New semantics (and doc).
	(jit-lock-mode): Make non-interactive.
	Don't automatically turn on font-lock.
	Set jit-lock-first-unfontify-pos to indicate deferred-contextual mode.
	Always use jit-lock-after-change.
	Remove and restore font-lock-after-change-function.
	(turn-on-jit-lock, jit-lock-after-fontify-buffer)
	(jit-lock-after-unfontify-buffer): Remove.
	(jit-lock-stealth-fontify):
	Reset jit-lock-first-unfontify-pos to point-max rather than to nil.
	(jit-lock-after-change): Set the `fontified' text-prop to nil.

2000-06-20  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/cl-indent.el (toplevel): Indent
	`print-unreadable-object' properly.  Untabify.

2000-06-14  Carsten Dominik  <dominik@strw.leidenuniv.nl>

	* textmodes/reftex.el (reftex-find-citation-regexp-format):
	Support for bibentry.
	(reftex-compile-variables): Fixed problem with end of section-re.

	* texmodes/reftex-dcr.el (reftex-view-crossref,
	reftex-view-crossref-from-bibtex):
	Deal with changed `reftex-find-citation-regexp-format'.
	(reftex-view-regexp-match, reftex-view-crossref-from-bibtex):
	Replaced `remprop' with `put'.
	(reftex-view-crossref, reftex-view-crossref-when-idle):
	Support for bibentry.

	* textmodes/reftex-vars.el (reftex-cite-format-builtin):
	New entry for bibentry package.

	* textmodes/reftex-parse.el (reftex-locate-bibliography-files):
	Regexp also matches "\nobibliography".

	* textmodes/reftex-global.el (reftex-renumber-simple-labels):
	Call `reftex-ensure-write-access' before doing anything.
	(reftex-ensure-write-access): New function.

2000-06-14  Carsten Dominik  <dominik@strw.leidenuniv.nl>

	* progmodes/idlwave.el: File re-installed (update to version 4.2)

	* progmodes/idlw-shell.el: File re-installed (update to version 4.2)

	* progmodes/idlw-rinfo.el: File re-installed (update to version 4.2)

	* progmodes/idlw-toolbar.el: File re-installed (update to version 4.2)


2000-06-20  Dave Love  <fx@gnu.org>

	* faces.el (frame-background-mode): Use set-default, not set, in
	setter.
	(frame-update-faces, frame-update-face-colors): Define with
	defalias.

	* enriched.el (enriched-decode-foreground)
	(enriched-decode-background): Don't use internal-find-face.

	* apropos.el: Doc fixes.

	* cus-edit.el (customize-changed-options): Check arg.
	(customize-version-lessp): Don't require decimal point.

	* custom.el (defcustom, defgroup): Doc fix.

	* newcomment.el (comment) <defgroup>: Add :version.
	(comment-multi-line): Doc fix.

	* emulation/mlsupport.el (define-hooked-local-abbrev,
	define-hooked-global-abbrev): Fix, using define-abbrev.

2000-06-19  Gerd Moellmann  <gerd@gnu.org>

	* menu-bar.el (menu-bar-edit-menu): Add menu item for marking
	the whole buffer.

2000-06-19  Dave Love  <fx@gnu.org>

	* menu-bar.el (menu-bar-options-save): New function.
	(menu-bar-options-menu): Use it.
	(menu-bar-options-menu) <toggle-global-lazy-font-lock-mode>:
	Simplify.

2000-06-19  Andreas Schwab  <schwab@suse.de>

	* progmodes/etags.el (tags-query-replace): Put new parameters
	START and END at the end, for backward compatibility.

2000-06-19  Kenichi Handa  <handa@etl.go.jp>

	* international/codepage.el:
	(cp-coding-system-for-codepage-1): Delete special codes for
	generating xxx-dos coding system because now a CCL based coding
	system can handle EOL conversion by default.

	* international/mule.el (make-coding-system): Generate subsidiary
	coding systems for EOL handling variants even for a CCL based
	coding system.

2000-06-19  Kenichi Handa  <handa@etl.go.jp>

	* international/isearch-x.el (isearch-minibuffer-input-method)
	(isearch-minibuffer-input-method-function): These variables
	deleted.
	(isearch-with-input-method): Don't use the above variables.
	(isearch-process-search-multibyte-characters): Likewise.  Call
	read-string with the arg INHERIT-INPUT-METHOD t.

2000-06-17  Stefan Monnier  <monnier@cs.yale.edu>

	* font-lock.el (font-lock-after-fontify-buffer)
	(font-lock-after-unfontify-buffer): No need to call back to jit-lock.

	* jit-lock.el (jit-lock-mode): Force jit-refontify when turned on.
	Use consistent make-local-variable style for font-lock-fontified.
	(jit-lock-fontify-buffer):
	Don't bother checking for font-lock-mode and jit-lock-mode.

	* time.el: Remove trailing ^M that prevent CVS-merging.

2000-06-16  Gerd Moellmann  <gerd@gnu.org>

	* Makefile.in (distclean): New target.

2000-06-16  Stefan Monnier  <monnier@cs.yale.edu>

	* Makefile.in (srcdir): Define for update-subdirs.

2000-06-16  Gerd Moellmann  <gerd@gnu.org>

	* find-lisp.el: New file.

2000-06-16  Andrew Innes  <andrewi@gnu.org>

	* time.el (display-time-mail-function): New variable, to allow
	external packages to indicate when new mail is available.
	(display-time-update): Use it.

2000-06-16  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (mule-version): Change version name to
	SAKAKI.  AOI has already been used by Meadow.

	* international/quail.el (quail-show-guidance-buf): To find the
	bottom window (but minibuffer), pay attention to the height of
	minibuffer.

2000-06-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* arc-mode.el (archive-mode-map): Use the new menu-item format for
	menu-bar menus.  Add help strings.  Don't remove the Edit menu
	from the menu bar, as the menu bar has enough space now.

	* Makefile.in (SHELL): Make sure /bin/sh is used.

	* woman.el (woman-man-buffer): Fix bold and underlined CJK
	characters, which use series of two ^H characters instead of one.

2000-06-15  Gerd Moellmann  <gerd@gnu.org>

	* info.el (Info-find-in-tag-table-1, Info-find-in-tag-table)
	(Info-find-node-in-buffer-1, Info-find-node-in-buffer): New
	functions.
	(Info-find-node-2): Try a case-sensitive search first, then
	do a case-insensitive search.

	* menu-bar.el (menu-bar-help-menu): Add menu item for non-English
	tutorials.

	* complete.el (PC-env-vars-alist): New variable.
	(PC-complete-as-file-name): New function.
	(partial-completion-mode): Initialize PC-env-vars-alist from
	process-environment.
	(PC-do-completion): Handle completion of env vars.

	* info.el (Info-set-mode-line): Show file name in mode line,
	use `*Info*' instead of `Info:'.

	* startup.el (command-line-1): Change copyright messages to year
	2000.

2000-06-15  Dave Love  <fx@gnu.org>

	* net/goto-addr.el (goto-address-fontify): Use keymap property,
	not local-map.

2000-06-15  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (set-buffer-file-coding-system): Almost
	rewritten to handle `undecided' as no-op.

2000-06-14  Gerd Moellmann  <gerd@gnu.org>

	* Makefile.in: New file.

	* Makefile: Removed.

	* net/goto-addr.el (goto-address): Don't bind C-c RET locally.
	(goto-address-highlight-keymap): Bind C-c RET.

2000-06-14  Kenichi Handa  <handa@etl.go.jp>

	* mail/sendmail.el (sendmail-send-it): The temporary buffer
	inherits buffer-file-coding-system of the current buffer.

	* tar-mode.el (tar-extract): For goto-char, use (point-min), not
	0.  Give correct argument to set-auto-coding-function.
	(tar-expunge): For goto-char, use (point-min), not 0.
	(tar-clear-modification-flags): For goto-char, use (point-min), not 1.
	(tar-subfile-save-buffer): Likewize.

	* international/mule.el
	(after-insert-file-set-buffer-file-coding-system): Call
	set-buffer-file-coding-system with the arg FORCE t.

2000-06-13  Gerd Moellmann  <gerd@gnu.org>

	* mail/sendmail.el (mail-specify-envelope-from): Initialize to
	nil.  Contemporary sendmails issue an X-Authentication-Warning if
	the sender is set with `-f'.

2000-06-13  Dave Love  <fx@gnu.org>

	* help.el (describe-function-1): Kluge around cases of functions
	fset to subrs whose doc doesn't match their symbol-name.

	* image.el (insert-image): Default STRING to a space.

	* info.el Doc fixes.
	(Info-build-node-completions): Match Ref tags.

2000-06-13  Eli Zaretskii <eliz@is.elta.co.il>

	* frame.el (display-multi-frame-p, display-multi-font-p): New
	defaliases for display-graphic-p.

	* hl-line.el: Fixed a typo in commentary.

2000-06-13  Kenichi Handa  <handa@etl.go.jp>

	* language/tibet-util.el (tibetan-tibetan-to-transcription): Typo
	fixed.

2000-06-12  Dave Love  <fx@gnu.org>

	* image.el (insert-image): Save a little consing.

2000-06-12  Kenichi Handa  <handa@etl.go.jp>

	* language/tibet-util.el: Convert all tibetan-1-column characters
	to the corresponding tibetan characters.
	(tibetan-add-components): Delete code for the special treatment of
	'a chung.

	* language/tibetan.el (tibetan-composable-pattern): Fix previous
	change.
	(tibetan-vowel-transcription-alist): More rules added.
	(tibetan-composite-vowel-alist): New variable.
	(tibetan-precomposition-rule-alist): More rules added.

2000-06-12  Stefan Monnier  <monnier@cs.yale.edu>

	* startup.el (command-line): Only call menu-bar-mode if interactive.

	* thingatpt.el (toplevel symbol-properties):
	* textmodes/makeinfo.el (makeinfo-compile):
	* progmodes/make-mode.el (makefile-pickup-filenames-as-targets):
	* progmodes/hideif.el (hif-compress-define-list)
	(hide-ifdef-use-define-alist):
	* net/ange-ftp.el (ange-ftp-vms-delete-file-entry)
	(ange-ftp-vms-add-file-entry):
	* menu-bar.el (menu-bar-update-buffers, menu-bar-update-buffers):
	* man.el (Man-build-man-command):
	* mail/rnewspost.el (news-reply-header-hook):
	* info.el (Info-insert-dir):
	* emulation/mlconvert.el (backward-word, forward-word, setq):
	* emacs-lisp/gulp.el (gulp-send-requests):
	* emacs-lisp/byte-opt.el (byte-compile-log-lap-1)
	(byte-optimize-inline-handler, byte-optimize-form-code-walker)
	(byte-optimize-apply, end of file):
	* emacs-lisp/advice.el (ad-advice-class-completion-table)
	(ad-make-freeze-definition):
	* startup.el (command-line, command-line-1): Don't quote lambdas.

	* pcvs.el (cvs-parse-process): Don't blindly refresh all cookies.
	(cvs-cleanup-removed): New function.
	(cvs-cleanup-functions): New var.
	(cvs-cleanup-collection): Use cvs-cleanup-functions to allow the user
	some flexibility in specifying additional entries to auto-cleanup.
	(cvs-quickdir): New function.
	(cvs-mode-insert): Use cvs-fileinfo-from-entries.
	(cvs-mode-imerge): Use smerge-ediff rather than vc-resolve-conflicts.
	(cvs-mode-find-file): Check that we are on a filename or dirname
	when invoked through a mouse-click.
	(cvs-full-path): Remove.
	(cvs-dired-action): Re-introduced.
	(cvs-dired-noselect): Use it.
	(vc-post-command-functions): use this new hook if available.

	* pcvs-info.el (cvs-fi-up-to-date-face, cvs-fi-unknown-face): New vars.
	(cvs-status-map): Don't inherit from cvs-mode-map anymore.
	(cvs-filename-map, cvs-dirname-map): Remove.
	(cvs-default-action): Remove.
	(cvs-add-face): Use `keymap' rather than `local-map' property, and only
	if the arg is really a keymap.
	(cvs-fileinfo-pp): Don't use any special map for file and dir names.
	Don't hardcode the mapping from state (aka type) to face, but check
	the var cvs-fi-<type>-face instead.
	(cvs-fileinfo-from-entries): New function.

	* pcvs-defs.el (cvs-default-ignore-marks, cvs-diff-ignore-marks):
	Docstring fix.
	(cvs-find-file-and-jump): Change default to be safer.
	(cvs-mode-diff-map): Define it as a function as well.
	(cvs-mode-map): Refer to the function variant of cvs-mode-diff-map.
	Bind mouse-2 in this global map rather than with text-properties.

	* pcvs-parse.el (cvs-parse-table): Look for conflict markers in the
	file to resolve the ambiguity between C(conflict) and C(need-merge).

2000-06-12  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (set-buffer-file-coding-system): If
	CODING-SYSTEM is nil, set buffer-file-coding-system to nil
	unconditionally.

2000-06-12  Dave Love  <fx@gnu.org>

	* wid-edit.el (widget-specify-button): Really suppress the face if
	required.

2000-06-11  Gerd Moellmann  <gerd@gnu.org>

	* term/x-win.el (x-colors): Add colors from recent rgb.txt.

2000-06-11  Stefan Monnier  <monnier@cs.yale.edu>

	* imenu.el (imenu-generic-expression): Docstring fix.

	* composite.el (composition-function-table): Move the `put'
	below the autoload cookie so we can load the file before loaddefs.

	* avoid.el (mouse-avoidance-random-shape): Don't quote lambda.

	* emacs-lisp/autoload.el (make-autoload): Use `cond'.
	Handle easy-mmode-define-global-mode.
	For complex macros like define-minor-mode that can generate
	several autoload entries, try to autoload entries in the
	macroexpanded code.

	* emacs-lisp/easy-mmode.el (define-minor-mode):
	If KEYMAP is a symbol, just use it.
	Use byte-compile-current-file and load-file-name to infer the
	proper :require to pass to defcustom.
	Wrap the hook var into `progn' so as not to autoload it.
	Add a :autoload-end cookie.
	Be more careful about the evaluation of KEYMAP.
	(easy-mmode-define-global-mode): Add a :autoload-end cookie.
	(define-derived-mode): Move define-abbrev-table outside of defvar.

2000-06-10  Stefan Monnier  <monnier@cs.yale.edu>

	* Makefile (EMACSOPT): Remove --no-init-file (implied by -batch).
	(autoloads): Explicitly load `autoload' to bootstrap without loaddefs.
	(backup-compiled-files): Ignore errors during `tar'.
	(bootstrap): Make autoloads before elc files.

2000-06-10  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (set-buffer-file-coding-system): If one of
	undecided-XXX is specified, change only EOL conversion.

	* international/mule-conf.el (unix): New alias for the coding
	system undecided-unix.

2000-06-09  Dave Love  <fx@gnu.org>

	* tar-mode.el (tar-copy): Supply MUSTBENEW arg to write-region.

	* progmodes/executable.el: Byte compile dynamic.
	(executable-insert): Change custom type.
	(executable-find): Add autoload cookie.
	(executable-make-buffer-file-executable-if-script-p): New
	function.  After Noah Friedman.

	* files.el (after-save-hook): Customize, with
	executable-make-buffer-file-executable-if-script-p as an option.

2000-06-09  Kenichi Handa  <handa@etl.go.jp>

	* ps-mule.el (ps-mule-font-info-database-bdf): Prefer the font
	"tib24p-mule.bdf" for Tibetan.

	* composite.el (decompose-composite-char): Declare it as obsolete.

	* man.el (Man-fontify-manpage): Pay attention to underline and
	overstrike pattern for CJK characters (e.g. __^H^H and X^H^HX).

2000-06-08  Gerd Moellmann  <gerd@gnu.org>

	* thingatpt.el (forward-thing): Use functionp instead of fboundp.
	Set maintainer to FSF since author isn't reachable.

2000-06-08  Dave Love  <fx@gnu.org>

	* international/mule-cmds.el (select-safe-coding-system): If
	DEFAULT-CODING-SYSTEM is not specified, also check the most
	preferred coding-system if buffer-file-coding-system is
	`undecided'.  From Handa.

2000-06-08  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el
	(after-insert-file-set-buffer-file-coding-system): If the buffer
	size is greater than INSERTED, judget that we are not visiting.

2000-06-07  Rajesh Vaidheeswarran  <rv@gnu.org>

	* whitespace.el (defgroup whitespace): Comment out `:version'.
	XEmacs 20.4 has problems defining the group with this present.
	We'll have this commented out till get resolve the problem.

2000-06-07  Gerd Moellmann  <gerd@gnu.org>

	* align.el: Update from author.

2000-06-07  Jari Aalto  <jari.aalto@poboxes.com>

	* apropos.el (apropos-mode-hook): New user variable.
	(apropos-mode): Run apropos-mode-hook.

2000-06-07  David Ponce  <david@dponce.com>

	* recentf.el: Fixed recentf-edit-list and recentf-open-more-files
	commands.  Require `wid-edit' at run-time.

2000-06-07  David Ponce  <david@dponce.com>

	* recentf.el: Added some "Commentary".
	(recentf-open-more-files, recentf-edit-list): Minor changes to
	move the point at the top of the file list.  This behaviour is
	consistent with the menu one when the list contains a lot of
	files.
	(recentf-cleanup): Now displays the number of items removed from
	the list.
	(recentf-relative-filter) New menu filter to show filenames
	relative to `default-directory'.

2000-06-07  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: XEmacs compatibility.  Doc fix.  Can select page size
	with/without giving an error if PostScript printer doesn't have this
	kind of page size.  Zebra Stripe continues or restarts on next page.
	Manual/automatic paper feeding.  Switch or not the header.
	(ps-print-version): New version number (5.2.2).
	(ps-windows-system): Include emx as a Windows system.
	(ps-setup, ps-begin-file, ps-color-values, ps-screen-to-bit-face)
	(ps-generate-postscript-with-faces, ps-generate-postscript-with-faces)
	(ps-background-text): Code fix.
	(ps-error-handler-message, ps-user-defined-prologue)
	(ps-print-prologue-header, ps-printer-name)
	(ps-print-control-characters, ps-n-up-filling, ps-zebra-color)
	(ps-line-number-step, ps-spool-config, ps-default-fg, ps-default-bg)
	(ps-use-face-background): Customization fix.
	(ps-n-up-database): Data fix.
	(ps-warn-paper-type, ps-zebra-stripe-follow, ps-manual-feed)
	(ps-switch-header): New vars.
	(ps-xemacs-color-name, ps-face-foreground-name)
	(ps-face-background-name, ps-boolean-constant): New funs.

2000-06-07  Dave Love  <fx@gnu.org>

	* allout.el: New version from Manheimer.

2000-06-07  Kenichi Handa  <handa@etl.go.jp>

	* textmodes/fill.el (fill-find-break-point): Check the validity of
	charset.

2000-05-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* bookmark.el (bookmark-insert-location, bookmark-bmenu-list)
	(bookmark-bmenu-show-filenames, bookmark-bmenu-hide-filenames):
	Call display-color-p and display-mouse-p instead of looking at
	window-system.

2000-06-06  Dave Love  <fx@gnu.org>

	* image.el (find-image): Doc fix.  Return nil if image not found.
	(put-image, insert-image): Make STRING arg optional.

2000-06-06  Kenichi Handa  <handa@etl.go.jp>

	* language/vietnamese.el: Remove eval-when-compile.
	(viet-viscii-nonascii-translation-table): Define it as a
	translation table made from viet-viscii-decode-table.
	(viet-viscii-encode-table): Define it as a translation table made
	from the reverse map of above.
	(viet-vscii-nonascii-translation-table): Define it as a
	translation table made from viet-vscii-decode-table.
	(viet-vscii-encode-table): Define it as a translation table made
	from the reverse map of above.
	(ccl-decode-viscii): Use translate-character.
	(ccl-encode-viscii, ccl-encode-viscii-font)
	(ccl-decode-vscii, ccl-encode-vscii, ccl-encode-vscii-font):
	Likewize.

	* language/cyrillic.el: Remove eval-when-compile.
	(cyrillic-koi8-r-nonascii-translation-table): Define it as a
	translation table made from cyrillic-koi8-r-decode-table.
	(cyrillic-koi8-r-encode-table): Define it as a translation table
	made from the reverse map of above.
	(ccl-decode-koi8): Use translate-character.
	(ccl-encode-koi8, ccl-encode-koi8-font): Likewize
	(cyrillic-alternativnyj-nonascii-translation-table): Define it as
	a translation table made from cyrillic-alternativnyj-decode-table.
	(cyrillic-alternativnyj-encode-table): Define it as a translation
	table made from the reverse map of above.
	(ccl-decode-alternativnyj): Use translate-character.
	(ccl-encode-alternativnyj, ccl-encode-alternativnyj-font):
	Likewize

	* international/mule-diag.el (non-iso-charset-alist): Specify
	translation table symbol instead of translation table itself.
	(list-block-of-chars): CHARSET may be a translation table symbol.

	* international/mule.el (make-coding-system): If CODING-SYSTEM
	already exists, override it.

	* international/fontset.el: Use family `proportional' for Tibetan
	fonts.

	* international/ccl.el (ccl-compile-translate-character): Don't
	check if Rrr has property translation-table.
	(ccl-compile-map-multiple): Modified to avoid compiler warning.

2000-06-05  Gerd Moellmann  <gerd@gnu.org>

	* info.el: Bind case-fold-search to t when searching in case
	a user sets it to nil in a hook.

2000-06-05  Stefan Monnier  <monnier@cs.yale.edu>

	* autoarg.el (autoarg-mode, autoarg-kp-mode):
	* hl-line.el (hl-line-mode): Use the new :global key argument.

	* tar-mode.el (tar-header-block-recompute-checksum): Remove.
	(tar-clip-time-string): Prepend a space.
	(tar-grind-file-mode): Construct a string rather than modifying one.
	(tar-header-block-summarize): Fix docstring.
	Use `format' rather than an error-prone set of copy-loops.

	* diff-mode.el (diff-font-lock-keywords, diff-hunk-header-re)
	(diff-goto-source, diff-unified->context, diff-context->unified)
	(diff-reverse-direction, diff-fixup-modifs): Fix the regexps to
	understand the format output by the `-p' argument to diff.

	* progmodes/sh-script.el (sh-symbol-list, sh-number-or-symbol-list)
	(sh-re-done): Use defconst.
	(sh-indent-supported-here, sh-electric-rparen-needed-here): Add defvar.
	(sh-help-string-for-variable, sh-guess-basic-offset):
	Don't quote lambdas.
	(sh-electric-rparen, sh-electric-hash, sh-search-word): Docstring typo.
	(sh-regexp-for-done, sh-kw-alist, sh-kw): Moved to before their use.

	* mail/mh-comp.el (mh-send-sub): Check mh-etc is bound before using it.
	(mh-letter-mode): Derive from text-mode.
	This implicitly means that it now calls kill-all-local-variables.
	Also remove the Emacs-18 compatibility code.

	* emacs-lisp/autoload.el (make-autoload): Simplify docstring.
	Make use of symbol-property doc-string-elt.
	Use memq rather than a sequence of eq.
	(doc-string-elt): Fix the wrong or missing previously unused values.
	(autoload-print-form): New function extracted from
	generate-file-autoloads to allow recursion when handling progn
	so that defvar's and defun's docstrings are properly printed.
	(generate-file-autoloads): Use it.

	* emacs-lisp/easy-mmode.el (easy-mmode-define-global-mode): Autoload.
	Use find-file-hooks in the minor-mode function.
	Be careful not to loop indefinitely in the post-command-hook function.

2000-06-05  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-init.el (ediff-has-face-support-p): Make it paint faces on
	tty's.
	* ediff-diff.el (ediff-exec-process): Use --binary for fine
	differences whenever appropriate.
	* viper-cmd.el (viper-smart-suffix-list): Rearranged list members.
	* viper.el (find-file, find-file-other-window): Get viper to do
	wildcards.

2000-06-04  Stefan Monnier  <monnier@cs.yale.edu>

	* jit-lock.el (jit-lock-saved-fontify-buffer-function): New var.
	(jit-lock-fontify-buffer): New function for JIT refontification.
	(jit-lock-mode): Fix docstring.
	Use jit-lock-fontify-buffer for font-lock-fontify-buffer-function.
	Remove jit-lock-after-change from the _local_ hook.
	(jit-lock-function-1): Fix docstring.

	* info.el (Info-on-current-buffer): Initialize info.

	* newcomment.el (comment-indent): Ignore comment-indent-hook.

	* progmodes/tcl.el (tcl-indent-for-comment):
	Ignore comment-indent-hook.

	* emacs-lisp/easy-mmode.el: Require CL during compilation.
	(easy-mmode-define-toggle): Remove (inline into define-minor-mode).
	(easy-mmode-pretty-mode-name): Rename from easy-mmode-derive-name
	and improve to use the lighter to guess the capitalization.
	(define-minor-mode): Inline code from easy-mmode-define-toggle.
	Add keyword arguments to specify global-ness or the custom group.
	Add local-map and help-echo properties to the lighter.
	(easy-mmode-define-navigation): Add the errors to debug-ignored-errors.
	(easy-mmode-define-global-mode): New macro.

2000-06-02  Dave Love  <fx@gnu.org>

	* wid-edit.el: byte-compile-dynamic since we typically don't use
	all the widgets.  Don't require cl or widget.  Remove
	eval-and-compile.  Don't autoload finder-commentary.  Doc fixes.
	(widget-read-event): Removed.  Callers changed to use read-event.
	(widget-button-release-event-p): Renamed from
	button-release-event-p.
	(widget-field-add-space, widget-field-use-before-change):
	Uncustomize.
	(widget-specify-field): Use keymap property, not local-map.
	(widget-specify-button): Obey :suppress-face.
	(widget-specify-insert): Use modern backquote syntax.
	(widget-image-directory): Renamed from widget-glyph-directory.
	(widget-image-enable): Renamed from widget-glyph-enable.
	(widget-image-find): Replaces widget-glyph-find.
	(widget-button-pressed-face): Move defvar.
	(widget-image-insert): Replaces widget-glyph-insert.
	(widget-convert): Use keywordp.
	(widget-leave-text, widget-children-value-delete): Use mapc.
	(widget-keymap): Remove XEmacs stuff.
	(widget-field-keymap, widget-text-keymap): Define all inside defvar.
	(widget-button-click): Don't set point at the click, but re-centre
	if we scroll out of window.  Rewritten for images v. glyphs &c.
	(widget-tabable-at): Use POS arg, not point.
	(widget-beginning-of-line, widget-end-of-line)
	(widget-item-value-create, widget-sublist, widget-princ-to-string)
	(widget-sexp-prompt-value, widget-echo-help): Simplify.
	(widget-default-create): Use widget-image-insert; some rewriting.
	(widget-visibility-value-create)
	(widget-push-button-value-create, widget-toggle-value-create): Use
	widget-image-insert.
	(checkbox): Create on and off images dynamically.
	(documentation-link): Change :help-echo.
	(widget-documentation-link-echo-help): Remove.

2000-06-02  Stefan Monnier  <monnier@cs.yale.edu>

	* log-edit.el (log-edit-done): Thinko in the "same comment" detection.

	* emacs-lisp/easy-mmode.el (easy-mmode-derive-name): New function.
	(easy-mmode-define-toggle, define-minor-mode): Use it.
	(easy-mmode-define-keymap): Docstring fix.
	(define-derived-mode): Default PARENT to fundamental-mode.
	Add the derived-mode-parent symbol-property.
	(easy-mmode-derived-mode-p): New function.

2000-06-02  Dave Love  <fx@gnu.org>

	* files.el (convert-standard-filename): Doc fix.
	(normal-backup-enable-predicate): New function.
	(backup-enable-predicate): Use it to replace the lambda form.

	* calendar/todo-mode.el: [This needs more work on the outline
	stuff.]  Doc fixes.
	(todo) <defgroup>: Add :version.
	(todo-add-category): Don't use pushnew.
	(todo-cmd-raise): Fix typo.
	(todo-top-priorities): Change temp buffer name.
	(todo-category-alist): Avoid redundant lambda.
	(todo-mode): Set paragraph-separate, outline-regexp from todo-prefix.
	Use outline-next-heading.

	* autoarg.el: Rewritten to use define-minor-mode.
	(autoarg-kp-digits, autoarg-kp-mode-map): New variable.
	(autoarg-kp-mode, autoarg-kp-digit-argument): New command.

2000-06-02  Kenichi Handa  <handa@etl.go.jp>

	* isearch.el (isearch-other-meta-char): Fix previous change.

2000-06-01  Stefan Monnier  <monnier@cs.yale.edu>

	* log-edit.el (log-edit-mode): Make vc-comment-ring-index local.
	(log-edit-done): Only add the comment to the ring if it's different
	from the last comment entered.

	* isearch.el (isearch-highlight): Turn internal-find-face into facep.

2000-06-01  Dave Love  <fx@gnu.org>

	* hl-line.el: Rewritten using define-minor-mode.

	* help.el (describe-function-1): Distinguish special form from
	builtin function.  Sanity-check presence of arglist for builtins.

2000-06-01  Kenichi Handa  <handa@etl.go.jp>

	* international/characters.el: Fix syntax/category setting of
	Tibetan characters.

	* language/tibet-util.el (tibetan-add-components): Fixes for new
	encoding of Tibetan characters.
	(tibetan-decompose-precomposition-alist): New variable.
	(tibetan-decompose-region): Convert precomposed characters to
	non-precomposed characters.
	(tibetan-decompose-string): Likewise.
	(tibetan-composition-function): Fix args to
	thibetan-compose-string.

	* language/tibetan.el (tibetan-composable-pattern): More
	characters included.
	(tibetan-consonant-transcription-alist): Rule for "R" added.
	(tibetan-subjoined-transcription-alist): Rules for "+W", "+Y", and
	"+R" added.
	(tibetan-base-to-subjoined-alist): Rule for "RA" added.

	* language/lao-util.el (lao-composition-function): Fix args to
	compose-string.

	* language/thai-util.el (thai-composition-function): Fix args to
	compose-string.

	* isearch.el (isearch-update): Set disable-point-adjustment to t
	to prevent the point moving to the end of a composition when a
	part of a composition is searched.
	(isearch-other-meta-char): If the key invoking this command can be
	mapped by function-key-map to a printing char, call
	isearch-process-search-char directly.

2000-06-01  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/bytecomp.el:
	* frame.el:
	* international/mule-cmds.el:
	* international/mule-util.el:
	* international/mule.el:
	* mouse.el:
	* subr.el:
	* faces.el: Update calls to make-obsolete with a WHEN argument.

	* byte-run.el (make-obsolete, make-obsolete-variable):
	Add an optional WHEN argument and change the format of the
	symbol-property information.
	* emacs-lisp/bytecomp.el (byte-compile-log): Don't quote lambda.
	(byte-compile-obsolete, byte-compile-variable-ref): Understand the
	new obsolete-symbol-property format and print WHEN if it is provided.

2000-05-31  Dave Love  <fx@gnu.org>

	* loadhist.el (loadhist-hook-functions): Remove
	before-change-function, after-change-function.
	(unload-feature): Deal with symbols which are both bound and
	fbound.

	* mouse.el (mouse-save-then-kill-delete-region): Don't bind
	before-change-function, after-change-function.

	* simple.el (newline): Don't bind before-change-function,
	after-change-function.

2000-05-31  Rajesh Vaidheeswarran <rv@gnu.org>

	* whitespace.el (whitespace-rescan-timer-time): Update interval
	set to 600 seconds (10 minutes) instead of 60 seconds since
	a large number of whitespace buffers causes emacs to `freeze'
	for a considerable amount of time.

	* whitespace.el: Updated email address

2000-05-31  Dave Love  <fx@gnu.org>

	* add-log.el (change-log-font-lock-keywords) <function>: Add
	pattern for function of change.
	(change-log-font-lock-keywords) <acknowledgements>: Amalgamate
	acknowledgements patterns.

2000-05-31  Kenichi Handa  <handa@etl.go.jp>

	* isearch.el (isearch-printing-char): If keyboard coding system is
	being used, call isearch-process-search-multibyte-characters.

	* international/isearch-x.el: Mostly rewritten.

	* international/quail.el (quail-start-conversion): Don't include
	unhandled events in the returned events, but set them in
	unread-command-events.  Exit if all inputs are deleted.

2000-05-30  Jason Rumney  <jasonr@gnu.org>

	* w32-fns.el (w32-charset-info-alist): Add each charset separately.

	* term/w32-win.el: Doc changes to reduce diffs with x-win.el.
	Reenable code to create initial fontsets.
	Use set-fontset-font in place of put-charset-property.

2000-05-30  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/perl-mode.el (perl-indent-line): When looking for a
	label, ensure that the first colon isn't followed by another.

	* paths.el (Info-default-directory-list): Doc fix.

	* net/net-utils.el (finger-X.500-host-regexps): New user-option.
	(finger): If HOST matches a regexp from finger-X.500-host-regexps,
	send a query containing USER only, not USER@HOST.

	* mail/rmail.el (rmail-widen-to-current-msgbeg): Use rmail-msgbeg
	and rmail-msgend to compute the restriction at the end, instead of
	computing it.

2000-05-29  Gerd Moellmann  <gerd@gnu.org>

	* dabbrev.el (dabbrev-expand): Don't display messages in the
	echo area if the minibuffer window is active.

	* jit-lock.el (jit-lock-mode): Add after change function to
	local hook.

2000-05-29  Christoph Wedler  <Christoph.Wedler@sap.com>

	* antlr-mode.el: New commands: hide/unhide actions,
	upcase/downcase literals.
	(antlr-tiny-action-length): New user option.
	(antlr-hide-actions): New command.  Suggested by
	Bjoern Mielenhausen <Bjoern.Mielenhausen@sap.com>.
	(antlr-mode-map): New binding [C-c C-v].
	(antlr-mode-menu): New entries.
	(antlr-downcase-literals): New command.
	(antlr-upcase-literals): Ditto.

	* antlr-mode.el: Minor changes: indendation, mode-name.
	(antlr-indent-line): Indent cpp directive at column 0.
	(antlr-mode): Use mode-name prefix "Antlr." instead of "Antlr/".

	* antlr-mode.el: XEmacs bug workaround, XEmacs hint.
	(antlr-font-lock-additional-keywords): Workaround for intentional
	bug in XEmacs version of font-lock.
	(antlr-mode): Set symbol property `mode-name' to "Antlr".  Could
	be used by a smarter version of `buffers-menu-grouping-function'.

2000-05-29  Gerd Moellmann  <gerd@gnu.org>

	* tmm.el (tmm-prompt): Recognize menu item definitions of the for
	`(menu-item ...)' when looking for the position of DEFAULT-ITEM.

2000-05-29  Kenichi Handa  <handa@etl.go.jp>

	* international/encoded-kb.el
	(encoded-kbd-iso2022-designation-map): Pay attention to that
	charset-iso-final-char return -1 for eight-bit-control and
	eight-bit-graphic.

2000-05-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* speedbar.el (speedbar-use-images, speedbar-update-flag)
	(speedbar-easymenu-definition-base): Use display-graphic-p where
	available, instead of window-system.

2000-05-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/codepage.el (cp-coding-system-for-codepage-1): Add
	eight-bit-graphic and eight-bit-control to safe charsets for cpNNN
	coding systems.

2000-05-26  Dave Love  <fx@gnu.org>

	* disp-table.el (standard-display-underline): Don't use
	internal-find-face.

	* mail/reporter.el: Maintainer change.  Doc fixes.
	(reporter-version): Deleted.

	* emacs-lisp/elp.el: Maintainer change.
	(elp-help-address, elp-submit-bug-report, elp-version): Deleted.

2000-05-26  Stefan Monnier  <monnier@cs.yale.edu>

	* add-log.el (add-change-log-entry): Merge the current entry with the
	previous one if the previous one is empty.

2000-05-26  Dave Love  <fx@gnu.org>

	* loadhist.el (unload-feature): Fix interactive spec [from
	lijnzaad@ebi.ac.uk].

	* emacs-lisp/bytecomp.el (byte-compile-callargs-warn): Use
	subr-arity to check primitives.
	(byte-compile-flush-pending, byte-compile-file-form-progn)
	(byte-compile-normal-call, byte-compile-list, byte-compile-concat)
	(byte-compile-insert, byte-compile-funcall): Use mapc instead of
	mapcar.

2000-05-26  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el: Set family names of non-latin charsets
	in default fontset to "*".

	* international/mule-diag.el (print-fontset): Combine family part
	and registry part of the fontname by "-*-" instead of "-".

	* international/mule-cmds.el (encode-coding-char): Make strings
	multibyte before calling encode-coding-string.

2000-05-25  Stefan Monnier  <monnier@cs.yale.edu>

	* derived.el: Fix keywords.
	(define-derived-mode): Only define if needed.

	* simple.el (fill-comment, comment-column, comment-start)
	(comment-start-skip, comment-end, comment-indent-function)
	(block-comment-start, block-comment-end, indent-for-comment)
	(set-comment-column, kill-comment, comment-padding, comment-region)
	(comment-multi-line, indent-new-comment-line): Remove.

	* bindings.el (esc-map): Change ; to comment-dwim and use the new
	function names for comment operations.

	* newcomment.el: Add abundant autoload cookies.
	(comment-style): Don't depend on runtime data at compile-time.
	(comment-indent-hook): Remove.
	(comment-indent): Check if comment-indent-hook is bound.
	(comment-region): Docstring fix.

2000-05-25  Dave Love  <fx@gnu.org>

	* emacs-lisp/elp.el (elp-restore-function): Don't use obsolete
	byte-code-function-p.

	* mail/rmailsum.el: Add provide.

	* net/goto-addr.el (goto-address-fontify): Add help-echo property.

	* smerge-mode.el (smerge-diff-switches): Don't use list* in
	defcustom.

2000-05-25  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-diff.el (ediff-exec-process): delete --binary option from
	non-buffer ediff jobs.

2000-05-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* hilit-chg.el (highlight-changes-mode): Ask about color or
	grayscale support, not about window-system.

	* ffap.el (ffap-menu-text-plist): Use display-mouse-p, not
	window-system.
	(ffap-highlight): Always default to t.

	* emacs-lisp/edebug.el (edebug-emacs-19-specific): Call
	display-popup-menus-p instead of looking at window-system.

	* disp-table.el (standard-display-g1, standard-display-graphic):
	Only refuse to use string glyphs on X and MS-Windows.

	* avoid.el: Remove window-system from commentary, suggest to use
	display-*-p instead.

	* apropos.el (apropos-print): Use display-mouse-p instead of
	window-system.

2000-05-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/codepage.el (cp-decoding-vector-for-codepage):
	Fill up unsupported characters with their own codes.  From Kenichi
	Handa.

2000-05-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule-diag.el (describe-char-after): Use
	display-graphic-p instead of window-system, so that this function
	works on MS-DOS.

2000-05-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/codepage.el (cp-make-coding-systems-for-codepage):
	Remove the eight-bit-graphic and eight-bit-control charsets from
	the list of charsets which we convert into `?'.

2000-05-25  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-conf.el: Specify CHARSET-ID explicitely for
	private charsets.
	(mule-unicode-0100-24ff, japanese-jisx0213-1,
	japanese-jisx0213-2): New charsets.

	* international/fontset.el: Setup default fontset for new charsets.

2000-05-24  Dave Love  <fx@gnu.org>

	* info.el (Info-find-node-2): Restructure [following "Vadim
	S. Solomin" <sovs@uic.nnov.ru>].

	* icomplete.el: Fix header for Finder.

2000-05-24  Eric M. Ludlam  <zappo@ultranet.com>

	* rmailout.el (rmail-output-to-rmail-file): Added optional param
	STAY.

	* rmail.el (rmail-automatic-folder-directives): New user variable.
	(rmail-show-message): Add call to `rmail-auto-file' during
	display.
	(rmail-auto-file): New function.

2000-05-24  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-diff.el (ediff-forward-word): Take syntactic word class into
	account.
	(ediff-test-utility,ediff-diff-mandatory-option)
	(ediff-reset-diff-options): Utilities for proper initialization of
	ediff-diff-options and ediff-diff3-options on Windows.

	* ediff-init.el (ediff-merge-filename-prefix): New customizable
	variable.

	* ediff-mult.el (ediff-filegroup-action): Use
	ediff-merge-filename-prefix.

2000-05-24  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-ex.el (ex-write): Set selective display to nil.

2000-05-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* language/hebrew.el (iso-8859-8-e, iso-8859-8-i): For now, just
	aliases for hebrew-iso-8bit.

2000-05-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* woman.el: New version from Francis J. Wright
	<F.J.Wright@Maths.QMW.ac.uk>.
	(woman-parse-colon-path): Support Cygwin-style //d/foo/bar file
	names in environment variables regardless of the path separator.
	(woman-topic-all-completions-1): Don't call file-name-directory-p
	on all files, since woman-file-regexp already filters out any
	directories.

2000-05-24  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-start-translation): Don't change
	modified-p of the current buffer.
	(quail-start-conversion): Likewise.

	* international/kkc.el (kkc-region): Don't change modified-p of
	the current buffer.

	* language/japanese.el (iso-2022-jp): Exclude katakana-jisx0201 to
	conform to RFC1468.
	(iso-2022-jp-2): Exclude katakana-jisx0201 to conform to RFC1554.

2000-05-23  Eric M. Ludlam  <zappo@ballista.ultranet.com>

	* speedbar.el (speedbar-easymenu-definition-base): Image toggle fix.
	(speedbar-insert-button): Invisible text property fix.
	(speedbar-directory-plus): Renamed from speedbar-directory-+
	(speedbar-directory-minus): Renamed from speedbar-directory--
	(speedbar-page-plus): Renamed from speedbar-file-+
	(speedbar-page-minus): Renamed from speedbar-file--
	(speedbar-page): Renamed from speedbar-file-
	(speedbar-tag): Renamed from speedbar-tag-
	(speedbar-tag-plus): Renamed from speedbar-tag-+
	(speedbar-tag-minus): Renamed from speedbar-tag--
	(speedbar-expand-image-button-alist): Use above renames.

	* sb-dir-plus.xpm: Renamed from sb-dir+.xpm
	* sb-dir-minus.xpm: Renamed from sb-dir-.xpm
	* sb-pg-plus.xpm: Renamed from sb-file+.xpm
	* sb-pg-minus.xpm: Renamed from sb-file-.xpm
	* sb-pg.xpm: Renamed from sb-file.xpm
	* sb-tag-plus.xpm: Renamed from sb-tag+.xpm
	* sb-tag-minus.xpm: Renamed from sb-tag-.xpm

2000-05-24  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-show-guidance-buf): Set
	current-input-method of the guidance buffer to the name of the
	curren input method.

2000-05-23  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/compile.el (compile-internal): Style typo.

	* mail/mh-e.el (mh-do-not-confirm, mh-folder-mode):
	quote vars and functions in the docstring.

	* newcomment.el (comment-make-extra-lines): Don't use `assert'.

	* completion.el (dynamic-completion-mode, dynamic-completion-mode):
	Don't quote lambdas.

	* ffap.el (ffap-highlight): Use facep rather than internal-find-face.

2000-05-23  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (command-line): Determine source file of compiled
	user init file differently.  Warn if compiled user init file
	is older than its source file.

	* ffap.el (ffap-url-regexp): Add `https'.

2000-05-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (make-backup-file-name-1): Replace slashes with `!'
	rather than `|' (which is not allowed on Windows).  Replace the
	drive letters with a string "drive_X".

2000-05-23  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/sh-script.el (sh-ancestor-alist): Add `bash2'.

	* files.el (interpreter-mode-alist): Add `bash2'.

2000-05-22  Dave Love  <fx@gnu.org>

	* loadhist.el (feature-symbols, file-provides, file-requires): Use
	mapc.
	(feature-file): Avoid calling symbol-name.  Doc fix.
	(file-set-intersect, file-dependents): Use dolist, not mapcar.
	(loadhist-hook-functions): Add mouse-position-function.
	(unload-feature): Change uses of mapcar.

	* files.el (parse-colon-path): Doc fix.
	(auto-mode-alist, interpreter-mode-alist): Purecopy the cars.
	(set-auto-mode): Use mapc.

	* complete.el (PC-look-for-include-file): Use :alnum: character
	class.
	(partial-completion-mode): Add autoload cookie.

2000-05-22  Sam Steingold  <sds@gnu.org>

	* info.el (Info-fontify-node): Fixed the call to
	`add-text-properties' (bug introduced on 2000-05-18).

2000-05-22  Dave Love  <fx@gnu.org>

	* bindings.el: Remove debug-ignored-errors set in other files.

	* progmodes/etags.el: Add to debug-ignored-errors.
	(visit-tags-table-buffer): Clear out buffers holding old tables
	when making a new list.
	(etags-recognize-tags-table, tags-recognize-empty-tags-table): Use
	mapc.

	* completion.el: Doc fixes.  Add to debug-ignored-errors.  Don't
	quote keywords.
	(cmpl-string-case-type): Use character classes.

	* comint.el:
	* textmodes/ispell.el:
	* imenu.el:
	* mail/mh-e.el:
	* progmodes/compile.el: Add to debug-ignored-errors.

	* dabbrev.el: Add to debug-ignored-errors.
	(dabbrev-completion): Use mapc.

2000-05-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* woman.el (From Francis J. Wright <F.J.Wright@Maths.QMW.ac.uk)
	(woman-mapcan, woman-parse-man.conf)
	(woman-toggle-use-extended-font, woman-toggle-use-symbol-font)
	(woman-reset-emulation, woman-select-symbol-fonts): New functions.
	(woman-parse-colon-path): Call woman-mapcan.  Recognize Cygwin
	path syntax better.
	(woman-man.conf-path, woman-use-own-frame): New defcustoms.
	(woman-manpath): Call woman-parse-man.conf.
	(woman-emulation): New defcustom, defaults to nroff.
	(woman-font-support): New defconst.
	(woman-use-symbol-font): New defcustom.
	(woman-menu): Add new menu items: "Colored/BW", "Advanced",
	"Emulation".
	Many functions: Doc fix.

2000-05-22  Kenichi Handa  <handa@etl.go.jp>

	* international/quail.el (quail-simple-translation-keymap): Map
	128..255 to quail-self-insert-command.
	(quail-keyboard-layout-alist): Add definition for "pc102-de".

2000-05-22  Stefan Monnier  <monnier@cs.yale.edu>

	* help.el (help-manyarg-func-alist): Typo.

	* emacs-lisp/sregex.el: Rewritten to take advantage of shy-groups and
	intervals which makes it heaps simpler.

	* newcomment.el (comment-region-internal): Go back to BEG after quoting
	the nested comment markers.

	* subr.el (remove-hook): Don't turn the hook's value into a list.

2000-05-21  Dave Love  <fx@gnu.org>

	* edmacro.el (edmacro-parse-keys): Return vector if any elements
	are invalid characters.

	* international/mule-util.el (detect-coding-with-priority): Use
	mapc.  Remove redundant lambda.

	* international/mule-diag.el (list-non-iso-charset-chars)
	(describe-fontset): Remove redundant lambda.

	* emulation/crisp.el (brief-mode): New alias.

	* emacs-lisp/ring.el (ring-elements): New function.

	* emacs-lisp/easymenu.el (easy-menu-create-menu)
	(easy-menu-do-add-item): Use keywordp.

	* emacs-lisp/byte-opt.el: Update side-effect free function lists.

	* replace.el: Doc and error message fixes.
	(replace-highlight): Use facep, not internal-find-face.

2000-05-20  Stefan Monnier  <monnier@cs.yale.edu>

	* international/ccl.el (ccl-compile-map-multiple): Don't quote lambda.

	* log-edit.el (log-edit-done): Cleanup trailing empty lines.
	(log-edit-insert-changelog): Drop `:' as well.

	* log-view.el: Fix file description.
	(log-view-mode-map): Unsatisfying fix for when cvs-mode-map is not
	available.
	(log-view-font-lock-keywords): Only use cvs-filename-face if present.
	(log-view-current-file): Only use cvs-pcl-cvs-dirchange-re if present.

	* emacs-lisp/easy-mmode.el: Update copyright and commentary.
	(easy-mmode-define-toggle): Deprecate the use of *-(on|off)-hook.
	Print a status message if the toggle is called interactively.
	(define-minor-mode): Allow INIT-VALUE to be (global . INIT-VALUE)
	for global minor modes and use `defcustom' for them.
	Use add-minor-mode.
	(easy-mmode-define-derived-mode): Remove.
	(define-derived-mode): Fancier default docstring.
	(easy-mmode-define-navigation): Signal an error rather than (ding).

	* newcomment.el (comment-styles): New `box-multi'.
	(comment-normalize-vars): Better default for comment-continue to
	avoid whitespace-only continuations.
	(comment-search-forward): Always move even in the no-syntax case.
	(comment-padright): Only obey N if it's only obeyed for padleft.
	(comment-make-extra-lines): Better handling of empty continuations.
	Use `=' for the filler if comment-start has only one character.
	(uncomment-region): Try handling the special `=' filler.
	(comment-region): Allow LINES even if MULTI is nil.
	(comment-box): Choose box style based on comment-style.

2000-05-20  Kenichi Handa  <handa@etl.go.jp>

	* international/ccl.el (ccl-compile-write-string): Make STR unibyte.
	(ccl-compile-write-repeat): If ARG is string, make it unibyte.

2000-05-20  Kenichi HANDA  <handa@etl.go.jp>

	* mail/rmail.el (rmail-decode-quoted-printable): Use delete-region
	and insert, not subst-char-in-region.

	* international/mule-diag.el (list-character-sets-1): Handle
	charsets eight-bit-control and eight-bit-graphic.
	(list-iso-charset-chars): Likewise.
	(list-block-of-chars): If CHARSET is not chat-table, insert 8-bit
	charactes as is.  Use indent-to to align characters.

	* international/mule-cmds.el (find-multibyte-characters): Never
	exclude charsets eight-bit-control and eight-bit-graphic.

2000-05-19  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/ada-mode.el (ada-mode, ada-create-case-exception):
	Don't quote lambdas.

	* emacs-lisp/lisp-mode.el (lisp-mode-variables): Set comment-add.

2000-05-19  Gerd Moellmann  <gerd@gnu.org>

	* gud.el (gud-jdb-directories): Doc fix.

2000-05-19  Stefan Monnier  <monnier@cs.yale.edu>

	* newcomment.el: New file.

2000-05-19  Gerd Moellmann  <gerd@gnu.org>

	* files.el (auto-mode-alist): Add pattern for POSIX `.shrc'.

2000-05-18  Andreas Schwab  <schwab@suse.de>

	* dired.el (dired-between-files): Also skip lines beginning with
	`used'.

2000-05-18  Gerd Moellmann  <gerd@gnu.org>

	* msb.el (msb-menu-cond): Add choice `user'.

2000-05-18  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Compatibility, customization and doc fix.
	(ps-printer-name-option): Replace defconst by defvar.
	(ps-postscript-code-directory): XEmacs compatibility.
	(ps-header-sheet, ps-setup, ps-begin-file, ps-begin-job): Code
	fix.
	(ps-user-defined-prologue, ps-print-prologue-header)
	(ps-xemacs-face-kind-p, ps-face-bold-p, ps-face-italic-p): XEmacs
	compatibility and code fix.
	(ps-print-background-image, ps-print-background-text):
	Customization fix.
	(ps-line-number-start, ps-n-up-on): New vars.

2000-05-18  Espen Skoglund  <esk@ira.uka.de>

	* pascal.el (pascal-indent-alist, pascal-indent-comment): Changed
	the indent-comment function to just return the appropriate indent.

2000-05-18  Eric M. Ludlam  <zappo@ultranet.com>

	* sb-dir+.xpm, sb-dir-.xpm, sb-dir.xpm, sb-file+.xpm, sb-file-.xpm,
	sb-file.xpm, sb-mail.xpm, sb-tag+.xpm, sb-tag-.xpm, sb-tag-gt.xpm,
	sb-tag-type.xpm, sb-tag-v.xpm, sb-tag.xpm: New Files

2000-05-18  Dave Love  <fx@gnu.org>

	* info.el (Info-fontify-node): Add intangible property as well as
	invisible.

	* calendar/appt.el (appt-make-list): Match all lines of entry.
	From "Stefan M. Walther (SMW)" <walther@netz.klinik.uni-mainz.de>

2000-05-18  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-diag.el (describe-char-after): Call
	internal-char-font, not char-font.  If internal-char-font returns
	nil, display "-- none --".

2000-05-17  Eli Zaretskii  <eliz@is.elta.co.il>

	* image.el (image-type-available-p): Don't reference image-types
	if it isn't bound.

2000-05-17  Stefan Monnier  <monnier@cs.yale.edu>

	* autoarg.el (autoarg-mode): Typo in the :set argument.

2000-05-17  Eli Zaretskii  <eliz@is.elta.co.il>

	* startup.el (command-line-1): Don't signal an error if the
	directory for auto-save-list files does not yet exist.

2000-05-17  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-conf.el (arabic-iso8859-6): Fix typo.

2000-05-16  Stefan Monnier  <monnier@cs.yale.edu>

	* subr.el (remove-hook): `setq' hook-value, not `set'.

2000-05-16  Sam Steingold  <sds@gnu.org>

	* info.el (debug-ignored-errors): More errors to ignore.

2000-05-16  Dave Love  <fx@gnu.org>

	* cus-edit.el: Don't require cl or easymenu.
	(custom-variable-prompt): Test standard-value property, not
	user-variable-p.

2000-05-16  Sam Steingold  <sds@gnu.org>

	* subr.el (add-hook): `setq' hook-value, not `set'.

2000-05-16  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (command-line-1): Mention the FAQ in the startup
	message.

	* help.el (view-emacs-FAQ): Change `emacs-faq' to `efaq'.

	* progmodes/compile.el (compilation-parse-errors): Collect
	`nomessage' regexps last.

	* dired.el (dired-mode-map): Use dired-do-query-replace-regexp.

	* dired-aux.el (dired-do-query-replace-regexp): Add `-regexp'
	to the function name.

2000-05-15  Dave Love  <fx@gnu.org>

	* speedbar.el (speedbar-recenter): Typo.
	(speedbar-expand-line): Make arg optional.
	(speedbar-mode): Avoid a compiler warning.

2000-05-15  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/sh-script.el (sh-while-getopts) <sh>: Handle case that
	user-specified option string is empty.

	* mouse.el (mouse-yank-at-click): Doc fix.

2000-05-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/internal.el (IT-character-translations): More updates of
	latin-iso8859-14 and latin-iso8859-15 from the latest ISO/IEC
	documents.

2000-05-15  Gerd Moellmann  <gerd@gnu.org>

	* env.el (getenv): New function, interactively callable.
